patch_id deponi_cascade_delete_10032020

IF(OBJECT_ID('FK_DEPONI_ANALYSIS_PROGRAM_DEPONI', 'F') IS NOT NULL) 
	alter table deponi_analysis_program drop constraint FK_DEPONI_ANALYSIS_PROGRAM_DEPONI
go
	alter table deponi_analysis_program add constraint FK_DEPONI_ANALYSIS_PROGRAM_DEPONI foreign key (deponi_seq_no) 
	references deponi (deponi_seq_no) on delete cascade
go

IF(OBJECT_ID('FK_DEPONI_APP_PARAM_DEPONI_ANA_PROGRAM', 'F') IS NOT NULL) 
	alter table deponi_ap_parameter drop constraint FK_DEPONI_APP_PARAM_DEPONI_ANA_PROGRAM
go
	alter table deponi_ap_parameter add constraint FK_DEPONI_APP_PARAM_DEPONI_ANA_PROGRAM foreign key (dap_seq_no) 
	references deponi_analysis_program (dap_seq_no) on delete cascade
go

IF(OBJECT_ID('FK_DEPONI_AP_PARAM_STD00019', 'F') IS NOT NULL) 
	alter table deponi_ap_parameter drop constraint FK_DEPONI_AP_PARAM_STD00019
go
	alter table deponi_ap_parameter add constraint FK_DEPONI_AP_PARAM_STD00019 foreign key (parameter) 
	references std00019 (code) on delete cascade
go

IF(OBJECT_ID('fk_depdeadok_deadline', 'F') IS NOT NULL) 
	alter table deponi_deadline_ok drop constraint fk_depdeadok_deadline
go
	alter table deponi_deadline_ok add constraint fk_depdeadok_deadline foreign key (dapd_seq_no) 
	references deponi_sp_ap_deadline (dapd_seq_no) on delete cascade
go

IF(OBJECT_ID('fk_depdeadok_param', 'F') IS NOT NULL) 
	alter table deponi_deadline_ok drop constraint fk_depdeadok_param
go
	alter table deponi_deadline_ok add constraint fk_depdeadok_param foreign key (dapp_seq_no) 
	references deponi_ap_parameter (dapp_seq_no) --on delete cascade
go

IF(OBJECT_ID('FK_DEPONI_LEACHATE_DEPONI', 'F') IS NOT NULL) 
	alter table deponi_leachate drop constraint FK_DEPONI_LEACHATE_DEPONI
go
	alter table deponi_leachate add constraint FK_DEPONI_LEACHATE_DEPONI foreign key (deponi_seq_no) 
	references deponi (deponi_seq_no) on delete cascade
go

IF(OBJECT_ID('FK_DEPONI_MAX_VALUE_GSC_UNIT', 'F') IS NOT NULL) 
	alter table deponi_max_value drop constraint FK_DEPONI_MAX_VALUE_GSC_UNIT
go
	alter table deponi_max_value add constraint FK_DEPONI_MAX_VALUE_GSC_UNIT foreign key (unit) 
	references gsc_unit (code) on delete cascade
go

IF(OBJECT_ID('FK_DEPONI_MAX_VALUE_DEP_SAMP_PLAC', 'F') IS NOT NULL) 
	alter table deponi_max_value drop constraint FK_DEPONI_MAX_VALUE_DEP_SAMP_PLAC
go
	alter table deponi_max_value add constraint FK_DEPONI_MAX_VALUE_DEP_SAMP_PLAC foreign key (dsp_seq_no) 
	references deponi_sampling_place (dsp_seq_no) on delete cascade
go

IF(OBJECT_ID('FK_DEPONI_MAX_VALUE_STD00019', 'F') IS NOT NULL) 
	alter table deponi_max_value drop constraint FK_DEPONI_MAX_VALUE_STD00019
go
	alter table deponi_max_value add constraint FK_DEPONI_MAX_VALUE_STD00019 foreign key (parameter) 
	references std00019 (code) on delete cascade
go

IF(OBJECT_ID('fk_depmxvalok_samplplace', 'F') IS NOT NULL) 
	alter table deponi_max_value_ok drop constraint fk_depmxvalok_samplplace
go
	alter table deponi_max_value_ok add constraint fk_depmxvalok_samplplace foreign key (dsp_seq_no) 
	references deponi_sampling_place (dsp_seq_no)-- on delete cascade
go

IF(OBJECT_ID('FK_DEPONI_SAMP_PLACE_BOR_FILTER', 'F') IS NOT NULL) 
	alter table deponi_sampling_place drop constraint FK_DEPONI_SAMP_PLACE_BOR_FILTER
go
	alter table deponi_sampling_place add constraint FK_DEPONI_SAMP_PLACE_BOR_FILTER foreign key (filterid) 
	references bor_filter (filterid) on delete cascade
go

IF(OBJECT_ID('FK_DEPONI_SAMP_PLACE_SAMPLING_PLACE', 'F') IS NOT NULL) 
	alter table deponi_sampling_place drop constraint FK_DEPONI_SAMP_PLACE_SAMPLING_PLACE
go
	alter table deponi_sampling_place add constraint FK_DEPONI_SAMP_PLACE_SAMPLING_PLACE foreign key (place_seq_no) 
	references sampling_place (place_seq_no)-- on delete cascade
go

IF(OBJECT_ID('FK_DEPONI_SAMP_PLACE_DEPONI', 'F') IS NOT NULL) 
	alter table deponi_sampling_place drop constraint FK_DEPONI_SAMP_PLACE_DEPONI
go
	alter table deponi_sampling_place add constraint FK_DEPONI_SAMP_PLACE_DEPONI foreign key (deponi_seq_no) 
	references deponi (deponi_seq_no) on delete cascade
go

IF(OBJECT_ID('FK_DEPONI_SAMP_PLACE_AP_DEPONI_SAMP_PLACE', 'F') IS NOT NULL) 
	alter table deponi_sampling_place_ap drop constraint FK_DEPONI_SAMP_PLACE_AP_DEPONI_SAMP_PLACE
go
	alter table deponi_sampling_place_ap add constraint FK_DEPONI_SAMP_PLACE_AP_DEPONI_SAMP_PLACE foreign key (dsp_seq_no) 
	references deponi_sampling_place (dsp_seq_no) on delete cascade
go

IF(OBJECT_ID('FK_DEPONI_SAMP_PLACE_DEPONI_ANA_PROGRAM', 'F') IS NOT NULL) 
	alter table deponi_sampling_place_ap drop constraint FK_DEPONI_SAMP_PLACE_DEPONI_ANA_PROGRAM
go
	alter table deponi_sampling_place_ap add constraint FK_DEPONI_SAMP_PLACE_DEPONI_ANA_PROGRAM foreign key (dap_seq_no) 
	references deponi_analysis_program (dap_seq_no)-- on delete cascade
go

IF(OBJECT_ID('FK_DEPONI_SAMP_PLACE_AP_DEP_SAMP_PLAC', 'F') IS NOT NULL) 
	alter table deponi_sampling_place_ap drop constraint FK_DEPONI_SAMP_PLACE_AP_DEP_SAMP_PLAC
go
	alter table deponi_sampling_place_ap add constraint FK_DEPONI_SAMP_PLACE_AP_DEP_SAMP_PLAC foreign key (dsp_seq_no) 
	references deponi_sampling_place (dsp_seq_no) --on delete cascade
go

IF(OBJECT_ID('FK_DEPONI_AP_DEADLINE_DEPONI_SAMP_PLACE', 'F') IS NOT NULL) 
	alter table deponi_sp_ap_deadline drop constraint FK_DEPONI_AP_DEADLINE_DEPONI_SAMP_PLACE
go
	alter table deponi_sp_ap_deadline add constraint FK_DEPONI_AP_DEADLINE_DEPONI_SAMP_PLACE foreign key (dspa_seq_no) 
	references deponi_sampling_place_ap (dspa_seq_no) --on delete cascade
go

IF(OBJECT_ID('FK_DEPONI_SUB_UNIT_DEPONI_UNIT', 'F') IS NOT NULL) 
	alter table deponi_subunit drop constraint FK_DEPONI_SUB_UNIT_DEPONI_UNIT
go
	alter table deponi_subunit add constraint FK_DEPONI_SUB_UNIT_DEPONI_UNIT foreign key (unit_seq_no) 
	references deponi_unit (unit_seq_no) on delete cascade
go

IF(OBJECT_ID('FK_DEPONI_UNIT_DEPONI_UNIT_CLASSIFICATION', 'F') IS NOT NULL) 
	alter table deponi_unit drop constraint FK_DEPONI_UNIT_DEPONI_UNIT_CLASSIFICATION
go
	alter table deponi_unit add constraint FK_DEPONI_UNIT_DEPONI_UNIT_CLASSIFICATION foreign key (classification) 
	references deponi_unit_classification (classification) on delete cascade
go

IF(OBJECT_ID('FK_DEPONI_UNIT_DEPONI', 'F') IS NOT NULL) 
	alter table deponi_unit drop constraint FK_DEPONI_UNIT_DEPONI
go
	alter table deponi_unit add constraint FK_DEPONI_UNIT_DEPONI foreign key (deponi_seq_no) 
	references deponi (deponi_seq_no) on delete cascade
go

IF(OBJECT_ID('FK_DEPONI_UNIT_LEACHATE_DEPONI_UNIT', 'F') IS NOT NULL) 
	alter table deponi_unit_leachate drop constraint FK_DEPONI_UNIT_LEACHATE_DEPONI_UNIT
go
	alter table deponi_unit_leachate add constraint FK_DEPONI_UNIT_LEACHATE_DEPONI_UNIT foreign key (unit_seq_no) 
	references deponi_unit (unit_seq_no) on delete cascade
go

IF(OBJECT_ID('FK_DEPONI_UNIT_WST_CAP_DEPONI_UNIT', 'F') IS NOT NULL) 
	alter table deponi_unit_waste_capacity drop constraint FK_DEPONI_UNIT_WST_CAP_DEPONI_UNIT
go
	alter table deponi_unit_waste_capacity add constraint FK_DEPONI_UNIT_WST_CAP_DEPONI_UNIT foreign key (unit_seq_no) 
	references deponi_unit (unit_seq_no) on delete cascade
go
