patch_id kpv_view_08252020

if exists (select 1 FROM sys.views where name = 'view_wcat_kpv_budget')
	drop view view_wcat_kpv_budget
;

create view dbo.view_wcat_kpv_budget (
kpv_seq_no, kpr_seq_no, element_no, start_date, end_date, plusminus) 
as
select kpv.kpv_seq_no
	,kpr.kpr_seq_no
	,app.element_no
	,app.start_date
	,dateadd(ms,-3,isnull(adj.from_date,isnull(app.expire_date,cast('12/31/9999 23:59:59.997' as datetime)))) end_date
	,'' plusminus
from wcat_kpv kpv
left join wcat_kpv_kpr kpr on kpv.kpv_seq_no = kpr.kpv_seq_no
left join an_program_parameters app  on kpr.an_program_id = app.an_program_id
left join (select * from wcat_kpv_kpr_param_adjust where plusminus = '-') adj  on kpr.kpr_seq_no = adj.kpr_seq_no and app.element_no = adj.parameter_code
union
select kpv.kpv_seq_no
	,kpr.kpr_seq_no
	,app.element_no 
	,dateadd(ms,3,adj.to_date) start_date
	,isnull(app.expire_date,cast('12/31/9999 23:59:59.997' as datetime)) end_date
	,'' plusminus
from wcat_kpv kpv
left join wcat_kpv_kpr kpr on kpv.kpv_seq_no = kpr.kpv_seq_no
left join an_program_parameters app  on kpr.an_program_id = app.an_program_id
join (select * from wcat_kpv_kpr_param_adjust where plusminus = '-') adj  on kpr.kpr_seq_no = adj.kpr_seq_no and app.element_no = adj.parameter_code
union
select kpv.kpv_seq_no
	,kpr.kpr_seq_no
	,app.element_no 
	,adj.from_date start_date
	,isnull(adj.to_date,cast('12/31/9999 23:59:59.997' as datetime)) end_date
	,adj.plusminus
from wcat_kpv kpv
left join wcat_kpv_kpr kpr on kpv.kpv_seq_no = kpr.kpv_seq_no
left join an_program_parameters app  on kpr.an_program_id = app.an_program_id
join wcat_kpv_kpr_param_adjust adj  on kpr.kpr_seq_no = adj.kpr_seq_no and app.element_no = adj.parameter_code

union
select kpr.kpv_seq_no
 ,kpr.kpr_seq_no
 ,adj.parameter_code element_no
 ,adj.from_date start_date
 ,isnull(adj.to_date,cast('12/31/9999 23:59:59.997' as datetime)) end_date
 ,adj.plusminus
from wcat_kpv_kpr_param_adjust adj
left join wcat_kpv_kpr kpr on adj.kpr_seq_no = kpr.kpr_seq_no
where not exists (select 1 from an_program_parameters app where app.AN_PROGRAM_ID = kpr.an_program_id and app.ELEMENT_NO = adj.parameter_code and adj.plusminus='+')
;
grant select on dbo.view_wcat_kpv_budget to wcat_user;


if exists (select 1 FROM sys.views where name = 'view_wcat_kpv_faktisk')
	drop view view_wcat_kpv_faktisk
;

create view dbo.view_wcat_kpv_faktisk (
kpv_seq_no, kpr_seq_no, sample_seq_no, sample_date, element_no, attribute, amount, target_value, faktisk )
as
with sec as (
select kpv.kpv_seq_no 
	, wkk.an_program_id
	, wkk.kpr_seq_no 
	, wkks.sample_seq_no
	, wkks.level
	, ana.AMOUNT
	, ana.UNIT
	, ana.attribute
	, ana.element_no
	, 1 as sec
	, 0 as prim
from wcat_kpv kpv
	join wcat_kpv_kpr wkk on wkk.kpv_seq_no = kpv.kpv_seq_no
	join wcat_kpv_kpr_samples wkks on wkk.kpr_seq_no = wkks.kpr_seq_no
	join AN_PROGRAM_PARAMETERS app on app.AN_PROGRAM_ID = wkk.an_program_id
	join ANALYSIS ana on wkks.sample_seq_no = ana.SAMPLE_SEQ_NO and ana.ELEMENT_NO = app.ELEMENT_NO

where wkks.level = 'S' 
) 
, analysis_ps as (select * from sec
union
 select kpv.kpv_seq_no 
	, wkk.an_program_id
	, wkk.kpr_seq_no
	, wkks.sample_seq_no
	, wkks.level
	, ana.AMOUNT
	, ana.UNIT
	, ana.attribute
	, ana.element_no
	, sec.sec
	, app.prim
from wcat_kpv kpv
	join wcat_kpv_kpr wkk on wkk.kpv_seq_no = kpv.kpv_seq_no
	join wcat_kpv_kpr_samples wkks on wkk.kpr_seq_no = wkks.kpr_seq_no
	join ANALYSIS ana on wkks.sample_seq_no = ana.SAMPLE_SEQ_NO 
	left join sec on wkks.sample_seq_no = sec.sample_seq_no and ana.ELEMENT_NO = sec.ELEMENT_NO
	left join ( select *, 1 as prim from AN_PROGRAM_PARAMETERS) app on app.AN_PROGRAM_ID = wkk.an_program_id and ana.ELEMENT_NO = app.element_no

where wkks.level = 'P' and (app.prim = 1 or  (app.prim is null and sec.sec is null)) 
)
select kpr.kpv_seq_no
		,kps.kpr_seq_no
		,samples.sample_seq_no
		,samples.sample_date 
		,analysis.element_no
		,analysis.attribute
		,analysis.amount
		,ap.target_value
		,1 as faktisk
	from wcat_kpv_kpr kpr
	join wcat_kpv_kpr_samples kps on kpr.kpr_seq_no = kps.kpr_seq_no
	join samples  on kps.sample_seq_no = samples.sample_seq_no
	join analysis_ps analysis on samples.sample_seq_no = analysis.SAMPLE_SEQ_NO and analysis.kpr_seq_no = kpr.kpr_seq_no
	left join analysis_parameters ap on analysis.element_no = ap.element_no 
		and samples.sample_date between ap.start_date and isnull(ap.expire_date,cast('12/31/9999 23:59:59.997' as datetime)) 
;
grant select on dbo.view_wcat_kpv_faktisk to wcat_user;
