-- 09-12-2020 TRK
--
patch_id jup_1260_201209

--******************************************************************************
-- Nye jupiter tabeller                                               09-12-2020
--******************************************************************************

-- Jupiters Aktiv-Status kodeliste

create table dbo.jup_Aktivstatus (
    code                          varchar(6)      not null,
    longtext                      varchar(100)    null,
    shorttext                     varchar(100)    null,
    sortno                        integer         null,
    active                        varchar(1)      not null default '1',

    created                       datetime        null default current_timestamp,
    created_by                    varchar(6)      null default current_user,
    changed                       datetime        null,
    changed_by                    varchar(6)      null,
    constraint pk_jup_Aktivstatus primary key (code)
);
grant select on jup_Aktivstatus to public;
grant select, update, delete, insert on jup_Aktivstatus to sysmgr;

if (select col_length('jup_Aktivstatus','ge_visible')) is null
   alter table jup_Aktivstatus add ge_visible varchar(1) not null default '1';

-- Put data i tabellen

if (select 'x' from jup_Aktivstatus where code = '0') is null
   insert into jup_Aktivstatus (code, longtext, shorttext, sortno, active, created_by) values ('0', 'Ikke oplyst', null, 1, '1', 'geokon');

if (select 'x' from jup_Aktivstatus where code = '1') is null
   insert into jup_Aktivstatus (code, longtext, shorttext, sortno, active, created_by) values ('1', 'Aktiv', null, 2, '1', 'geokon');

if (select 'x' from jup_Aktivstatus where code = '2') is null
   insert into jup_Aktivstatus (code, longtext, shorttext, sortno, active, created_by) values ('2', 'Inaktiv', null, 3, '1', 'geokon');

if (select 'x' from jup_Aktivstatus where code = '99') is null
   insert into jup_Aktivstatus (code, longtext, shorttext, sortno, active, created_by) values ('99', 'Andet', null, 4, '1', 'geokon');

-- Sørg for, at deponi.active ikke er null

update deponi set
  active = '0'
where active is null;

-- Udvid deponi.active fra varchar(1) null til varchar(6) not null

alter table deponi
  alter column active varchar(6) not null;

-- deponi.active skal nu refererer til jup_Aktivstatus.code

drop_foreign_key on deponi jup_Aktivstatus;
alter table deponi
  add constraint fk_deponi_jup_Aktivstatus foreign key (active)
  references jup_Aktivstatus (code);

--******************************************************************************
-- Nye kolonner på tabellen jup_drwChemAnalysis                       10-12-2020
--******************************************************************************

if (select col_length('jup_drwChemAnalysis','accreditedindicator')) is null
   alter table jup_drwChemAnalysis add accreditedindicator varchar(4) null;

if (select col_length('jup_drwChemAnalysis','fractionationmethod')) is null
   alter table jup_drwChemAnalysis add fractionationmethod integer null;

if (select col_length('jup_drwChemAnalysis','analysisresultidentifier')) is null
   alter table jup_drwChemAnalysis add analysisresultidentifier varchar(500) null;

if (select col_length('jup_drwChemAnalysis','sortno')) is null
   alter table jup_drwChemAnalysis add sortno integer null;

if (select col_length('jup_drwChemAnalysis','guid')) is null
   alter table jup_drwChemAnalysis add guid varchar(500) null;

if (select col_length('jup_drwChemAnalysis','guidPltchemsample')) is null
   alter table jup_drwChemAnalysis add guidPltchemsample varchar(500) null;

--******************************************************************************
-- Nye kolonner på tabellen jup_grwChemAnalysis                       10-12-2020
--******************************************************************************

if (select col_length('jup_grwChemAnalysis','accreditedindicator')) is null
   alter table jup_grwChemAnalysis add accreditedindicator varchar(4) null;

if (select col_length('jup_grwChemAnalysis','fractionationmethod')) is null
   alter table jup_grwChemAnalysis add fractionationmethod integer null;

if (select col_length('jup_grwChemAnalysis','analysisresultidentifier')) is null
   alter table jup_grwChemAnalysis add analysisresultidentifier varchar(500) null;

if (select col_length('jup_grwChemAnalysis','sortno')) is null
   alter table jup_grwChemAnalysis add sortno integer null;

if (select col_length('jup_grwChemAnalysis','guid')) is null
   alter table jup_grwChemAnalysis add guid varchar(500) null;

if (select col_length('jup_grwChemAnalysis','guidGrwchemsample')) is null
   alter table jup_grwChemAnalysis add guidGrwchemsample varchar(500) null;

--******************************************************************************
-- Nye kolonner på tabellen analysis                                  10-12-2020
--******************************************************************************

if (select col_length('analysis','accredited_id')) is null
   alter table analysis add accredited_id varchar(4) null;

if (select col_length('analysis','abs_coeff')) is null
   alter table analysis add abs_coeff numeric(12,4) null;

--******************************************************************************