patch_id ki_task_product_legislation_03112020                          

/*==============================================================*/
/* Table: ki_task_product_legislation                           */
/*==============================================================*/
create table dbo.ki_task_product_legislation (
   prod_seq_no          numeric(9,0)         not null,
   legislation_code     varchar(6)           not null,
   group_id             varchar(6)           null,
   outcome_code         varchar(6)           null,
   comments             varchar(100)         null,
   created              datetime             null default getdate(),
   created_by           varchar(6)           null default user_name(),
   changed              datetime             null,
   changed_by           varchar(6)           null,
   constraint PK_KI_TASK_PRODUCT_LEGISLATION primary key (prod_seq_no, legislation_code)
)
go

alter table ki_task_product_legislation
   add constraint FK_KI_TASK_PRODUCT_LEG_KI_TASK_PRODUCT foreign key (prod_seq_no)
      references ki_task_product (prod_seq_no)
         on delete cascade
go

alter table ki_task_product_legislation
   add constraint FK_KI_TASK_PRODUCT_LEG_KI_LEG foreign key (legislation_code)
      references ki_legislation (code)
go

alter table ki_task_product_legislation
   add constraint FK_KI_TASK_PRODUCT_LEG_KI_OUTCOME foreign key (outcome_code)
      references ki_legislation_outcome (code)
go

grant insert, update, delete, select on ki_task_product_legislation to ki_user
go

grant select on ki_task_product_legislation to public
go