patch_id new_table_audittrail_08042021

if not exists (select 1 from sysobjects where name = 'audittrail' and type = 'U')
CREATE TABLE dbo.audittrail(
	id_audittrail int IDENTITY(1,1) NOT NULL,
	st_table varchar(50) NOT NULL,
	id_key int NOT NULL,
	st_logtype varchar(10) NOT NULL,
	st_logtext varchar(4000) NOT NULL,
	dt_logdatetime datetime NOT NULL default current_timestamp,
	st_userid varchar(6) NOT NULL default current_user,
	CONSTRAINT PK_audittrail PRIMARY KEY (id_audittrail ));


grant update,insert,delete,select on audittrail to public;
	

if not exists (select 1 from sysobjects where name = 'audittrail_header' and type = 'U')
CREATE TABLE dbo.audittrail_header(
	id_audittrail_header int IDENTITY(1,1) NOT NULL,
	st_table varchar(50) NOT NULL,
	st_header varchar(1000) NOT NULL,
	st_type varchar(50) NULL,
	nr_section int NULL,
	CONSTRAINT PK_audittrail_header PRIMARY KEY (id_audittrail_header ));


grant update,insert,delete,select on audittrail_header to public;


if  (select count(*) from dbo.audittrail_header where st_type = 'Dokument' ) = 0
INSERT audittrail_header ( st_table, st_header, st_type, nr_section)
VALUES ('document', '{Initialer}, {Reg.dato}, {OK}', 'Dokument',1);


IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'geokon.usp_get_audittrail_data') AND type in (N'P', N'PC'))
DROP PROCEDURE geokon.usp_get_audittrail_data;

create PROCEDURE geokon.usp_get_audittrail_data 
	(@table varchar(30),  @key int )
AS

BEGIN

DECLARE	@ix integer, @maxlng integer
	
DECLARE @tab TABLE (
	id_ident		integer	identity(1, 1)	NOT NULL, 
	id_key			integer			NULL, 
	dt_logdatetime	datetime		NOT NULL, 
	st_logtype		varchar(10)		NOT NULL, 
	st_userid		varchar(6)		NULL, 
	st_data			varchar(1000)	NOT NULL)

INSERT	@tab (id_key, dt_logdatetime, st_logtype, st_userid, st_data)
SELECT	id_key, dt_logdatetime, st_logtype, st_userid, Replace(st_logtext, '}', char(9)) st_data
  FROM	dbo.audittrail
 WHERE	st_table = @table
  AND	id_key = @key
  UNION ALL
SELECT	NULL, getdate(), 'Header', NULL, Replace(st_header, '}', char(9))
  FROM	dbo.audittrail_header AH
 WHERE	st_table = @table
 ORDER BY 2 DESC, 3 DESC


UPDATE	T1
   SET	st_logtype = 'Modified'
  FROM	@tab T1
		JOIN @tab T2 ON T1.id_ident = T2.id_ident - 1 AND T1.st_logtype = 'Inserted' AND T2.st_logtype = 'Deleted'

DELETE	T2
  FROM	@tab T1
		JOIN @tab T2 ON T1.id_ident = T2.id_ident - 1 AND T1.st_logtype = 'Modified' AND T2.st_logtype = 'Deleted'

SELECT	@ix = Max(charindex(char(9), st_data))
  FROM	@tab
  
WHILE @ix > 0
BEGIN
	UPDATE	@tab
	   SET	st_data = Left(st_data, charindex(char(9), st_data) - 1) + Space(@ix - charindex(char(9), st_data)) + '}' +
					  Substring(st_data, charindex(char(9), st_data) + 1, Len(st_data) - charindex(char(9), st_data) + 1)
	 WHERE	charindex(char(9), st_data) > 0

	SELECT	@ix = Max(charindex(char(9), st_data))
	  FROM	@tab
END

SELECT	@maxlng = Max(Len(Replace(st_data, '}, {', '} {')))
  FROM	@tab

SELECT	id_key, dt_logdatetime, st_logtype, st_userid, Replace(st_data, '}, {', '} {') st_data, @maxlng maxlng
  FROM	@tab

END;
 

grant execute on geokon.usp_get_audittrail_data to public;


if exists (SELECT * FROM sys.objects O WHERE O.name = N'tr_i_audittrail_document') 
DROP TRIGGER tr_i_audittrail_document;


Create TRIGGER dbo.tr_i_audittrail_document
ON dbo.csm_document AFTER INSERT 
AS 
BEGIN 
	
	SET NOCOUNT ON

	INSERT	audittrail (st_table, id_key, st_logtype, st_logtext, dt_logdatetime, st_userid ) 

	SELECT	'document', t1.doc_seq_no , 'Inserted', '{' + IsNull( T1.init,' ')  + '}' 
												+ ', {' + IsNull( CONVERT(VARCHAR,  T1.reg_date, 105), ' ') + '}'
												+ ', {' + IsNull( T1.cal, ' ') + '}',
												getDate(), T1.created_by
	from inserted T1 
	
	
End;


if exists (SELECT * FROM sys.objects O WHERE O.name = N'tr_u_audittrail_document') 
DROP TRIGGER tr_u_audittrail_document;



Create TRIGGER dbo.tr_u_audittrail_document
ON dbo.csm_document AFTER UPDATE 
AS 
BEGIN 
	
	SET NOCOUNT ON

	INSERT	audittrail (st_table, id_key, st_logtype, st_logtext, dt_logdatetime, st_userid ) 

	SELECT	'document', t1.doc_seq_no , 'Inserted', '{' + IsNull( T1.init,' ')  + '}' 
												+ ', {' + IsNull( CONVERT(VARCHAR,  T1.reg_date, 105), ' ') + '}'
												+ ', {' + IsNull( T1.cal, '') + '}',
												getDate(), T1.changed_by
	from inserted T1 
	join deleted t2 on t1.doc_seq_no = t2.doc_seq_no
	where (t1.init <> t2.init) or (t1.reg_date <> t2.reg_date) or (t1.cal <> t2.cal)
	union 
	SELECT	'document', t1.doc_seq_no , 'Deleted', '{' + IsNull( T1.init,'')  + '}' 
												+ ', {' + IsNull( CONVERT(VARCHAR,  T1.reg_date, 105), ' ') + '}'
												+ ', {' + IsNull( T1.cal, ' ') + '}',
												getDate(), T2.changed_by
	FROM deleted T1 
	join inserted t2 on t1.doc_seq_no = t2.doc_seq_no
	where (t1.init <> t2.init) or (t1.reg_date <> t2.reg_date) or (t1.cal <> t2.cal)
	
End;



