-- 13-04-2021 TRK

-- DMA tabeller - 12.8.0 - mss

patch_id dma_1280_210413

--******************************************************************************
-- Nye DMA kodelister                                                 13-04-2021
--******************************************************************************

create table dbo.dma_haandhaevelseVedroererAnlaegstype (
    Id                            varchar(50)     not null,
    Navn                          varchar(80)     not null,
    Beskrivelse                   varchar(4000)   null,
    Aktiv                         varchar(1)      null,
    created                       datetime        null default current_timestamp,
    created_by                    varchar(6)      null default current_user,
    changed                       datetime        null,
    changed_by                    varchar(6)      null,
    constraint pk_dma_haandhaevelseVedroererAnlaegstype primary key (Id)
);
grant select on dma_haandhaevelseVedroererAnlaegstype to public;
grant select,insert,update,delete on dma_haandhaevelseVedroererAnlaegstype to sysmgr;

-- Fyld data i tabellen hvis den er tom.
if not exists (select * from dma_haandhaevelseVedroererAnlaegstype)
  insert into dma_haandhaevelseVedroererAnlaegstype (Id, Navn, Beskrivelse, Aktiv, created_by) values ('HVA00001', 'Mellemstort fyringsanlg', 'Hndhvelsen vedrrer MCP-anlg', '1', 'geokon');


create table dbo.dma_haandhaevelseVedroererKrav (
    Id                            varchar(50)     not null,
    Navn                          varchar(80)     not null,
    Beskrivelse                   varchar(4000)   null,
    Aktiv                         varchar(1)      null,
    created                       datetime        null default current_timestamp,
    created_by                    varchar(6)      null default current_user,
    changed                       datetime        null,
    changed_by                    varchar(6)      null,
    constraint pk_dma_haandhaevelseVedroererKrav primary key (Id)
);
grant select on dma_haandhaevelseVedroererKrav to public;
grant select,insert,update,delete on dma_haandhaevelseVedroererKrav to sysmgr;

-- Fyld data i tabellen hvis den er tom.

if not exists (select * from dma_haandhaevelseVedroererKrav)
begin
   insert into dma_haandhaevelseVedroererKrav (Id, Navn, Beskrivelse, Aktiv, created_by) values ('HVK00001', 'NOx, SOx og stv (EU krav)', 'Hndhvelsen vedrrer NOx, SOx og stv (EU krav)', '1', 'geokon')
   insert into dma_haandhaevelseVedroererKrav (Id, Navn, Beskrivelse, Aktiv, created_by) values ('HVK00002', 'vrige (DK krav)', 'Hndhvelsen vedrrer vrige krav (DK krav)', '1', 'geokon')
end;

--******************************************************************************
-- Nye ind_enforce kolonner                                           13-04-2021
--******************************************************************************

if (select col_length('ind_enforce','plant_seq_no')) is null
   alter table ind_enforce add plant_seq_no numeric(9,0) null;

if (select col_length('ind_enforce','dma_vedroererAnlaegstype_id')) is null
   alter table ind_enforce add dma_vedroererAnlaegstype_id varchar(50) null;

if (select col_length('ind_enforce','dma_vedroererKrav_id')) is null
   alter table ind_enforce add dma_vedroererKrav_id varchar(50) null;

drop_foreign_key on ind_enforce ind_comb_plant;
alter table ind_enforce
  add constraint fk_ind_enforce_ind_comb_plant foreign key (plant_seq_no)
  references ind_comb_plant (plant_seq_no);

drop_foreign_key on ind_enforce dma_haandhaevelseVedroererAnlaegstype;
alter table ind_enforce
  add constraint fk_ind_enforce_dma_haandhaevelseVedroererAnlaegstype foreign key (dma_vedroererAnlaegstype_id)
  references dma_haandhaevelseVedroererAnlaegstype (Id);

drop_foreign_key on ind_enforce dma_haandhaevelseVedroererKrav;
alter table ind_enforce
  add constraint fk_ind_enforce_dma_haandhaevelseVedroererKrav foreign key (dma_vedroererKrav_id)
  references dma_haandhaevelseVedroererKrav (Id);

--******************************************************************************