patch_id cor_audittrail_12052021


if exists (SELECT * FROM sys.objects O WHERE O.name = N'tr_i_audittrail_document') 
DROP TRIGGER tr_i_audittrail_document;


Create TRIGGER dbo.tr_i_audittrail_document
ON dbo.csm_document AFTER INSERT 
AS 
BEGIN 
	
	SET NOCOUNT ON

	INSERT	audittrail (st_table, id_key, st_logtype, st_logtext, dt_logdatetime, st_userid ) 

	SELECT	'document', t1.doc_seq_no , 'Inserted', '{' + IsNull( T1.init,' ')  + '}' 
												+ ', {' + IsNull( CONVERT(VARCHAR,  T1.reg_date, 105), ' ') + '}'
												+ ', {' + IsNull( T1.cal, ' ') + '}',
												getDate(), IsNull(T1.created_by,'SYS')
	from inserted T1 
	
	
End;


if exists (SELECT * FROM sys.objects O WHERE O.name = N'tr_u_audittrail_document') 
DROP TRIGGER tr_u_audittrail_document;



Create TRIGGER dbo.tr_u_audittrail_document
ON dbo.csm_document AFTER UPDATE 
AS 
BEGIN 
	
	SET NOCOUNT ON

	INSERT	audittrail (st_table, id_key, st_logtype, st_logtext, dt_logdatetime, st_userid ) 

	SELECT	'document', t1.doc_seq_no , 'Inserted', '{' + IsNull( T1.init,' ')  + '}' 
												+ ', {' + IsNull( CONVERT(VARCHAR,  T1.reg_date, 105), ' ') + '}'
												+ ', {' + IsNull( T1.cal, '') + '}',
												getDate(), IsNull(T1.changed_by,'SYS')
	from inserted T1 
	join deleted t2 on t1.doc_seq_no = t2.doc_seq_no
	where (t1.init <> t2.init) or (t1.reg_date <> t2.reg_date) or (t1.cal <> t2.cal)
	union 
	SELECT	'document', t1.doc_seq_no , 'Deleted', '{' + IsNull( T1.init,'')  + '}' 
												+ ', {' + IsNull( CONVERT(VARCHAR,  T1.reg_date, 105), ' ') + '}'
												+ ', {' + IsNull( T1.cal, ' ') + '}',
												getDate(), IsNull(T2.changed_by,'SYS')
	FROM deleted T1 
	join inserted t2 on t1.doc_seq_no = t2.doc_seq_no
	where (t1.init <> t2.init) or (t1.reg_date <> t2.reg_date) or (t1.cal <> t2.cal)
	
End;



