-- 02-07-2021 TRK
--
patch_id jup_1285_210702

--******************************************************************************
-- Ny jupiter tabel                                                   02-07-2021
--******************************************************************************

-- Jupiters limitlist tabel

create table dbo.jup_limitlist (
    compoundno                    integer         not null,
    compoundgroup                 integer         null,
    to_commission                 varchar(1)      null,
    waterworks_min                numeric(12,4)   null,
    waterworks_max                numeric(12,4)   null,
    pipelinenetwork_min           numeric(12,4)   null,
    pipelinenetwork_max           numeric(12,4)   null,
    consumer_min                  numeric(12,4)   null,
    consumer_max                  numeric(12,4)   null,
    remark                        varchar(100)    null,
    compoundundergroup            integer         null,
    recommended_min               numeric(12,4)   null,
    recommended_max               numeric(12,4)   null,
    unit                          integer         null,

    created                       datetime        null default current_timestamp,
    created_by                    varchar(6)      null default current_user,
    changed                       datetime        null,
    changed_by                    varchar(6)      null,
    constraint pk_jup_limitlist primary key (compoundno)
);
grant select on jup_limitlist to public;
grant select, update, delete, insert on jup_limitlist to sysmgr;

--******************************************************************************
-- Nye kolonner i app_settings                                        08-07-2021
--******************************************************************************

if (select 'x' from app_settings where app_section = 'JUPITER' AND app_key = 'SubstanceLimitUpdateActivated') is null
   insert into app_settings (app_section, app_key, app_search, app_sort, app_user_section, app_user_key, app_descript, app_value)
   select 'JUPITER', 'SubstanceLimitUpdateActivated', 'D', 45, 'Jupiter integration', 'Opdatering af grnsevrdier - aktiveret', 'Angiver om Jupiter servicen automatisk skal opdatere grnsevrdier. Kan sttes til Ja eller Nej (Default er Nej)', 'Nej';

--******************************************************************************