-- 17-03-2021 TRK

-- DMA tabeller - 12.8.0 - mss

patch_id dma_1280_210317

--******************************************************************************
-- Nye DMA kodelister                                                 17-03-2021
--******************************************************************************

create table dbo.dma_afgoerelseBasistilstandsrapport (
    Id                            varchar(50)     not null,
    Navn                          varchar(80)     not null,
    Beskrivelse                   varchar(4000)   null,
    Aktiv                         varchar(1)      null,
    created                       datetime        null default current_timestamp,
    created_by                    varchar(6)      null default current_user,
    changed                       datetime        null,
    changed_by                    varchar(6)      null,
    constraint pk_dma_afgoerelseBasistilstandsrapport primary key (Id)
);
grant select on dma_afgoerelseBasistilstandsrapport to public;
grant select,insert,update,delete on dma_afgoerelseBasistilstandsrapport to sysmgr;


-- Fyld data i tabellen hvis den er tom.

if not exists (select * from dma_afgoerelseBasistilstandsrapport)
begin
    insert into dma_afgoerelseBasistilstandsrapport (Id, Navn, Beskrivelse, Aktiv, created_by) values ('ABT0000001', 'Rapport eksisterer', 'Basistilstandsrapport eksisterer', '1', 'geokon')
    insert into dma_afgoerelseBasistilstandsrapport (Id, Navn, Beskrivelse, Aktiv, created_by) values ('ABT0000002', 'Rapportkrav ikke afklaret eller rapport ikke udarbejdet', 'Rapportkrav ikke afklaret eller rapport ikke udarbejdet', '1', 'geokon')
    insert into dma_afgoerelseBasistilstandsrapport (Id, Navn, Beskrivelse, Aktiv, created_by) values ('ABT0000003', 'Rapport ikke krvet', 'Basistilstandsrapport er ikke krvet', '1', 'geokon')
end;


create table dbo.dma_afgoerelseBATAEL (
    Id                            varchar(50)     not null,
    Navn                          varchar(200)    not null,
    Beskrivelse                   varchar(4000)   null,
    Aktiv                         varchar(1)      null,
    created                       datetime        null default current_timestamp,
    created_by                    varchar(6)      null default current_user,
    changed                       datetime        null,
    changed_by                    varchar(6)      null,
    constraint pk_dma_afgoerelseBATAEL primary key (Id)
);
grant select on dma_afgoerelseBATAEL to public;
grant select,insert,update,delete on dma_afgoerelseBATAEL to sysmgr;


-- Fyld data i tabellen hvis den er tom.

if not exists (select * from dma_afgoerelseBATAEL)
begin
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000001', 'Production of Chlor-alkali - Cl2 - BAT13-I', '4, Chemical industry: 4,2 Production of inorganic chemicals, such as: (a) gases, such as ammonia, chlorine or hydrogen chloride, fluorine or hydrogen fluoride, carbon oxides, sulphur compounds, nitrogen oxides, hydrogen, sulphur dioxide, carbonyl chloride;(c) bases, such as ammonium hydroxide, potassium hydroxide, sodium hydroxide; Reducing free chlorine to water. The BAT-AEL emission level is 0,05 - 0,2 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000002', 'Production of Chlor-alkali - Cl2 - BAT8-I', '4, Chemical industry: 4,2 Production of inorganic chemicals, such as: (a) gases, such as ammonia, chlorine or hydrogen chloride, fluorine or hydrogen fluoride, carbon oxides, sulphur compounds, nitrogen oxides, hydrogen, sulphur dioxide, carbonyl chloride;(c) bases, such as ammonium hydroxide, potassium hydroxide, sodium hydroxide; Chlorine absorption unit; features (i)-(xv) (see list); Reducing chlorine and chlorine dioxide emissions to air. The BAT-AEL emission level is 0,2 - 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000003', 'Production of Cement, Lime and Magnesium Oxide - CO - BAT48', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (b) production of lime in kilns with a production capacity exceeding 50?tonnes per day; PFRK, OSK, LRK, PRK; Reducing carbon monoxide (CO) emissions to air. The BAT-AEL emission level is  < 500 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000004', 'Production of Cement, Lime and Magnesium Oxide - CO - BAT63', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (c) production of magnesium oxide in kilns with a production capacity exceeding 50?tonnes per day; Techniques (a)-(c) (see table); Reducing carbon monoxide (CO) emissions to air. The BAT-AEL emission level is < 50 - 1000 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000005', 'Production of Cement, Lime and Magnesium Oxide - Dust - BAT16', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (a) production of cement clinker in rotary kilns with a production capacity exceeding 500?tonnes per day or in other kilns with a production capacity exceeding 50?tonnes per day; Dry flue-gas cleaning with a filter (usually fabric filter); Reducing dust emissions to air. The BAT-AEL emission level is  < 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000006', 'Production of Cement, Lime and Magnesium Oxide - Dust - BAT17', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (a) production of cement clinker in rotary kilns with a production capacity exceeding 500?tonnes per day or in other kilns with a production capacity exceeding 50?tonnes per day; ESPs, fabric filters, hybrid filters; Reducing dust emissions to air. The BAT-AEL emission level is < 10 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000007', 'Production of Cement, Lime and Magnesium Oxide - Dust - BAT18', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (a) production of cement clinker in rotary kilns with a production capacity exceeding 500?tonnes per day or in other kilns with a production capacity exceeding 50?tonnes per day; ESPs, fabric filters, hybrid filters; Reducing dust emissions to air. The BAT-AEL emission level is < 10 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000008', 'Production of Cement, Lime and Magnesium Oxide - Dust - BAT42-I', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (b) production of lime in kilns with a production capacity exceeding 50?tonnes per day; Fabric filter; Reducing dust emissions to air. The BAT-AEL emission level is  < 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000009', 'Production of Cement, Lime and Magnesium Oxide - Dust - BAT42-II', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (b) production of lime in kilns with a production capacity exceeding 50?tonnes per day; Wet scrubber; Reducing dust emissions to air. The BAT-AEL emission level is < 10 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000010', 'Production of Cement, Lime and Magnesium Oxide - Dust - BAT43-I', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (b) production of lime in kilns with a production capacity exceeding 50?tonnes per day; Fabric filter; Reducing dust emissions to air. The BAT-AEL emission level is  < 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000011', 'Production of Cement, Lime and Magnesium Oxide - Dust - BAT43-II', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (b) production of lime in kilns with a production capacity exceeding 50?tonnes per day; ESP or other filters; Reducing dust emissions to air. The BAT-AEL emission level is  < 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000012', 'Production of Cement, Lime and Magnesium Oxide - Dust - BAT59', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (c) production of magnesium oxide in kilns with a production capacity exceeding 50?tonnes per day; Fabric filters, centrifugal separators/ cyclones, wet dust separators; Reducing dust emissions to air. The BAT-AEL emission level is  < 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000013', 'Production of Cement, Lime and Magnesium Oxide - Dust - BAT60', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (c) production of magnesium oxide in kilns with a production capacity exceeding 50?tonnes per day; ESPs, fabric filters, centrifugal separators / cyclones, wet dust separators; Reducing dust emissions to air. The BAT-AEL emission level is < 20 - 35 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000014', 'Production of Cement, Lime and Magnesium Oxide - HCl - BAT25', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (a) production of cement clinker in rotary kilns with a production capacity exceeding 500?tonnes per day or in other kilns with a production capacity exceeding 50?tonnes per day; Primary techniques (a)-(b) (see table); Reducing hydrogen chloride (HCl) emissions to air. The BAT-AEL emission level is  < 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000015', 'Production of Cement, Lime and Magnesium Oxide - HCl - BAT51-I', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (b) production of lime in kilns with a production capacity exceeding 50?tonnes per day; Primary techniques (a)-(b) (see table), when using waste; Reducing hydrogen chloride (HCl) emissions to air. The BAT-AEL emission level is  < 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000016', 'Production of Cement, Lime and Magnesium Oxide - HF - BAT26', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (a) production of cement clinker in rotary kilns with a production capacity exceeding 500?tonnes per day or in other kilns with a production capacity exceeding 50?tonnes per day; Primary techniques (a)-(b) (see table); Reducing hydrogen fluoride (HF) emissions to air. The BAT-AEL emission level is  < 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000017', 'Production of Cement, Lime and Magnesium Oxide - HF - BAT51-II', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (b) production of lime in kilns with a production capacity exceeding 50?tonnes per day; Primary techniques (a)-(b) (see table), when using waste; Reducing hydrogen fluoride (HF) emissions to air. The BAT-AEL emission level is  < 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000018', 'Production of Cement, Lime and Magnesium Oxide - Hg - BAT28-I', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (a) production of cement clinker in rotary kilns with a production capacity exceeding 500?tonnes per day or in other kilns with a production capacity exceeding 50?tonnes per day; Techniques (a)-(c) (see table); Reducing mercury emissions to air. The BAT-AEL emission level is  < 0,05 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000019', 'Production of Cement, Lime and Magnesium Oxide - Hg - BAT53-I', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (b) production of lime in kilns with a production capacity exceeding 50?tonnes per day; Techniques (a)-(d) (see table), when using wastes; Reducing metals emissions to air. The BAT-AEL emission level is  < 0,05 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000020', 'Production of Cement, Lime and Magnesium Oxide - Metals - BAT28-II', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (a) production of cement clinker in rotary kilns with a production capacity exceeding 500?tonnes per day or in other kilns with a production capacity exceeding 50?tonnes per day; Techniques (a)-(c) (see table); Reducing metals emissions to air. The BAT-AEL emission level is  < 0,05 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000021', 'Production of Cement, Lime and Magnesium Oxide - Metals - BAT28-III', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (a) production of cement clinker in rotary kilns with a production capacity exceeding 500?tonnes per day or in other kilns with a production capacity exceeding 50?tonnes per day; Techniques (a)-(c) (see table); Reducing metals emissions to air. The BAT-AEL emission level is  < 0,5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000022', 'Production of Cement, Lime and Magnesium Oxide - Metals - BAT53-II', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (b) production of lime in kilns with a production capacity exceeding 50?tonnes per day; Techniques (a)-(d) (see table), when using wastes; Reducing metals emissions to air. The BAT-AEL emission level is  < 0,05 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000023', 'Production of Cement, Lime and Magnesium Oxide - Metals - BAT53-III', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (b) production of lime in kilns with a production capacity exceeding 50?tonnes per day; Techniques (a)-(d) (see table), when using wastes; Reducing metals emissions to air. The BAT-AEL emission level is  < 0,5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000024', 'Production of Cement, Lime and Magnesium Oxide - NH3 - BAT20', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (a) production of cement clinker in rotary kilns with a production capacity exceeding 500?tonnes per day or in other kilns with a production capacity exceeding 50?tonnes per day; SNCR; techniques (a)-(c) (see table); Reducing ammonia slip emissions to air. The BAT-AEL emission level is < 30 - 50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000025', 'Production of Cement, Lime and Magnesium Oxide - NH3 - BAT46', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (b) production of lime in kilns with a production capacity exceeding 50?tonnes per day; SNCR; Reducing ammonia slip emissions to air. The BAT-AEL emission level is  < 30 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000026', 'Production of Cement, Lime and Magnesium Oxide - NO2 - BAT19-I', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (a) production of cement clinker in rotary kilns with a production capacity exceeding 500?tonnes per day or in other kilns with a production capacity exceeding 50?tonnes per day; Preheater kilns; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 200 - 450 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000027', 'Production of Cement, Lime and Magnesium Oxide - NO2 - BAT19-II', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (a) production of cement clinker in rotary kilns with a production capacity exceeding 500?tonnes per day or in other kilns with a production capacity exceeding 50?tonnes per day; Lepol and long rotary kilns; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 400 - 800 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000028', 'Production of Cement, Lime and Magnesium Oxide - NO2 - BAT45-I', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (b) production of lime in kilns with a production capacity exceeding 50?tonnes per day; PFRK, ASK, MFSK, OSK; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 100 - 350 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000029', 'Production of Cement, Lime and Magnesium Oxide - NO2 - BAT45-II', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (b) production of lime in kilns with a production capacity exceeding 50?tonnes per day; LRK, PRK; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 200 - 500 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000030', 'Production of Cement, Lime and Magnesium Oxide - NO2 - BAT62', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (c) production of magnesium oxide in kilns with a production capacity exceeding 50?tonnes per day; Techniques (a)-(b) (see table); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 500 - 1500 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000031', 'Production of Cement, Lime and Magnesium Oxide - PCDD.F - BAT27', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (a) production of cement clinker in rotary kilns with a production capacity exceeding 500?tonnes per day or in other kilns with a production capacity exceeding 50?tonnes per day; Techniques (a)-(f) (see table); Reducing PCDD/F emissions to air. The BAT-AEL emission level is < 0,05 - 0,1 ng/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000032', 'Production of Cement, Lime and Magnesium Oxide - PCDD.F - BAT52', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (b) production of lime in kilns with a production capacity exceeding 50?tonnes per day; Primary techniques (a)-(c) (see table); Reducing PCDD/F emissions to air. The BAT-AEL emission level is < 0,05 - 0,1 ng/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000033', 'Production of Cement, Lime and Magnesium Oxide - SO2 - BAT21', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (a) production of cement clinker in rotary kilns with a production capacity exceeding 500?tonnes per day or in other kilns with a production capacity exceeding 50?tonnes per day; Absorbent addition, wet scrubber; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 50 - 400 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000034', 'Production of Cement, Lime and Magnesium Oxide - SO2 - BAT47-I', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (b) production of lime in kilns with a production capacity exceeding 50?tonnes per day; PFRK, ASK, MFSK, OSK, PRK; Reducing SOX emissions to air. The BAT-AEL emission level is < 50 - 200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000035', 'Production of Cement, Lime and Magnesium Oxide - SO2 - BAT47-II', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (b) production of lime in kilns with a production capacity exceeding 50?tonnes per day; LRK; Reducing SOX emissions to air. The BAT-AEL emission level is < 50 - 400 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000036', 'Production of Cement, Lime and Magnesium Oxide - SO2 - BAT65', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (c) production of magnesium oxide in kilns with a production capacity exceeding 50?tonnes per day; Primary and secondary techniques (a)-(d) (see table); Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 50 - 400 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000037', 'Production of Cement, Lime and Magnesium Oxide - TOC - BAT50-I', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (b) production of lime in kilns with a production capacity exceeding 50?tonnes per day; LRK, PRK; Reducing total organic carbon (TOC) emissions to air. The BAT-AEL emission level is  < 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000038', 'Production of Cement, Lime and Magnesium Oxide - TOC - BAT50-II', '3, Mineral industry: 3,1 Production of cement, lime and magnesium oxide: (b) production of lime in kilns with a production capacity exceeding 50?tonnes per day; ASK, MFSK, PFRK; Reducing total organic carbon (TOC) emissions to air. The BAT-AEL emission level is  < 30 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000039', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - AOX - BAT10-XIII', '4, Chemical industry: 4.1, Production of organic chemicals; 4.2, Production of inorganic chemicals; 4.3, Production of phosphorous-, nitrogen- or potassium-based fertilisers; 4.4, Production of plant protection products or of biocides; 4.5, Production of pharmaceutical products including intermediates; 4.6. Production of explosives. Reducing adsorbable organically bound halogens (AOX) to water. The BAT-AEL emission level is 0,2 - 1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000040', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - AOX - BAT10-XIV', '6, Other activities: 6,11 Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under Section 4. of Annex I Reducing adsorbable organically bound halogens (AOX) to water. The BAT-AEL emission level is 0,2 - 1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000041', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - COD - BAT10-III', '4, Chemical industry: 4.1, Production of organic chemicals; 4.2, Production of inorganic chemicals; 4.3, Production of phosphorous-, nitrogen- or potassium-based fertilisers; 4.4, Production of plant protection products or of biocides; 4.5, Production of pharmaceutical products including intermediates; 4.6. Production of explosives. Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is < 30 - 100 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000042', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - COD - BAT10-IV', '6, Other activities: 6,11 Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under Section 4. of Annex I Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is < 30 - 100 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000043', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - Cr - BAT10-XV', '4, Chemical industry: 4.1, Production of organic chemicals; 4.2, Production of inorganic chemicals; 4.3, Production of phosphorous-, nitrogen- or potassium-based fertilisers; 4.4, Production of plant protection products or of biocides; 4.5, Production of pharmaceutical products including intermediates; 4.6. Production of explosives. Reducing chromium to water. The BAT-AEL emission level is 5 - 25 ?g/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000044', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - Cr - BAT10-XVI', '6, Other activities: 6,11 Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under Section 4. of Annex I Reducing chromium to water. The BAT-AEL emission level is 5 - 25 ?g/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000045', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - Cu - BAT10-XVII', '4, Chemical industry: 4.1, Production of organic chemicals; 4.2, Production of inorganic chemicals; 4.3, Production of phosphorous-, nitrogen- or potassium-based fertilisers; 4.4, Production of plant protection products or of biocides; 4.5, Production of pharmaceutical products including intermediates; 4.6. Production of explosives. Reducing copper to water. The BAT-AEL emission level is 5 - 50 ?g/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000046', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - Cu - BAT10-XVIII', '6, Other activities: 6,11 Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under Section 4. of Annex I Reducing copper to water. The BAT-AEL emission level is 5 - 50 ?g/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000047', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - InorgN - BAT10-IX', '4, Chemical industry: 4.1, Production of organic chemicals; 4.2, Production of inorganic chemicals; 4.3, Production of phosphorous-, nitrogen- or potassium-based fertilisers; 4.4, Production of plant protection products or of biocides; 4.5, Production of pharmaceutical products including intermediates; 4.6. Production of explosives. Reducing total inorganic nitrogen (N inorg) to water. The BAT-AEL emission level is 5 - 20 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000048', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - InorgN - BAT10-X', '6, Other activities: 6,11 Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under Section 4. of Annex I Reducing total inorganic nitrogen (N inorg) to water. The BAT-AEL emission level is 5 - 20 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000049', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - Ni - BAT10-XIX', '4, Chemical industry: 4.1, Production of organic chemicals; 4.2, Production of inorganic chemicals; 4.3, Production of phosphorous-, nitrogen- or potassium-based fertilisers; 4.4, Production of plant protection products or of biocides; 4.5, Production of pharmaceutical products including intermediates; 4.6. Production of explosives. Reducing nickel to water. The BAT-AEL emission level is 5 - 50 ?g/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000050', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - Ni - BAT10-XX', '6, Other activities: 6,11 Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under Section 4. of Annex I Reducing nickel to water. The BAT-AEL emission level is 5 - 50 ?g/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000051', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - TN - BAT10-VII', '4, Chemical industry: 4.1, Production of organic chemicals; 4.2, Production of inorganic chemicals; 4.3, Production of phosphorous-, nitrogen- or potassium-based fertilisers; 4.4, Production of plant protection products or of biocides; 4.5, Production of pharmaceutical products including intermediates; 4.6. Production of explosives. Reducing total nitrogen (TN) to water. The BAT-AEL emission level is 5 - 25 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000052', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - TN - BAT10-VIII', '6, Other activities: 6,11 Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under Section 4. of Annex I Reducing total nitrogen (TN) to water. The BAT-AEL emission level is 5 - 25 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000053', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - TOC - BAT10-I', '4, Chemical industry: 4.1, Production of organic chemicals; 4.2, Production of inorganic chemicals; 4.3, Production of phosphorous-, nitrogen- or potassium-based fertilisers; 4.4, Production of plant protection products or of biocides; 4.5, Production of pharmaceutical products including intermediates; 4.6. Production of explosives. Reducing total organic carbon (TOC) to water. The BAT-AEL emission level is < 10 - 33 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000054', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - TOC - BAT10-II', '6, Other activities: 6,11 Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under Section 4. of Annex I Reducing total organic carbon (TOC) to water. The BAT-AEL emission level is < 10 - 33 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000055', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - TP - BAT10-XI', '4, Chemical industry: 4.1, Production of organic chemicals; 4.2, Production of inorganic chemicals; 4.3, Production of phosphorous-, nitrogen- or potassium-based fertilisers; 4.4, Production of plant protection products or of biocides; 4.5, Production of pharmaceutical products including intermediates; 4.6. Production of explosives. Reducing total phosphorus (TP) to water. The BAT-AEL emission level is 0,5 - 3 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000056', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - TP - BAT10-XII', '6, Other activities: 6,11 Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under Section 4. of Annex I Reducing total phosphorus (TP) to water. The BAT-AEL emission level is 0,5 - 3 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000057', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - TSS - BAT10-V', '4, Chemical industry: 4.1, Production of organic chemicals; 4.2, Production of inorganic chemicals; 4.3, Production of phosphorous-, nitrogen- or potassium-based fertilisers; 4.4, Production of plant protection products or of biocides; 4.5, Production of pharmaceutical products including intermediates; 4.6. Production of explosives. Reducing total suspended solids (TSS) to water. The BAT-AEL emission level is 5 - 35 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000058', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - TSS - BAT10-VI', '6, Other activities: 6,11 Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under Section 4. of Annex I Reducing total suspended solids (TSS) to water. The BAT-AEL emission level is 5 - 35 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000059', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - Zn - BAT10-XXI', '4, Chemical industry: 4.1, Production of organic chemicals; 4.2, Production of inorganic chemicals; 4.3, Production of phosphorous-, nitrogen- or potassium-based fertilisers; 4.4, Production of plant protection products or of biocides; 4.5, Production of pharmaceutical products including intermediates; 4.6. Production of explosives. Reducing zinc to water. The BAT-AEL emission level is 20 - 300 ?g/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000060', 'Common Waste Water and Waste Gas Treatment/ Management Systems in the Chemical Sector - Zn - BAT10-XXII', '6, Other activities: 6,11 Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under Section 4. of Annex I Reducing zinc to water. The BAT-AEL emission level is 20 - 300 ?g/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000061', 'Manufacture of Glass - Amines - BAT63-V', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(v) (see table); Reducing amines emissions to air. The BAT-AEL emission level is  < 3 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000062', 'Manufacture of Glass - Amines - BAT63-XI', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(v) (see table); Reducing amines emissions to air. The BAT-AEL emission level is  < 2 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000063', 'Manufacture of Glass - Amines - BAT63-XVIII', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(v) (see table); Reducing amines emissions to air. The BAT-AEL emission level is  < 0,01 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000064', 'Manufacture of Glass - As - BAT13-IX', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day Reducing arsenic to water. The BAT-AEL emission level is  < 0,3 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000065', 'Manufacture of Glass - B - BAT13-XVIII', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day Reducing boron to water. The BAT-AEL emission level is < 1 - 3 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000066', 'Manufacture of Glass - Ba - BAT13-X', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day Reducing barium to water. The BAT-AEL emission level is  < 3 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000067', 'Manufacture of Glass - C - BAT37-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing total volatile organic compounds emissions to air. The BAT-AEL emission level is  < 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000068', 'Manufacture of Glass - C - BAT63-VI', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(v) (see table); Reducing total volatile organic compounds emissions to air. The BAT-AEL emission level is 10 - 30 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000069', 'Manufacture of Glass - C - BAT63-XII', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(v) (see table); Reducing total volatile organic compounds emissions to air. The BAT-AEL emission level is  < 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000070', 'Manufacture of Glass - C - BAT63-XIX', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(v) (see table); Reducing total volatile organic compounds emissions to air. The BAT-AEL emission level is  < 0,065 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000071', 'Manufacture of Glass - C - BAT70', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iii) (see table); Reducing volatile organic compounds emissions to air. The BAT-AEL emission level is 10 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000072', 'Manufacture of Glass - C6H6O - BAT13-XIX', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day Reducing phenol to water. The BAT-AEL emission level is  < 1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000073', 'Manufacture of Glass - C6H6O - BAT63-II', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(v) (see table); Reducing phenol emissions to air. The BAT-AEL emission level is < 5 - 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000074', 'Manufacture of Glass - C6H6O - BAT63-VIII', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(v) (see table); Reducing phenol emissions to air. The BAT-AEL emission level is < 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000075', 'Manufacture of Glass - C6H6O - BAT63-XV', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(v) (see table); Reducing phenol emissions to air. The BAT-AEL emission level is  < 0,03 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000076', 'Manufacture of Glass - CH2O - BAT37-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing formaldehyde emissions to air. The BAT-AEL emission level is  < 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000077', 'Manufacture of Glass - CH2O - BAT63-III', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(v) (see table); Reducing formaldehyde emissions to air. The BAT-AEL emission level is < 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000078', 'Manufacture of Glass - CH2O - BAT63-IX', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(v) (see table); Reducing formaldehyde emissions to air. The BAT-AEL emission level is < 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000079', 'Manufacture of Glass - CH2O - BAT63-XVI', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(v) (see table); Reducing formaldehyde emissions to air. The BAT-AEL emission level is  < 0,03 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000080', 'Manufacture of Glass - CO - BAT9', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (see table); Reducing carbon monoxide (CO) emissions to air. The BAT-AEL emission level is  < 100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000081', 'Manufacture of Glass - COD - BAT13-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is < 5 - 130 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000082', 'Manufacture of Glass - Cd - BAT13-XIV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day Reducing cadmium to water. The BAT-AEL emission level is  < 0,05 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000083', 'Manufacture of Glass - Cr - BAT13-XIII', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day Reducing chromium to water. The BAT-AEL emission level is  < 0,3 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000084', 'Manufacture of Glass - Cu - BAT13-XII', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day Reducing copper to water. The BAT-AEL emission level is  < 0,3 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000085', 'Manufacture of Glass - Dust - BAT16-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Flue-gas cleaning system such as electrostatic precipitator or bag filter (see table); Reducing dust emissions to air. The BAT-AEL emission level is < 10 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000086', 'Manufacture of Glass - Dust - BAT16-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Flue-gas cleaning system such as electrostatic precipitator or bag filter (see table); Reducing dust emissions to air. The BAT-AEL emission level is < 0,015 - 0,06 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000087', 'Manufacture of Glass - Dust - BAT22-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing dust emissions to air. The BAT-AEL emission level is  < 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000088', 'Manufacture of Glass - Dust - BAT24-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Electrostatic precipitator or bag filter system; Reducing dust emissions to air. The BAT-AEL emission level is < 10 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000089', 'Manufacture of Glass - Dust - BAT24-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Electrostatic precipitator or bag filter system; Reducing dust emissions to air. The BAT-AEL emission level is < 0,025 - 0,05 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000090', 'Manufacture of Glass - Dust - BAT31-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table); Reducing dust emissions to air. The BAT-AEL emission level is < 15 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000091', 'Manufacture of Glass - Dust - BAT32-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing dust emissions to air. The BAT-AEL emission level is < 10 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000092', 'Manufacture of Glass - Dust - BAT32-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing dust emissions to air. The BAT-AEL emission level is < 0,045 - 0,09 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000093', 'Manufacture of Glass - Dust - BAT37-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing dust emissions to air. The BAT-AEL emission level is < 5 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000094', 'Manufacture of Glass - Dust - BAT37-V', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing dust emissions to air. The BAT-AEL emission level is < 5 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000095', 'Manufacture of Glass - Dust - BAT38-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(v) (see table) (???); Reducing dust emissions to air. The BAT-AEL emission level is < 10 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000096', 'Manufacture of Glass - Dust - BAT38-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(v) and batch formulations with significant amounts of dangerous substances (EC No 1272/2008) (?); Reducing dust emissions to air. The BAT-AEL emission level is < 1 - 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000097', 'Manufacture of Glass - Dust - BAT38-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(v) (see table) (???); Reducing dust emissions to air. The BAT-AEL emission level is < 0,03 - 0,06 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000098', 'Manufacture of Glass - Dust - BAT38-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(v) and batch formulations with significant amounts of dangerous substances (EC No 1272/2008) (?); Reducing dust emissions to air. The BAT-AEL emission level is < 0,003 - 0,03 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000099', 'Manufacture of Glass - Dust - BAT46-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(ii) (see table); Reducing dust emissions to air. The BAT-AEL emission level is < 1 - 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000100', 'Manufacture of Glass - Dust - BAT48-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing dust emissions to air. The BAT-AEL emission level is < 10 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000101', 'Manufacture of Glass - Dust - BAT48-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table) and batch formulations with significant amounts of dangerous substances (EC No 1272/2008) (?); Reducing dust emissions to air. The BAT-AEL emission level is < 1 - 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000102', 'Manufacture of Glass - Dust - BAT48-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing dust emissions to air. The BAT-AEL emission level is < 0,03 - 0,13 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000103', 'Manufacture of Glass - Dust - BAT48-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table) and batch formulations with significant amounts of dangerous substances (EC No 1272/2008) (?); Reducing dust emissions to air. The BAT-AEL emission level is < 0,003 - 0,065 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000104', 'Manufacture of Glass - Dust - BAT54-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(ii) (see table); Reducing dust emissions to air. The BAT-AEL emission level is 1 - 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000105', 'Manufacture of Glass - Dust - BAT56-I', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Electrostatic precipitator or bag filter system; Reducing dust emissions to air. The BAT-AEL emission level is < 10 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000106', 'Manufacture of Glass - Dust - BAT56-II', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Electrostatic precipitator or bag filter system; Reducing dust emissions to air. The BAT-AEL emission level is < 0,02 - 0,05 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000107', 'Manufacture of Glass - Dust - BAT64', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Flue-gas cleaning by bag filter system (?); Reducing dust emissions to air. The BAT-AEL emission level is < 5 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000108', 'Manufacture of Glass - Dust - BAT65', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iii) (see table); Reducing dust emissions to air. The BAT-AEL emission level is 1 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000109', 'Manufacture of Glass - Dust - BAT71-I', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Electrostatic precipitator or bag filter system; Reducing dust emissions to air. The BAT-AEL emission level is < 10 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000110', 'Manufacture of Glass - Dust - BAT71-II', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Electrostatic precipitator or bag filter system; Reducing dust emissions to air. The BAT-AEL emission level is < 0,05 - 0,15 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000111', 'Manufacture of Glass - Dust - BAT76-I', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iii) (see table); Reducing dust emissions to air. The BAT-AEL emission level is 5 - 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000112', 'Manufacture of Glass - F - BAT13-V', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day Reducing fluorides to water. The BAT-AEL emission level is  < 6 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000113', 'Manufacture of Glass - H2S - BAT61-I', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Waste gas incineration system to oxidise hydrogen sulphide to SO2; Reducing hydrogen sulphide emissions to air. The BAT-AEL emission level is  < 2 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000114', 'Manufacture of Glass - H2S - BAT61-II', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Waste gas incineration system to oxidise hydrogen sulphide to SO2; Reducing hydrogen sulphide emissions to air. The BAT-AEL emission level is  < 0,005 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000115', 'Manufacture of Glass - HCl - BAT20-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(ii) (see table); Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is < 10 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000116', 'Manufacture of Glass - HCl - BAT20-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(ii) (see table); Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is < 0,02 - 0,03 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000117', 'Manufacture of Glass - HCl - BAT22-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is  < 30 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000118', 'Manufacture of Glass - HCl - BAT28-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(ii) (see table); Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is < 10 - 25 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000119', 'Manufacture of Glass - HCl - BAT28-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(ii) (see table); Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is < 0,025 - 0,0625 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000120', 'Manufacture of Glass - HCl - BAT31-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table); Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is  < 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000121', 'Manufacture of Glass - HCl - BAT35-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table); Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is  < 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000122', 'Manufacture of Glass - HCl - BAT35-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table); Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is  < 0,05 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000123', 'Manufacture of Glass - HCl - BAT42-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table); Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is < 10 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000124', 'Manufacture of Glass - HCl - BAT42-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table); Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is < 0,03 - 0,06 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000125', 'Manufacture of Glass - HCl - BAT52-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is < 10 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000126', 'Manufacture of Glass - HCl - BAT52-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is < 0,03 - 0,05 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000127', 'Manufacture of Glass - HCl - BAT60-I', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(ii) (see table); for glass wool; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is < 5 - 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000128', 'Manufacture of Glass - HCl - BAT60-II', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(ii) (see table); for stone wool; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is < 10 - 30 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000129', 'Manufacture of Glass - HCl - BAT60-IV', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(ii) (see table); for glass wool; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is < 0,01 - 0,02 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000130', 'Manufacture of Glass - HCl - BAT60-V', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(ii) (see table); for stone wool; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is < 0,025 - 0,075 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000131', 'Manufacture of Glass - HCl - BAT68-I', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Raw materials selection for batch formulation with low content of chlorine and fluorine; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is  < 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000132', 'Manufacture of Glass - HCl - BAT74-I', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iii) (see table); Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is  < 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000133', 'Manufacture of Glass - HCl - BAT74-III', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iii) (see table); Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is  < 0,05 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000134', 'Manufacture of Glass - HF - BAT20-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(ii) (see table); Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 1 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000135', 'Manufacture of Glass - HF - BAT20-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(ii) (see table); Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is 0,001 - 0,008 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000136', 'Manufacture of Glass - HF - BAT28-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(ii) (see table); Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 1 - 4 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000137', 'Manufacture of Glass - HF - BAT28-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(ii) (see table); Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 0,0025 - 0,01 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000138', 'Manufacture of Glass - HF - BAT31-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table); Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 1 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000139', 'Manufacture of Glass - HF - BAT35-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table); Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 5 - 15 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000140', 'Manufacture of Glass - HF - BAT35-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table); Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 0,02 - 0,07 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000141', 'Manufacture of Glass - HF - BAT42-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table); Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 1 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000142', 'Manufacture of Glass - HF - BAT42-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table); Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 0,003 - 0,015 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000143', 'Manufacture of Glass - HF - BAT47', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(ii) (see table); Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is  < 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000144', 'Manufacture of Glass - HF - BAT52-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 1 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000145', 'Manufacture of Glass - HF - BAT52-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 0,003 - 0,04 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000146', 'Manufacture of Glass - HF - BAT55', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(ii) (see table); Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is  < 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000147', 'Manufacture of Glass - HF - BAT60-III', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(ii) (see table); for all products; Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 1 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000148', 'Manufacture of Glass - HF - BAT60-VI', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(ii) (see table); for all products; Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 0,002 - 0,013 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000149', 'Manufacture of Glass - HF - BAT68-II', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Raw materials selection for batch formulation with low content of chlorine and fluorine; Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is  < 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000150', 'Manufacture of Glass - HF - BAT74-II', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iii) (see table); Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is  < 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000151', 'Manufacture of Glass - HF - BAT74-IV', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iii) (see table); Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is  < 0,03 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000152', 'Manufacture of Glass - Metals - BAT21-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 0,2 - 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000153', 'Manufacture of Glass - Metals - BAT21-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 1 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000154', 'Manufacture of Glass - Metals - BAT21-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 0,0003 - 0,0015 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000155', 'Manufacture of Glass - Metals - BAT21-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 0,0015 - 0,0075 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000156', 'Manufacture of Glass - Metals - BAT29-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 0,2 - 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000157', 'Manufacture of Glass - Metals - BAT29-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 1 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000158', 'Manufacture of Glass - Metals - BAT29-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 0,0005 - 0,0025 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000159', 'Manufacture of Glass - Metals - BAT29-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 0,0025 - 0,0125 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000160', 'Manufacture of Glass - Metals - BAT31-V', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table); Reducing metals emissions to air. The BAT-AEL emission level is  < 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000161', 'Manufacture of Glass - Metals - BAT31-VI', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table); Reducing metals emissions to air. The BAT-AEL emission level is  < 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000162', 'Manufacture of Glass - Metals - BAT36-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 0,2 - 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000163', 'Manufacture of Glass - Metals - BAT36-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 1 - 3 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000164', 'Manufacture of Glass - Metals - BAT36-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 0,0009 - 0,0045 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000165', 'Manufacture of Glass - Metals - BAT36-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 0,0045 - 0,0135 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000166', 'Manufacture of Glass - Metals - BAT43-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 0,2 - 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000167', 'Manufacture of Glass - Metals - BAT43-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 1 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000168', 'Manufacture of Glass - Metals - BAT43-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 0,0006 - 0,003 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000169', 'Manufacture of Glass - Metals - BAT43-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 0,003 - 0,015 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000170', 'Manufacture of Glass - Metals - BAT46-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(ii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is  < 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000171', 'Manufacture of Glass - Metals - BAT46-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(ii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 1 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000172', 'Manufacture of Glass - Metals - BAT53-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 0,1 - 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000173', 'Manufacture of Glass - Metals - BAT53-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 1 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000174', 'Manufacture of Glass - Metals - BAT53-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 0,0003 - 0,003 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000175', 'Manufacture of Glass - Metals - BAT53-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 0,003 - 0,015 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000176', 'Manufacture of Glass - Metals - BAT54-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(ii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is  < 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000177', 'Manufacture of Glass - Metals - BAT54-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(ii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 1 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000178', 'Manufacture of Glass - Metals - BAT62-I', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(ii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 0,2 - 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000179', 'Manufacture of Glass - Metals - BAT62-II', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(ii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 1 - 2 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000180', 'Manufacture of Glass - Metals - BAT62-III', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(ii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 0,0004 - 0,0025 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000181', 'Manufacture of Glass - Metals - BAT62-IV', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(ii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is < 0,002 - 0,005 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000182', 'Manufacture of Glass - Metals - BAT69-I', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(ii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is  < 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000183', 'Manufacture of Glass - Metals - BAT69-II', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(ii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is  < 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000184', 'Manufacture of Glass - Metals - BAT75-I', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is  < 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000185', 'Manufacture of Glass - Metals - BAT75-II', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is  < 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000186', 'Manufacture of Glass - Metals - BAT75-III', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is  < 0,0075 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000187', 'Manufacture of Glass - Metals - BAT75-IV', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is  < 0,037 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000188', 'Manufacture of Glass - Metals - BAT76-II', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is  < 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000189', 'Manufacture of Glass - Metals - BAT76-III', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iii) (see table); Reducing metals emissions to air. The BAT-AEL emission level is  < 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000190', 'Manufacture of Glass - NH3 - BAT10', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; SCR or SNCR; Reducing ammonia (NH3) emissions to air. The BAT-AEL emission level is < 5 - 30 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000191', 'Manufacture of Glass - NH3 - BAT37-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing ammonia emissions to air. The BAT-AEL emission level is  < 30 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000192', 'Manufacture of Glass - NH3 - BAT63-IV', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(v) (see table); Reducing ammonia emissions to air. The BAT-AEL emission level is 30 - 60 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000193', 'Manufacture of Glass - NH3 - BAT63-X', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(v) (see table); Reducing ammonia emissions to air. The BAT-AEL emission level is < 20 - 60 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000194', 'Manufacture of Glass - NH3 - BAT63-XVII', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(v) (see table); Reducing ammonia emissions to air. The BAT-AEL emission level is  < 0,4 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000195', 'Manufacture of Glass - NH4 - BAT13-XVII', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day Reducing ammonia to water. The BAT-AEL emission level is  < 10 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000196', 'Manufacture of Glass - NO2 - BAT17-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; I. Primary techniques: Combustion modifications (i), special furnace design (ii); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 500 - 800 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000197', 'Manufacture of Glass - NO2 - BAT17-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; I. Primary techniques: Electric melting (iii); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000198', 'Manufacture of Glass - NO2 - BAT17-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; II. Secondary techniques; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 500 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000199', 'Manufacture of Glass - NO2 - BAT17-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; I. Primary techniques: Combustion modifications (i), special furnace design (ii); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 0,75 - 1,2 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000200', 'Manufacture of Glass - NO2 - BAT17-V', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; I. Primary techniques: Electric melting (iii); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 0,3 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000201', 'Manufacture of Glass - NO2 - BAT17-VI', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; I. Primary techniques: Oxy-fuel melting (iv); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 0,5 - 0,8 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000202', 'Manufacture of Glass - NO2 - BAT17-VII', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; II. Secondary techniques; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 0,75 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000203', 'Manufacture of Glass - NO2 - BAT18-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; I. Primary techniques (see table BAT 17): Combustion modifications (i), special furnace designs (ii) combined with minimisation of these (nitrates) raw materials; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 500 - 800 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000204', 'Manufacture of Glass - NO2 - BAT18-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; I. Primary techniques (see table BAT 17): Electric melting (iii) combined with minimisation of these (nitrates) raw materials; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000205', 'Manufacture of Glass - NO2 - BAT18-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; II. Secondary techniques (see table BAT 17) combined with minimisation of these (nitrates) raw materials; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 500 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000206', 'Manufacture of Glass - NO2 - BAT18-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; I. Primary techniques (see table BAT 17): Combustion modifications (i), special furnace designs (ii) combined with minimisation of these (nitrates) raw materials; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 0,75 - 1,2 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000207', 'Manufacture of Glass - NO2 - BAT18-IX', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Primary techniques (see table) in cases of short campaigns or melting furnaces with a capacity < 100 t/d; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 3 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000208', 'Manufacture of Glass - NO2 - BAT18-V', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; I. Primary techniques (see table BAT 17): Electric melting (iii) combined with minimisation of these (nitrates) raw materials; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 0,3 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000209', 'Manufacture of Glass - NO2 - BAT18-VI', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; I. Primary techniques (see table BAT 17): Oxy-fuel melting (iv) combined with minimisation of these (nitrates) raw materials; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 0,5 - 0,8 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000210', 'Manufacture of Glass - NO2 - BAT18-VII', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; II. Secondary techniques (see table BAT 17) combined with minimisation of these (nitrates) raw materials; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 0,75 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000211', 'Manufacture of Glass - NO2 - BAT18-VIII', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Primary techniques (see table) in cases of short campaigns or melting furnaces with a capacity < 100 t/d; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 1000 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000212', 'Manufacture of Glass - NO2 - BAT25-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; I. Primary techniques: Combustion modifications (i), Fenix process (ii); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 700 - 800 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000213', 'Manufacture of Glass - NO2 - BAT25-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; II. Secondary techniques; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 400 - 700 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000214', 'Manufacture of Glass - NO2 - BAT25-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; I. Primary techniques: Combustion modifications (i), Fenix process (ii); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 1,75 - 2 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000215', 'Manufacture of Glass - NO2 - BAT25-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; I. Primary techniques: Oxy-fuel melting (iii); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 1,25 - 2 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000216', 'Manufacture of Glass - NO2 - BAT25-V', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; II. Secondary techniques; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 1 - 1,75 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000217', 'Manufacture of Glass - NO2 - BAT26-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; II. Secondary techniques (see table BAT 25) and minimisation of these (nitrates) raw materials; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 400 - 700 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000218', 'Manufacture of Glass - NO2 - BAT26-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; II. Secondary techniques (see table BAT 25) and minimisation of these (nitrates) raw materials; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 1 - 1,75 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000219', 'Manufacture of Glass - NO2 - BAT26-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Primary techniques (see table) and production of special glasses in a limited number of short campaigns; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 1200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000220', 'Manufacture of Glass - NO2 - BAT26-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Primary techniques (see table) and production of special glasses in a limited number of short campaigns; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 3 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000221', 'Manufacture of Glass - NO2 - BAT33-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Combustion modifications (i); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 600 - 1000 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000222', 'Manufacture of Glass - NO2 - BAT33-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Combustion modifications (i); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 2,7 - 4,5 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000223', 'Manufacture of Glass - NO2 - BAT33-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Oxy-fuel melting (ii); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 0,5 - 1,5 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000224', 'Manufacture of Glass - NO2 - BAT39-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Combustion modifications (i), special furnace design (ii); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 500 - 1000 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000225', 'Manufacture of Glass - NO2 - BAT39-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Electric melting (iii); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000226', 'Manufacture of Glass - NO2 - BAT39-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Combustion modifications (i), special furnace design (ii); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 1,25 - 2,5 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000227', 'Manufacture of Glass - NO2 - BAT39-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Electric melting (iii); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 0,3 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000228', 'Manufacture of Glass - NO2 - BAT39-V', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Oxy-fuel melting (iv); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 0,5 - 1,5 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000229', 'Manufacture of Glass - NO2 - BAT40-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Combustion modifications (i), special furnace designs (ii) (see table BAT 39) combined with minimisation of these (nitrates) raw materials; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 500 - 1500 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000230', 'Manufacture of Glass - NO2 - BAT40-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Electric melting (iii) (see table BAT 39) combined with minimisation of these (nitrates) raw materials; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000231', 'Manufacture of Glass - NO2 - BAT40-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Combustion modifications (i), special furnace designs (ii) (see table BAT 39) combined with minimisation of these (nitrates) raw materials; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 1,25 - 2,5 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000232', 'Manufacture of Glass - NO2 - BAT40-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Electric melting (iii) (see table BAT 39) combined with minimisation of these (nitrates) raw materials; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 0,3 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000233', 'Manufacture of Glass - NO2 - BAT40-IX', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Electric melting in production of special types of soda-lime glasses and other special glasses and for a limited number of short campaigns or for melting furnaces with a capacity < 100 t/d (?); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 8 - 10 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000234', 'Manufacture of Glass - NO2 - BAT40-V', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Oxy-fuel melting (iv) (see table BAT 39) combined with minimisation of these (nitrates) raw materials; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 0,5 - 1,5 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000235', 'Manufacture of Glass - NO2 - BAT40-VI', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Fuel/air conventional furnaces in production of special types of soda-lime glasses and other special glasses and for a limited number of short campaigns or for melting furnaces with a capacity < 100 t/d (?); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 500 - 1500 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000236', 'Manufacture of Glass - NO2 - BAT40-VII', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Electric melting in production of special types of soda-lime glasses and other special glasses and for a limited number of short campaigns or for melting furnaces with a capacity < 100 t/d (?); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 300 - 500 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000237', 'Manufacture of Glass - NO2 - BAT40-VIII', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Fuel/air conventional furnaces in production of special types of soda-lime glasses and other special glasses and for a limited number of short campaigns or for melting furnaces with a capacity < 100 t/d (?); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 1,25 - 3,75 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000238', 'Manufacture of Glass - NO2 - BAT49-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; I. Primary techniques: Combustion modifications (i); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 600 - 800 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000239', 'Manufacture of Glass - NO2 - BAT49-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; I. Primary techniques: Electric melting (ii); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000240', 'Manufacture of Glass - NO2 - BAT49-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; II. Secondary techniques; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 500 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000241', 'Manufacture of Glass - NO2 - BAT49-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; I. Primary techniques: Combustion modifications (i); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 1,5 - 3,2 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000242', 'Manufacture of Glass - NO2 - BAT49-V', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; I. Primary techniques: Electric melting (ii); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 0,25 - 0,4 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000243', 'Manufacture of Glass - NO2 - BAT49-VI', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; I. Primary techniques: Oxy-fuel melting (iii); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 1 - 3 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000244', 'Manufacture of Glass - NO2 - BAT49-VII', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; II. Secondary techniques; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 1 - 3 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000245', 'Manufacture of Glass - NO2 - BAT50-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Primary or secondary techniques (see table) combined with minimisation of nitrate input; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 500 - 1000 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000246', 'Manufacture of Glass - NO2 - BAT50-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Primary or secondary techniques (see table) combined with minimisation of nitrate input; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 1 - 6 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000247', 'Manufacture of Glass - NO2 - BAT57-I', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; For glass wool: Fuel/air (i) and electric furnaces (ii); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 200 - 500 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000248', 'Manufacture of Glass - NO2 - BAT57-II', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; For stone wool: All types of furnaces; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 400 - 500 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000249', 'Manufacture of Glass - NO2 - BAT57-III', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; For glass wool: Fuel/air (i) and electric furnaces (ii); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 0,4 - 1 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000250', 'Manufacture of Glass - NO2 - BAT57-IV', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; For glass wool: Oxy-fuel melting (iii); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 0,5 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000251', 'Manufacture of Glass - NO2 - BAT57-V', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; For stone wool: All types of furnaces; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 1 - 1,25 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000252', 'Manufacture of Glass - NO2 - BAT58-I', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Primary techniques (i)-(iii) combined with minimisation of nitrate input; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 500 - 700 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000253', 'Manufacture of Glass - NO2 - BAT58-II', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Primary techniques (i)-(iii) combined with minimisation of nitrate input; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 1 - 1,4 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000254', 'Manufacture of Glass - NO2 - BAT63-XIII', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(v) (see table); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 100 - 200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000255', 'Manufacture of Glass - NO2 - BAT63-XX', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(v) (see table); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 1 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000256', 'Manufacture of Glass - NO2 - BAT66', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Lubricant burn-off oven with combustion control and/or modifications (see table); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 100 - 200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000257', 'Manufacture of Glass - NO2 - BAT72-I', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Primary techniques: Fuel/air, fuel/oxygen- enriched air combustion, without nitrates; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 500 - 1000 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000258', 'Manufacture of Glass - NO2 - BAT72-II', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Primary techniques: Fuel/air, fuel/oxygen- enriched air combustion, with use of nitrates; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 1600 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000259', 'Manufacture of Glass - NO2 - BAT72-III', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Primary techniques: Oxy-fuel firing, without nitrates; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 2,5 - 5 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000260', 'Manufacture of Glass - NO2 - BAT72-IV', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Primary techniques: Oxy-fuel firing, with use of nitrates; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 5 - 10 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000261', 'Manufacture of Glass - NO2 - BAT72-V', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Primary techniques: Fuel/air, fuel/oxygen- enriched air combustion, without nitrates; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 2,5 - 7,5 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000262', 'Manufacture of Glass - NO2 - BAT72-VI', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Primary techniques: Fuel/air, fuel/oxygen- enriched air combustion, with use of nitrates; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 12 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000263', 'Manufacture of Glass - Ni - BAT13-XVI', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day Reducing nickel to water. The BAT-AEL emission level is  < 0,5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000264', 'Manufacture of Glass - Pb - BAT13-VII', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day Reducing lead to water. The BAT-AEL emission level is < 0,05 - 0,3 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000265', 'Manufacture of Glass - Pb - BAT45-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table); Reducing lead compounds emissions to air. The BAT-AEL emission level is < 0,5 - 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000266', 'Manufacture of Glass - Pb - BAT45-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table); Reducing lead compounds emissions to air. The BAT-AEL emission level is < 0,001 - 0,003 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000267', 'Manufacture of Glass - Pb - BAT46-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(ii) (see table); Reducing lead emissions to air. The BAT-AEL emission level is < 1 - 1,5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000268', 'Manufacture of Glass - SO2 - BAT19-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table), and natural gas; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 200 - 500 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000269', 'Manufacture of Glass - SO2 - BAT19-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table), and fuel oil; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 500 - 1200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000270', 'Manufacture of Glass - SO2 - BAT19-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table), and natural gas; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 0,3 - 0,75 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000271', 'Manufacture of Glass - SO2 - BAT19-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table), and fuel oil; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 0,75 - 1,8 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000272', 'Manufacture of Glass - SO2 - BAT23', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(ii) (see table); Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 100 - 200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000273', 'Manufacture of Glass - SO2 - BAT27-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table), and natural gas; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 300 - 500 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000274', 'Manufacture of Glass - SO2 - BAT27-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table), and fuel oil; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is 500 - 1300 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000275', 'Manufacture of Glass - SO2 - BAT27-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table), and natural gas; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 0,75 - 1,25 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000276', 'Manufacture of Glass - SO2 - BAT27-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table), and fuel oil; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is 1,25 - 3,25 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000277', 'Manufacture of Glass - SO2 - BAT31-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table); Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is  < 200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000278', 'Manufacture of Glass - SO2 - BAT34-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table), and natural gas; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 200 - 800 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000279', 'Manufacture of Glass - SO2 - BAT34-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table), and fuel oil; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 500 - 1000 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000280', 'Manufacture of Glass - SO2 - BAT34-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table), and natural gas; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 0,9 - 3,6 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000281', 'Manufacture of Glass - SO2 - BAT34-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iv) (see table), and fuel oil; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 2,25 - 4,5 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000282', 'Manufacture of Glass - SO2 - BAT41-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table), and natural gas; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 200 - 300 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000283', 'Manufacture of Glass - SO2 - BAT41-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table), and fuel oil; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is  < 1000 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000284', 'Manufacture of Glass - SO2 - BAT41-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table), and electric melting; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is  < 100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000285', 'Manufacture of Glass - SO2 - BAT41-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table), and natural gas; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 0,5 - 0,75 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000286', 'Manufacture of Glass - SO2 - BAT41-V', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table), and fuel oil; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is  < 2,5 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000287', 'Manufacture of Glass - SO2 - BAT41-VI', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table), and electric melting; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is  < 0,25 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000288', 'Manufacture of Glass - SO2 - BAT51-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table), and natural gas and/or electric melting; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 30 - 200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000289', 'Manufacture of Glass - SO2 - BAT51-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table), and fuel oil; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is 500 - 800 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000290', 'Manufacture of Glass - SO2 - BAT51-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table), and natural gas and/or electric melting; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 0,08 - 0,5 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000291', 'Manufacture of Glass - SO2 - BAT51-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table), and fuel oil; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is 1,25 - 2 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000292', 'Manufacture of Glass - SO2 - BAT59-I', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iv) (see table); for glass wool: Gas-fired and electric furnaces; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 50 - 150 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000293', 'Manufacture of Glass - SO2 - BAT59-II', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iv) (see table); for stone wool: Gas-fired and electric furnaces; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is  < 350 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000294', 'Manufacture of Glass - SO2 - BAT59-III', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iv) (see table); for stone wool: Cupola furnaces, no briquettes or slag recycling; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is  < 400 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000295', 'Manufacture of Glass - SO2 - BAT59-IV', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iv) (see table); for stone wool: Cupola furnaces, with cement briquettes or slag recycling; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is  < 1400 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000296', 'Manufacture of Glass - SO2 - BAT59-V', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iv) (see table); for glass wool: Gas-fired and electric furnaces; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 0,1 - 0,3 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000297', 'Manufacture of Glass - SO2 - BAT59-VI', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iv) (see table); for stone wool: Gas-fired and electric furnaces; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is  < 0,9 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000298', 'Manufacture of Glass - SO2 - BAT59-VII', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iv) (see table); for stone wool: Cupola furnaces, no briquettes or slag recycling; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is  < 1 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000299', 'Manufacture of Glass - SO2 - BAT59-VIII', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iv) (see table); for stone wool: Cupola furnaces, with cement briquettes or slag recycling; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is  < 3,5 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000300', 'Manufacture of Glass - SO2 - BAT67', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Primary techniques (i)-(ii) (see table); Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is  < 50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000301', 'Manufacture of Glass - SO2 - BAT73-I', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iii) (see table); Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 50 - 200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000302', 'Manufacture of Glass - SO2 - BAT73-II', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(iii) (see table); Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 0,25 - 1,5 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000303', 'Manufacture of Glass - SO4 - BAT13-IV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day Reducing sulphates to water. The BAT-AEL emission level is  < 1000 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000304', 'Manufacture of Glass - Sb - BAT13-VIII', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day Reducing antimony to water. The BAT-AEL emission level is  < 0,5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000305', 'Manufacture of Glass - Se - BAT30-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing selenium compounds emissions to air. The BAT-AEL emission level is 1 - 3 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000306', 'Manufacture of Glass - Se - BAT30-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing selenium compounds emissions to air. The BAT-AEL emission level is 0,0025 - 0,0075 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000307', 'Manufacture of Glass - Se - BAT44-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(ii) (see table); Reducing selenium compounds emissions to air. The BAT-AEL emission level is  < 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000308', 'Manufacture of Glass - Se - BAT44-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(ii) (see table); Reducing selenium compounds emissions to air. The BAT-AEL emission level is  < 0,003 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000309', 'Manufacture of Glass - Sn - BAT13-XV', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day Reducing tin to water. The BAT-AEL emission level is  < 0,5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000310', 'Manufacture of Glass - Sn - BAT22-III', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing tin compounds emissions to air. The BAT-AEL emission level is  < 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000311', 'Manufacture of Glass - THC - BAT13-VI', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day Reducing total hydrocarbons to water. The BAT-AEL emission level is  < 15 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000312', 'Manufacture of Glass - TPM - BAT63-I', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(v) (see table); Reducing total particulate matter emissions to air. The BAT-AEL emission level is < 20 - 50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000313', 'Manufacture of Glass - TPM - BAT63-VII', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(v) (see table); Reducing total particulate matter emissions to air. The BAT-AEL emission level is < 5 - 30 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000314', 'Manufacture of Glass - TPM - BAT63-XIV', '3, Mineral industry: 3,4 Melting mineral substances including the production of mineral fibres with a melting capacity exceeding 20?tonnes per day; Techniques (i)-(v) (see table); Reducing total particulate matter emissions to air. The BAT-AEL emission level is  < 0,2 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000315', 'Manufacture of Glass - TSS - BAT13-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day Reducing total suspended solids to water. The BAT-AEL emission level is  < 30 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000316', 'Manufacture of Glass - Ti - BAT22-II', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day; Techniques (i)-(iii) (see table); Reducing titanium compounds emissions to air. The BAT-AEL emission level is  < 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000317', 'Manufacture of Glass - Zn - BAT13-XI', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day Reducing zinc to water. The BAT-AEL emission level is  < 0,5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000318', 'Manufacture of Glass - pH - BAT13-I', '3, Mineral industry: 3,3 Manufacture of glass including glass fibre with a melting capacity exceeding 20 tonnes per day Reducing pH to water. The BAT-AEL emission level is 6,5 ? 9.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000319', 'Intensive rearing of poultry or pigs - NH3 - BAT30-I', '6.? Other activities: 6.6 (c): Intensive rearing of poultry or pigs with more than 750 places for sows - mating and gestating sows; Techniques (a)-(e) (see table incl. footnote) for mating and gestating sows; Reducing ammonia emissions to air. The BAT-AEL emission level is 0,2-2,7 kg NH3/animal place/year.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000320', 'Intensive rearing of poultry or pigs - NH3 - BAT30-II', '6.? Other activities: 6.6 (c): Intensive rearing of poultry or pigs with more than 750 places for sows - farrowing sows (including piglets) in crates; Techniques (a)-(e) (see table incl. footnote) for farrowing sows (including piglets) in crates; Reducing ammonia emissions to air. The BAT-AEL emission level is 0,4-5,6 kg NH3/animal place/year.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000321', 'Intensive rearing of poultry or pigs - NH3 - BAT30-III', '6.? Other activities: 6.6 (c): Intensive rearing of poultry or pigs with more than 750 places for sows - weaners; Techniques (a)-(e) (see table incl. footnote) for weaners; Reducing ammonia emissions to air. The BAT-AEL emission level is 0,03-0,53 kg NH3/animal place/year.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000322', 'Intensive rearing of poultry or pigs - NH3 - BAT30-IV', '6.? Other activities: 6.6 (b): Intensive rearing of poultry or pigs with more than 2 000 places for production pigs (over 30 kg) - fattening pigs; Techniques (a)-(e) (see table incl. footnote) for fattening pigs; Reducing ammonia emissions to air. The BAT-AEL emission level is 0,1-2,6 kg NH3/animal place/year.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000323', 'Intensive rearing of poultry or pigs - NH3 - BAT31-I', '6.? Other activities: 6.6 (a): Intensive rearing of poultry or pigs with more than 40 000 places for poultry; Techniques (a)-(c) (see table incl. footnote) for fattening pigs for cage systems; Reducing ammonia emissions to air. The BAT-AEL emission level is 0,02-0,08 kg NH3/animal place/year.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000324', 'Intensive rearing of poultry or pigs - NH3 - BAT31-II', '6.? Other activities: 6.6 (a): Intensive rearing of poultry or pigs with more than 40 000 places for poultry; Techniques (a)-(c) (see table incl. footnote) for fattening pigs for non-cage systems; Reducing ammonia emissions to air. The BAT-AEL emission level is 0,02-0,13 kg NH3/animal place/year.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000325', 'Intensive rearing of poultry or pigs - NH3 - BAT32', '6.? Other activities: 6.6 (a): Intensive rearing of poultry or pigs with more than 40 000 places for poultry; Techniques (a)-(f) (see table incl. footnote); Reducing ammonia emissions to air. The BAT-AEL emission level is 0,01-0,08 kg NH3/animal place/year.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000326', 'Iron and Steel Production - BOD5 - BAT56-II', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke Reducing biological oxygen demand for 5 days (BOD5) to water. The BAT-AEL emission level is  < 20 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000327', 'Iron and Steel Production - CN - BAT56-V', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke Reducing cyanide (CN-) to water. The BAT-AEL emission level is  < 0,1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000328', 'Iron and Steel Production - CN - BAT67-V', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour Reducing cyanide (CN-) to water. The BAT-AEL emission level is  < 0,4 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000329', 'Iron and Steel Production - COD - BAT28-II', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is  < 100 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000330', 'Iron and Steel Production - COD - BAT39-II', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is  < 160 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000331', 'Iron and Steel Production - COD - BAT56-I', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is  < 220 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000332', 'Iron and Steel Production - Cr - BAT81-V', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour Reducing total chromium to water. The BAT-AEL emission level is  < 0,5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000333', 'Iron and Steel Production - Cr - BAT92-V', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour Reducing total chromium to water. The BAT-AEL emission level is  < 0,5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000334', 'Iron and Steel Production - Dust - BAT20-I', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering; Bag filter for new and existing plants; Reducing dust emissions to air. The BAT-AEL emission level is < 1 - 15 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000335', 'Iron and Steel Production - Dust - BAT20-II', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering; Advanced electrostatic precipitators for existing plants, when bag filters are not applicable; Reducing dust emissions to air. The BAT-AEL emission level is < 20 - 40 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000336', 'Iron and Steel Production - Dust - BAT26-I', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering; Bag filter; Reducing dust emissions to air. The BAT-AEL emission level is  < 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000337', 'Iron and Steel Production - Dust - BAT26-II', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering; Electrostatic precipitator; Reducing dust emissions to air. The BAT-AEL emission level is  < 30 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000338', 'Iron and Steel Production - Dust - BAT33-I', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering; Crushing, grinding and drying; Reducing dust emissions to air. The BAT-AEL emission level is  < 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000339', 'Iron and Steel Production - Dust - BAT33-II', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering; All other process steps or where all waste gases are treated together; Reducing dust emissions to air. The BAT-AEL emission level is < 10 - 15 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000340', 'Iron and Steel Production - Dust - BAT42', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke; Coal grinding plants, techniques (I.)-(II.) (see list); Reducing dust emissions to air. The BAT-AEL emission level is < 10 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000341', 'Iron and Steel Production - Dust - BAT43', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke; Using efficient extraction and subsequent dedusting (technique (V.); Reducing dust emissions to air. The BAT-AEL emission level is < 10 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000342', 'Iron and Steel Production - Dust - BAT44-I', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke; Coal charging systems with land-based treatment of extracted gases; Reducing dust emissions to air. The BAT-AEL emission level is  < 5 g/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000343', 'Iron and Steel Production - Dust - BAT44-II', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke; Coal charging systems with land-based treatment of extracted gases; Reducing dust emissions to air. The BAT-AEL emission level is  < 50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000344', 'Iron and Steel Production - Dust - BAT49-II', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke; Techniques (I.)-(IV.) (see list); Reducing dust emissions to air. The BAT-AEL emission level is < 1 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000345', 'Iron and Steel Production - Dust - BAT50-I', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke; Bag filters; Reducing dust emissions to air. The BAT-AEL emission level is  < 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000346', 'Iron and Steel Production - Dust - BAT50-II', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke; Other cases; Reducing dust emissions to air. The BAT-AEL emission level is  < 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000347', 'Iron and Steel Production - Dust - BAT51-I', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke; Coke dry quenching (CDQ); Reducing dust emissions to air. The BAT-AEL emission level is  < 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000348', 'Iron and Steel Production - Dust - BAT51-II', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke; Emission-minimised conventional wet quenching; Reducing dust emissions to air. The BAT-AEL emission level is  < 25 g/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000349', 'Iron and Steel Production - Dust - BAT51-III', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke; Coke stabilisation quenching (CSQ); Reducing dust emissions to air. The BAT-AEL emission level is  < 10 g/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000350', 'Iron and Steel Production - Dust - BAT52', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke; Techniques (I.)-(II.) (see list); Reducing dust emissions to air. The BAT-AEL emission level is  < 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000351', 'Iron and Steel Production - Dust - BAT59', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour; Dust capture and dry dedusting; Reducing dust emissions to air. The BAT-AEL emission level is  < 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000352', 'Iron and Steel Production - Dust - BAT61', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour; BAT II (see list); Reducing dust emissions to air. The BAT-AEL emission level is < 1 - 15 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000353', 'Iron and Steel Production - Dust - BAT64', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour; Techniques (I)-(II) (see list); Reducing dust emissions to air. The BAT-AEL emission level is < 10 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000354', 'Iron and Steel Production - Dust - BAT65-II', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour; Desulphurised and dedusted surplus coke oven gas, dedusted blast furnace gas, dedusted basic oxygen furnace gas and natural gas; Reducing dust emissions to air. The BAT-AEL emission level is  < 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000355', 'Iron and Steel Production - Dust - BAT75-I', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour; BAT III.i (see list); Reducing dust emissions to air. The BAT-AEL emission level is 10 ? 30 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000356', 'Iron and Steel Production - Dust - BAT75-II', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour; BAT III.ii (see list); Reducing dust emissions to air. The BAT-AEL emission level is < 50 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000357', 'Iron and Steel Production - Dust - BAT76-I', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour; BAT I (see list) for new and existing plants; Reducing dust emissions to air. The BAT-AEL emission level is 10 - 30 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000358', 'Iron and Steel Production - Dust - BAT76-II', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour; BAT II (see list) for existing plants; Reducing dust emissions to air. The BAT-AEL emission level is  < 50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000359', 'Iron and Steel Production - Dust - BAT78-I', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour; Bag filter; Reducing dust emissions to air. The BAT-AEL emission level is < 1 - 15 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000360', 'Iron and Steel Production - Dust - BAT78-II', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour; ESP; Reducing dust emissions to air. The BAT-AEL emission level is  < 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000361', 'Iron and Steel Production - Dust - BAT78-III', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour; Bag filter; Reducing dust emissions to air. The BAT-AEL emission level is < 1 - 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000362', 'Iron and Steel Production - Dust - BAT78-IV', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour; ESP; Reducing dust emissions to air. The BAT-AEL emission level is  < 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000363', 'Iron and Steel Production - Dust - BAT79', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour; BAT I (see list); Reducing dust emissions to air. The BAT-AEL emission level is < 10 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000364', 'Iron and Steel Production - Dust - BAT88-I', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour; Techniques (I.)-(III.) (see list) and dedusting by bag filter; Reducing dust emissions to air. The BAT-AEL emission level is  < 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000365', 'Iron and Steel Production - Dust - BAT90', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour; BAT I; Reducing dust emissions to air. The BAT-AEL emission level is < 10 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000366', 'Iron and Steel Production - Fe - BAT67-II', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour Reducing iron to water. The BAT-AEL emission level is  < 5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000367', 'Iron and Steel Production - Fe - BAT81-II', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour Reducing iron to water. The BAT-AEL emission level is  < 5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000368', 'Iron and Steel Production - Fe - BAT92-II', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour Reducing iron to water. The BAT-AEL emission level is  < 5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000369', 'Iron and Steel Production - H2S - BAT48-I', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke; Technique (I.) (see list); Reducing hydrogen sulphide emissions to air. The BAT-AEL emission level is < 300 ? 1 000 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000370', 'Iron and Steel Production - H2S - BAT48-II', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke; Technique (II.) (see list); Reducing hydrogen sulphide emissions to air. The BAT-AEL emission level is < 10 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000371', 'Iron and Steel Production - HCl - BAT34-III', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering; Wet scrubber, semi-dry absorption with a subsequent dedusting system; Reducing hydrogen chloride (HCl) emissions to air. The BAT-AEL emission level is < 1 - 3 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000372', 'Iron and Steel Production - HF - BAT34-II', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering; Wet scrubber, semi-dry absorption with a subsequent dedusting system; Reducing hydrogen fluoride (HF) emissions to air. The BAT-AEL emission level is < 1 - 3 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000373', 'Iron and Steel Production - Hg - BAT21', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering; Waste gas treatment with activated carbon or lignite coke injection; Reducing mercury emissions to air. The BAT-AEL emission level is < 0,03 - 0,05 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000374', 'Iron and Steel Production - Hg - BAT88-II', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour; Techniques (I.)-(III.) (see list) and dedusting by bag filter; Reducing mercury emissions to air. The BAT-AEL emission level is  < 0,05 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000375', 'Iron and Steel Production - Metals - BAT28-III', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering Reducing heavy metals to water. The BAT-AEL emission level is  < 0,1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000376', 'Iron and Steel Production - Metals - BAT39-IV', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering Reducing heavy metals to water. The BAT-AEL emission level is  < 0,55 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000377', 'Iron and Steel Production - NO2 - BAT23-I', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering; Process integrated measures (I.); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 500 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000378', 'Iron and Steel Production - NO2 - BAT23-II', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering; RAC (II.i); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 250 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000379', 'Iron and Steel Production - NO2 - BAT23-III', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering; SCR (II.ii); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 120 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000380', 'Iron and Steel Production - NO2 - BAT49-III', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke; Techniques (I.)-(IV.) (see list) for New or substantially revamped plants (< 10 years old); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 350 - 500 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000381', 'Iron and Steel Production - NO2 - BAT49-IV', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke; Techniques (I.)-(IV.) (see list) for Older plants (> 10 years old); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 500 - 650 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000382', 'Iron and Steel Production - NO2 - BAT65-III', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour; Desulphurised and dedusted surplus coke oven gas, dedusted blast furnace gas, dedusted basic oxygen furnace gas and natural gas; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is  < 100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000383', 'Iron and Steel Production - Ni - BAT81-IV', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour Reducing nickel to water. The BAT-AEL emission level is  < 0,5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000384', 'Iron and Steel Production - Ni - BAT92-IV', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour Reducing nickel to water. The BAT-AEL emission level is  < 0,5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000385', 'Iron and Steel Production - PAH - BAT56-VI', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke Reducing polycyclic aromatic hydrocarbons (PAH) to water. The BAT-AEL emission level is  < 0,05 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000386', 'Iron and Steel Production - PCDD.F - BAT25-I', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering; Bag filter; Reducing polychlorinated dibenzodioxins/ furans (PCDD/F) emissions to air. The BAT-AEL emission level is < 0,05 - 0,2 ng/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000387', 'Iron and Steel Production - PCDD.F - BAT25-II', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering; Advanced electrostatic precipitator; Reducing polychlorinated dibenzodioxins/ furans (PCDD/F) emissions to air. The BAT-AEL emission level is < 0,2 - 0,4 ng/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000388', 'Iron and Steel Production - PCDD.F - BAT89', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour; Techniques (I.)-(III.) (see list); Reducing polychlorinated dibenzodioxins/ furans (PCDD/F) emissions to air. The BAT-AEL emission level is  < 0,1 ng/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000389', 'Iron and Steel Production - Pb - BAT67-III', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour Reducing lead to water. The BAT-AEL emission level is  < 0,5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000390', 'Iron and Steel Production - Phenols - BAT56-VII', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke Reducing phenols to water. The BAT-AEL emission level is  < 0,5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000391', 'Iron and Steel Production - S - BAT56-III', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke Reducing sulphides to water. The BAT-AEL emission level is  < 0,1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000392', 'Iron and Steel Production - SCN - BAT56-IV', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke Reducing thiocyanate (SCN-) to water. The BAT-AEL emission level is  < 4 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000393', 'Iron and Steel Production - SO2 - BAT22-I', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering; BAT I - IV (see list); Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 350 - 500 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000394', 'Iron and Steel Production - SO2 - BAT22-II', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering; BAT V (see list); Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is  < 100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000395', 'Iron and Steel Production - SO2 - BAT34-I', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering; Wet scrubber, semi-dry absorption with a subsequent dedusting system; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 30 - 50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000396', 'Iron and Steel Production - SO2 - BAT49-I', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke; Techniques (I.)-(IV.) (see list); Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is < 200 - 500 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000397', 'Iron and Steel Production - SO2 - BAT65-I', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour; Desulphurised and dedusted surplus coke oven gas, dedusted blast furnace gas, dedusted basic oxygen furnace gas and natural gas; Reducing sulphur oxides (SOx) emissions to air. The BAT-AEL emission level is  < 200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000398', 'Iron and Steel Production - SS - BAT28-I', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering Reducing suspended solids to water. The BAT-AEL emission level is  < 30 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000399', 'Iron and Steel Production - SS - BAT39-I', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering Reducing suspended solids to water. The BAT-AEL emission level is  < 50 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000400', 'Iron and Steel Production - SS - BAT67-I', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour Reducing suspended solids to water. The BAT-AEL emission level is  < 30 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000401', 'Iron and Steel Production - SS - BAT81-I', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour Reducing suspended solids to water. The BAT-AEL emission level is  < 20 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000402', 'Iron and Steel Production - SS - BAT92-I', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour Reducing suspended solids to water. The BAT-AEL emission level is  < 20 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000403', 'Iron and Steel Production - THC - BAT81-VI', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour Reducing total hydrocarbons to water. The BAT-AEL emission level is  < 5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000404', 'Iron and Steel Production - THC - BAT92-VI', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour Reducing total hydrocarbons to water. The BAT-AEL emission level is  < 5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000405', 'Iron and Steel Production - TKN - BAT39-III', '2, Production and processing of metals: 2,1 Metal ore (including sulphide ore) roasting or sintering Reducing kjeldahl nitrogen to water. The BAT-AEL emission level is  < 45 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000406', 'Iron and Steel Production - TN - BAT56-VIII', '1, Energy industries undertaking activities related to 2.2: 1,3 Production of coke Reducing sum of ammonia-nitrogen (NH4+ - N), nitrate-nitrogen (NO3- - N) and nitrite-nitrogen (NO2- - N) to water. The BAT-AEL emission level is < 15 - 50 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000407', 'Iron and Steel Production - Zn - BAT67-IV', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour Reducing zinc to water. The BAT-AEL emission level is  < 2 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000408', 'Iron and Steel Production - Zn - BAT81-III', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour Reducing zinc to water. The BAT-AEL emission level is  < 2 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000409', 'Iron and Steel Production - Zn - BAT92-III', '2, Production and processing of metals: 2,2 Production of pig iron or steel (primary or secondary fusion) including continuous casting, with a capacity exceeding 2,5?tonnes per hour Reducing zinc to water. The BAT-AEL emission level is  < 2 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000410', 'Large combustion plants  - CH4 - BAT45-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for New plant; Reducing methane emissions to air. The BAT-AEL emission level is 215?500 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000411', 'Large combustion plants  - CH4 - BAT45-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for Existing plant; Reducing methane emissions to air. The BAT-AEL emission level is 215?560 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000412', 'Large combustion plants  - As - BAT15-VIII', '1.? Energy industries; 5.? Waste management: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; 5.2, Disposal or recovery of waste in waste co-incineration plants for non-hazardous waste with a capacity exceeding 3 tonnes per hour or for hazardous waste with a capacity exceeding 10 tonnes per day, only when this activity takes place in combustion plants covered under 1.1 above. Reducing arsenic to water. The BAT-AEL emission level is 10?50 ?g/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000413', 'Large combustion plants  - COD - BAT15-II', '1.? Energy industries; 5.? Waste management: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; 5.2, Disposal or recovery of waste in waste co-incineration plants for non-hazardous waste with a capacity exceeding 3 tonnes per hour or for hazardous waste with a capacity exceeding 10 tonnes per day, only when this activity takes place in combustion plants covered under 1.1 above. Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is 60?150 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000414', 'Large combustion plants  - Cd - BAT15-IX', '1.? Energy industries; 5.? Waste management: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; 5.2, Disposal or recovery of waste in waste co-incineration plants for non-hazardous waste with a capacity exceeding 3 tonnes per hour or for hazardous waste with a capacity exceeding 10 tonnes per day, only when this activity takes place in combustion plants covered under 1.1 above. Reducing cadmium to water. The BAT-AEL emission level is 2?5 ?g/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000415', 'Large combustion plants  - Cr - BAT15-X', '1.? Energy industries; 5.? Waste management: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; 5.2, Disposal or recovery of waste in waste co-incineration plants for non-hazardous waste with a capacity exceeding 3 tonnes per hour or for hazardous waste with a capacity exceeding 10 tonnes per day, only when this activity takes place in combustion plants covered under 1.1 above. Reducing chromium to water. The BAT-AEL emission level is 10?50 ?g/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000416', 'Large combustion plants  - Cu - BAT15-XI', '1.? Energy industries; 5.? Waste management: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; 5.2, Disposal or recovery of waste in waste co-incineration plants for non-hazardous waste with a capacity exceeding 3 tonnes per hour or for hazardous waste with a capacity exceeding 10 tonnes per day, only when this activity takes place in combustion plants covered under 1.1 above. Reducing copper to water. The BAT-AEL emission level is 10?50 ?g/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000417', 'Large combustion plants  - Dust - BAT22-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000418', 'Large combustion plants  - Dust - BAT22-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?18 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000419', 'Large combustion plants  - Dust - BAT22-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 4?16 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000420', 'Large combustion plants  - Dust - BAT22-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 4?22 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000421', 'Large combustion plants  - Dust - BAT22-IX', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000422', 'Large combustion plants  - Dust - BAT22-V', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000423', 'Large combustion plants  - Dust - BAT22-VI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?14 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000424', 'Large combustion plants  - Dust - BAT22-VII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 3?15 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000425', 'Large combustion plants  - Dust - BAT22-VIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 4?22 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000426', 'Large combustion plants  - Dust - BAT22-X', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000427', 'Large combustion plants  - Dust - BAT22-XI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 3?15 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000428', 'Large combustion plants  - Dust - BAT22-XII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 4?22 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000429', 'Large combustion plants  - Dust - BAT22-XIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000430', 'Large combustion plants  - Dust - BAT22-XIV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?8 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000431', 'Large combustion plants  - Dust - BAT22-XV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 3?10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000432', 'Large combustion plants  - Dust - BAT22-XVI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 3?11 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000433', 'Large combustion plants  - Dust - BAT26-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000434', 'Large combustion plants  - Dust - BAT26-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?15 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000435', 'Large combustion plants  - Dust - BAT26-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000436', 'Large combustion plants  - Dust - BAT26-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?22 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000437', 'Large combustion plants  - Dust - BAT26-IX', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000438', 'Large combustion plants  - Dust - BAT26-V', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000439', 'Large combustion plants  - Dust - BAT26-VI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?12 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000440', 'Large combustion plants  - Dust - BAT26-VII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000441', 'Large combustion plants  - Dust - BAT26-VIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?18 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000442', 'Large combustion plants  - Dust - BAT26-X', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000443', 'Large combustion plants  - Dust - BAT26-XI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000444', 'Large combustion plants  - Dust - BAT26-XII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?16 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000445', 'Large combustion plants  - Dust - BAT30-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(f) (see table) for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000446', 'Large combustion plants  - Dust - BAT30-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(f) (see table) for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000447', 'Large combustion plants  - Dust - BAT30-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(f) (see table) for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 7?18 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000448', 'Large combustion plants  - Dust - BAT30-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(f) (see table) for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 7?22 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000449', 'Large combustion plants  - Dust - BAT30-V', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(f) (see table) for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000450', 'Large combustion plants  - Dust - BAT30-VI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(f) (see table) for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000451', 'Large combustion plants  - Dust - BAT30-VII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(f) (see table) for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 7?10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000452', 'Large combustion plants  - Dust - BAT30-VIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(f) (see table) for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 7?11 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000453', 'Large combustion plants  - Dust - BAT35-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(c) (see table) for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 5?10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000454', 'Large combustion plants  - Dust - BAT35-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(c) (see table) for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 5?35 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000455', 'Large combustion plants  - Dust - BAT35-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(c) (see table) for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 10?20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000456', 'Large combustion plants  - Dust - BAT35-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(c) (see table) for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 10?45 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000457', 'Large combustion plants  - Dust - BAT39-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Technique (a) (see table) for new and existing plants; Reducing dust emissions to air. The BAT-AEL emission level is 2?5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000458', 'Large combustion plants  - Dust - BAT39-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Technique (a) (see table) for new and existing plants; Reducing dust emissions to air. The BAT-AEL emission level is 2?10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000459', 'Large combustion plants  - Dust - BAT51-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) in boilers; Reducing dust emissions to air. The BAT-AEL emission level is 2?7 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000460', 'Large combustion plants  - Dust - BAT51-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) in boilers; Reducing dust emissions to air. The BAT-AEL emission level is 2?10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000461', 'Large combustion plants  - Dust - BAT51-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) in combined-cycle gas turbines (CCGTs); Reducing dust emissions to air. The BAT-AEL emission level is 2?5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000462', 'Large combustion plants  - Dust - BAT51-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table) in combined-cycle gas turbines (CCGTs); Reducing dust emissions to air. The BAT-AEL emission level is 2?5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000463', 'Large combustion plants  - Dust - BAT58-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table). for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000464', 'Large combustion plants  - Dust - BAT58-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table). for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?15 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000465', 'Large combustion plants  - Dust - BAT58-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table). for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000466', 'Large combustion plants  - Dust - BAT58-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table). for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?22 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000467', 'Large combustion plants  - Dust - BAT58-V', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table). for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000468', 'Large combustion plants  - Dust - BAT58-VI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table). for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000469', 'Large combustion plants  - Dust - BAT58-VII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table). for New plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000470', 'Large combustion plants  - Dust - BAT58-VIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table). for Existing plant; Reducing dust emissions to air. The BAT-AEL emission level is 2?11 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000471', 'Large combustion plants  - Dust - BAT75-III', '1. Energy industries: 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; Techniques (a)-(c) (see table); Reducing dust emissions to air. The BAT-AEL emission level is < 2,5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000472', 'Large combustion plants  - F - BAT15-IV', '1.? Energy industries; 5.? Waste management: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; 5.2, Disposal or recovery of waste in waste co-incineration plants for non-hazardous waste with a capacity exceeding 3 tonnes per hour or for hazardous waste with a capacity exceeding 10 tonnes per day, only when this activity takes place in combustion plants covered under 1.1 above. Reducing fluorides to water. The BAT-AEL emission level is 10?25 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000473', 'Large combustion plants  - Formaldehyde - BAT45-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for New or existing plan; Reducing formaldehyde emissions to air. The BAT-AEL emission level is 5?15 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000474', 'Large combustion plants  - HCl - BAT21-XIX', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) for New plant; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 1?3 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000475', 'Large combustion plants  - HCl - BAT21-XVII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) for New plant; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 1?6 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000476', 'Large combustion plants  - HCl - BAT21-XVIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) for Existing plant; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 2?10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000477', 'Large combustion plants  - HCl - BAT21-XX', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) for Existing plant; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 1?5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000478', 'Large combustion plants  - HCl - BAT25-XIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for New plant; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 1?7 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000479', 'Large combustion plants  - HCl - BAT25-XIV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for Existing plant; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 1?15 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000480', 'Large combustion plants  - HCl - BAT25-XIX', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for New plant; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 1?12 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000481', 'Large combustion plants  - HCl - BAT25-XV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for New plant; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 1?12 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000482', 'Large combustion plants  - HCl - BAT25-XVI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for Existing plant; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 1?35 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000483', 'Large combustion plants  - HCl - BAT25-XVII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for New plant; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 1?5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000484', 'Large combustion plants  - HCl - BAT25-XVIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for Existing plant; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 1?9 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000485', 'Large combustion plants  - HCl - BAT25-XX', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for Existing plant; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 1?12 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000486', 'Large combustion plants  - HCl - BAT25-XXI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for New plant; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 1?5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000487', 'Large combustion plants  - HCl - BAT25-XXII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for Existing plant; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 1?5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000488', 'Large combustion plants  - HCl - BAT25-XXIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for New plant; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 1?12 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000489', 'Large combustion plants  - HCl - BAT25-XXIV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for Existing plant; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 1?12 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000490', 'Large combustion plants  - HCl - BAT57-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table). for New plant; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 1?7 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000491', 'Large combustion plants  - HCl - BAT57-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table). for Existing plant; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 2?15 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000492', 'Large combustion plants  - HCl - BAT57-VII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table). for New plant; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 1?5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000493', 'Large combustion plants  - HCl - BAT57-VIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table). for Existing plant; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 1?9 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000494', 'Large combustion plants  - HF - BAT21-XXI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) for New plant; Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 1?3 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000495', 'Large combustion plants  - HF - BAT21-XXII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) for Existing plant; Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 1?6 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000496', 'Large combustion plants  - HF - BAT21-XXIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) for New plant; Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 1?2 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000497', 'Large combustion plants  - HF - BAT21-XXIV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) for Existing plant; Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 1?3 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000498', 'Large combustion plants  - HF - BAT25-XXIX', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for New plant; Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000499', 'Large combustion plants  - HF - BAT25-XXV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for New plant; Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000500', 'Large combustion plants  - HF - BAT25-XXVI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for Existing plant; Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 1,5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000501', 'Large combustion plants  - HF - BAT25-XXVII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for New plant; Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000502', 'Large combustion plants  - HF - BAT25-XXVIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for Existing plant; Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000503', 'Large combustion plants  - HF - BAT25-XXX', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for Existing plant; Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000504', 'Large combustion plants  - HF - BAT57-IX', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table). for New plant; Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 1?2 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000505', 'Large combustion plants  - HF - BAT57-V', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table). for New plant; Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 1?3 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000506', 'Large combustion plants  - HF - BAT57-VI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table). for Existing plant; Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 1?6 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000507', 'Large combustion plants  - HF - BAT57-X', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table). for Existing plant; Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is < 1?3 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000508', 'Large combustion plants  - Hg - BAT15-XII', '1.? Energy industries; 5.? Waste management: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; 5.2, Disposal or recovery of waste in waste co-incineration plants for non-hazardous waste with a capacity exceeding 3 tonnes per hour or for hazardous waste with a capacity exceeding 10 tonnes per day, only when this activity takes place in combustion plants covered under 1.1 above. Reducing mercury to water. The BAT-AEL emission level is 0,2?3 ?g/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000509', 'Large combustion plants  - Hg - BAT23-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table) for New plant; Reducing mercury emissions to air. The BAT-AEL emission level is < 1?3 ?g/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000510', 'Large combustion plants  - Hg - BAT23-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table) for New plant; Reducing mercury emissions to air. The BAT-AEL emission level is < 1?5 ?g/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000511', 'Large combustion plants  - Hg - BAT23-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table) for Existing plant; Reducing mercury emissions to air. The BAT-AEL emission level is < 1?9 ?g/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000512', 'Large combustion plants  - Hg - BAT23-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table) for Existing plant; Reducing mercury emissions to air. The BAT-AEL emission level is < 1?10 ?g/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000513', 'Large combustion plants  - Hg - BAT23-V', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table) for New plant; Reducing mercury emissions to air. The BAT-AEL emission level is < 1?2 ?g/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000514', 'Large combustion plants  - Hg - BAT23-VI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table) for New plant; Reducing mercury emissions to air. The BAT-AEL emission level is < 1?4 ?g/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000515', 'Large combustion plants  - Hg - BAT23-VII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table) for Existing plant; Reducing mercury emissions to air. The BAT-AEL emission level is < 1?4 ?g/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000516', 'Large combustion plants  - Hg - BAT23-VIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table) for Existing plant; Reducing mercury emissions to air. The BAT-AEL emission level is < 1?7 ?g/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000517', 'Large combustion plants  - Hg - BAT27', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table); Reducing mercury emissions to air. The BAT-AEL emission level is < 1?5 ?g/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000518', 'Large combustion plants  - Hg - BAT75-II', '1. Energy industries: 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; Techniques (a)-(c) (see table); Reducing particulate-bound mercury emissions to air. The BAT-AEL emission level is < 1 ?g/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000519', 'Large combustion plants  - Metals - BAT68-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Use one or a combination of the techniques given in BAT 22; Reducing metals emissions to air. The BAT-AEL emission level is 0,005?0,5 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000520', 'Large combustion plants  - Metals - BAT68-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Use one or a combination of the techniques given in BAT 22; Reducing metals emissions to air. The BAT-AEL emission level is 5?12 ?g/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000521', 'Large combustion plants  - Metals - BAT68-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Use one or a combination of the techniques given in BAT 22; Reducing metals emissions to air. The BAT-AEL emission level is 0,005?0,2 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000522', 'Large combustion plants  - Metals - BAT68-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Use one or a combination of the techniques given in BAT 22; Reducing metals emissions to air. The BAT-AEL emission level is 5?6 ?g/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000523', 'Large combustion plants  - Metals - BAT69-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Use one or a combination of the techniques given in BAT 26; Reducing metals emissions to air. The BAT-AEL emission level is 0,075?0,3 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000524', 'Large combustion plants  - Metals - BAT69-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Use one or a combination of the techniques given in BAT 26; Reducing metals emissions to air. The BAT-AEL emission level is < 5 ?g/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000525', 'Large combustion plants  - Metals - BAT75-I', '1. Energy industries: 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; Techniques (a)-(c) (see table); Reducing particulate-bound metals emissions to air. The BAT-AEL emission level is < 0,025 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000526', 'Large combustion plants  - NH3 - BAT7', '1.? Energy industries; 5.? Waste management: 1.1Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; 5.2, Disposal or recovery of waste in waste co-incineration plants for non-hazardous waste with a capacity exceeding 3 tonnes per hour or for hazardous waste with a capacity exceeding 10 tonnes per day, only when this activity takes place in combustion plants covered under 1.1 above; Optimise the design and/or operation of SCR and/or SNCR; Reducing ammonia emissions to air. The BAT-AEL emission level is < 3?10 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000527', 'Large combustion plants  - NOx - BAT20-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table incl. footnote) for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 100?150 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000528', 'Large combustion plants  - NOx - BAT20-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table incl. footnote) for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 100?270 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000529', 'Large combustion plants  - NOx - BAT20-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table incl. footnote) for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 155?200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000530', 'Large combustion plants  - NOx - BAT20-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table incl. footnote) for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 165?330 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000531', 'Large combustion plants  - NOx - BAT20-IX', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table incl. footnote) in FBC boiler combusting coal and/or lignite and lignite-fired PC boiler. for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 50-85 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000532', 'Large combustion plants  - NOx - BAT20-V', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table incl. footnote) for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 50?100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000533', 'Large combustion plants  - NOx - BAT20-VI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table incl. footnote) for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 100?180 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000534', 'Large combustion plants  - NOx - BAT20-VII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table incl. footnote) for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 80?130 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000535', 'Large combustion plants  - NOx - BAT20-VIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table incl. footnote) for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 155?210 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000536', 'Large combustion plants  - NOx - BAT20-X', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table incl. footnote) in FBC boiler combusting coal and/or lignite and lignite-fired PC boiler. for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 85 - 150 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000537', 'Large combustion plants  - NOx - BAT20-XI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table incl. footnote) in FBC boiler combusting coal and/or lignite and lignite-fired PC boiler. for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 80-125 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000538', 'Large combustion plants  - NOx - BAT20-XII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table incl. footnote) in FBC boiler combusting coal and/or lignite and lignite-fired PC boiler. for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 140-165 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000539', 'Large combustion plants  - NOx - BAT20-XIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table incl. footnote) in coal-fired PC boiler. for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 65 ? 85 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000540', 'Large combustion plants  - NOx - BAT20-XIV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table incl. footnote) in coal-fired PC boiler. for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 65 ? 150 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000541', 'Large combustion plants  - NOx - BAT20-XV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table incl. footnote) in coal-fired PC boiler. for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 80 ? 125 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000542', 'Large combustion plants  - NOx - BAT20-XVI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(e) (see table incl. footnote) in coal-fired PC boiler. for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 85 ? 165 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000543', 'Large combustion plants  - NOx - BAT24-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table) for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 70-150 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000544', 'Large combustion plants  - NOx - BAT24-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table) for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 70-225 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000545', 'Large combustion plants  - NOx - BAT24-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table) for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 120?200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000546', 'Large combustion plants  - NOx - BAT24-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table) for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 120?275 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000547', 'Large combustion plants  - NOx - BAT24-IX', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table) for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 40?140 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000548', 'Large combustion plants  - NOx - BAT24-V', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table) for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 50?140 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000549', 'Large combustion plants  - NOx - BAT24-VI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table) for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 50?180 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000550', 'Large combustion plants  - NOx - BAT24-VII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table) for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 100?200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000551', 'Large combustion plants  - NOx - BAT24-VIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table) for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 100?220 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000552', 'Large combustion plants  - NOx - BAT24-X', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table) for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 40?150 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000553', 'Large combustion plants  - NOx - BAT24-XI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table) for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 65?150 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000554', 'Large combustion plants  - NOx - BAT24-XII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table) for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 95?165 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000555', 'Large combustion plants  - NOx - BAT28-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table) for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 75?200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000556', 'Large combustion plants  - NOx - BAT28-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table) for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 150?270 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000557', 'Large combustion plants  - NOx - BAT28-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table) for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 100?215 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000558', 'Large combustion plants  - NOx - BAT28-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table) for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 210?330 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000559', 'Large combustion plants  - NOx - BAT28-V', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table) for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 45?75 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000560', 'Large combustion plants  - NOx - BAT28-VI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table) for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 45?100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000561', 'Large combustion plants  - NOx - BAT28-VII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table) for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 85?100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000562', 'Large combustion plants  - NOx - BAT28-VIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table) for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 85?110 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000563', 'Large combustion plants  - NOx - BAT33-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(b) (see table) for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 115?190 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000564', 'Large combustion plants  - NOx - BAT33-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(b) (see table) for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 125?625 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000565', 'Large combustion plants  - NOx - BAT33-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(b) (see table) for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 145?300 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000566', 'Large combustion plants  - NOx - BAT33-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(b) (see table) for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 150?750 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000567', 'Large combustion plants  - NOx - BAT44-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for new open-cycle gas turbines (OCGTs); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 15?35 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000568', 'Large combustion plants  - NOx - BAT44-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for new open-cycle gas turbines (OCGTs); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 25?50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000569', 'Large combustion plants  - NOx - BAT44-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for Existing OCGT (excluding turbines for mechanical drive applications); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 15?50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000570', 'Large combustion plants  - NOx - BAT44-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for Existing OCGT (excluding turbines for mechanical drive applications); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 25?55 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000571', 'Large combustion plants  - NOx - BAT44-IX', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for existing combined-cycle gas turbines (CCGTs); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 10?50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000572', 'Large combustion plants  - NOx - BAT44-V', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for new combined-cycle gas turbines (CCGTs); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 10?30 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000573', 'Large combustion plants  - NOx - BAT44-VI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for new combined-cycle gas turbines (CCGTs); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 15?40 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000574', 'Large combustion plants  - NOx - BAT44-VII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for existing combined-cycle gas turbines (CCGTs); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 10?40 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000575', 'Large combustion plants  - NOx - BAT44-VIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for existing combined-cycle gas turbines (CCGTs); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 18-50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000576', 'Large combustion plants  - NOx - BAT44-X', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for existing combined-cycle gas turbines (CCGTs); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 18-55 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000577', 'Large combustion plants  - NOx - BAT44-XI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for existing combined-cycle gas turbines (CCGTs); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 10-45 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000578', 'Large combustion plants  - NOx - BAT44-XII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for existing combined-cycle gas turbines (CCGTs); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 35-55 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000579', 'Large combustion plants  - NOx - BAT44-XIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for existing combined-cycle gas turbines (CCGTs); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 25-50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000580', 'Large combustion plants  - NOx - BAT44-XIV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for existing combined-cycle gas turbines (CCGTs); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 35-55 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000581', 'Large combustion plants  - NOx - BAT44-XIX', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 50?100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000582', 'Large combustion plants  - NOx - BAT44-XV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for open- and combined-cycle gas turbines put into operation no later than 27 November 2003, or existing gas turbine for emergency use and operated < 500 h/yr; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 60?140 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000583', 'Large combustion plants  - NOx - BAT44-XVI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 15?50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000584', 'Large combustion plants  - NOx - BAT44-XVII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 25-55 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000585', 'Large combustion plants  - NOx - BAT44-XVIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 10?60 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000586', 'Large combustion plants  - NOx - BAT44-XX', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 30?85 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000587', 'Large combustion plants  - NOx - BAT44-XXI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 85?110 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000588', 'Large combustion plants  - NOx - BAT44-XXII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 20?75 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000589', 'Large combustion plants  - NOx - BAT44-XXIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 20?100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000590', 'Large combustion plants  - NOx - BAT44-XXIV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 55?85 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000591', 'Large combustion plants  - NOx - BAT44-XXV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Ensure optimised combustion and/or to use oxidation catalysts for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 55?110 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000592', 'Large combustion plants  - NOx - BAT49-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(b) (see table) for New boilers; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 15?65 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000593', 'Large combustion plants  - NOx - BAT49-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(b) (see table) for New boilers; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 22?100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000594', 'Large combustion plants  - NOx - BAT49-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(b) (see table) for Existing boilers; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 20?100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000595', 'Large combustion plants  - NOx - BAT49-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(b) (see table) for Existing boilers; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 22?110 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000596', 'Large combustion plants  - NOx - BAT49-V', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(b) (see table) for new combined-cycle gas turbines (CCGTs); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 20?35 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000597', 'Large combustion plants  - NOx - BAT49-VI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(b) (see table) for new combined-cycle gas turbines (CCGTs); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 30?50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000598', 'Large combustion plants  - NOx - BAT49-VII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(b) (see table) for existing combined-cycle gas turbines (CCGTs); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 20?50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000599', 'Large combustion plants  - NOx - BAT49-VIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(b) (see table) for existing combined-cycle gas turbines (CCGTs); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 30?55 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000600', 'Large combustion plants  - NOx - BAT53-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(d) (see table). for new open-cycle gas turbines on offshore platforms; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 15?50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000601', 'Large combustion plants  - NOx - BAT53-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(d) (see table). for existing open-cycle gas turbines on offshore platforms; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 50?350 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000602', 'Large combustion plants  - NOx - BAT56-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table). for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 30?85 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000603', 'Large combustion plants  - NOx - BAT56-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table). for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 80?290 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000604', 'Large combustion plants  - NOx - BAT56-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table). for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 50?110 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000605', 'Large combustion plants  - NOx - BAT56-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table). for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 100?330 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000606', 'Large combustion plants  - NOx - BAT56-V', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table). for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 20?80 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000607', 'Large combustion plants  - NOx - BAT56-VI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table). for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 70?100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000608', 'Large combustion plants  - NOx - BAT56-VII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table). for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 30?100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000609', 'Large combustion plants  - NOx - BAT56-VIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(i) (see table). for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 85?110 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000610', 'Large combustion plants  - NOx - BAT73-I', '1. Energy industries: 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; Use one or a combination of the techniques given below: (a)-(e) (see table) for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 10?25 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000611', 'Large combustion plants  - NOx - BAT73-II', '1. Energy industries: 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; Use one or a combination of the techniques given below: (a)-(e) (see table) for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 12?45 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000612', 'Large combustion plants  - NOx - BAT73-III', '1. Energy industries: 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; Use one or a combination of the techniques given below: (a)-(e) (see table) for New plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 1?35 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000613', 'Large combustion plants  - NOx - BAT73-IV', '1. Energy industries: 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; Use one or a combination of the techniques given below: (a)-(e) (see table) for Existing plant; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 1?60 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000614', 'Large combustion plants  - Ni - BAT15-XIII', '1.? Energy industries; 5.? Waste management: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; 5.2, Disposal or recovery of waste in waste co-incineration plants for non-hazardous waste with a capacity exceeding 3 tonnes per hour or for hazardous waste with a capacity exceeding 10 tonnes per day, only when this activity takes place in combustion plants covered under 1.1 above. Reducing nickel to water. The BAT-AEL emission level is 10?50 ?g/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000615', 'Large combustion plants  - PCDD.F - BAT59', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(c) (see table); Reducing PCDD/F emissions to air. The BAT-AEL emission level is < 0,012?0,036 ng I-TEQ/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000616', 'Large combustion plants  - PCDD.F - BAT71-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Use a combination of the techniques given in BAT 6, BAT 26 and techniques (a)-(c) (see table); Reducing PCDD/F emissions to air. The BAT-AEL emission level is ? 0,01-0,03 ng I-TEQ/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000617', 'Large combustion plants  - Pb - BAT15-XIV', '1.? Energy industries; 5.? Waste management: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; 5.2, Disposal or recovery of waste in waste co-incineration plants for non-hazardous waste with a capacity exceeding 3 tonnes per hour or for hazardous waste with a capacity exceeding 10 tonnes per day, only when this activity takes place in combustion plants covered under 1.1 above. Reducing lead to water. The BAT-AEL emission level is 10?20 ?g/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000618', 'Large combustion plants  - SO2 - BAT21-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) for New plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 150?200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000619', 'Large combustion plants  - SO2 - BAT21-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) for Existing plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 150?360 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000620', 'Large combustion plants  - SO2 - BAT21-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) for New plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 170?220 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000621', 'Large combustion plants  - SO2 - BAT21-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) for Existing plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 170?400 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000622', 'Large combustion plants  - S - BAT15-VI', '1.? Energy industries; 5.? Waste management: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; 5.2, Disposal or recovery of waste in waste co-incineration plants for non-hazardous waste with a capacity exceeding 3 tonnes per hour or for hazardous waste with a capacity exceeding 10 tonnes per day, only when this activity takes place in combustion plants covered under 1.1 above. Reducing sulphide to water. The BAT-AEL emission level is 0,1?0,2 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000623', 'Large combustion plants  - SO2 - BAT21-IX', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) in PC boilers for New plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 10?75 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000624', 'Large combustion plants  - SO2 - BAT21-V', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) for New plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 80?150 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000625', 'Large combustion plants  - SO2 - BAT21-VI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) for Existing plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 95?200 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000626', 'Large combustion plants  - SO2 - BAT21-VII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) for New plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 135?200 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000627', 'Large combustion plants  - SO2 - BAT21-VIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) for Existing plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 135?220 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000628', 'Large combustion plants  - SO2 - BAT21-X', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) in PC boilers for Existing plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 10?130 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000629', 'Large combustion plants  - SO2 - BAT21-XI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) in PC boilers for New plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 25?110 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000630', 'Large combustion plants  - SO2 - BAT21-XII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) in PC boilers for Existing plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 25?165 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000631', 'Large combustion plants  - SO2 - BAT21-XIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) in fluidised bed boilers for New plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 20?75 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000632', 'Large combustion plants  - SO2 - BAT21-XIV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) in fluidised bed boilers for Existing plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 20?180 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000633', 'Large combustion plants  - SO2 - BAT21-XV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) in fluidised bed boilers for New plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 25?110 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000634', 'Large combustion plants  - SO2 - BAT21-XVI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(j) (see table) in fluidised bed boilers for Existing plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 50?220 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000635', 'Large combustion plants  - SO2 - BAT25-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for New plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 15?70 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000636', 'Large combustion plants  - SO2 - BAT25-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for Existing plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 15?100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000637', 'Large combustion plants  - SO2 - BAT25-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for New plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 30?175 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000638', 'Large combustion plants  - SO2 - BAT25-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for Existing plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 30?215 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000639', 'Large combustion plants  - SO2 - BAT25-IX', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for New plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is < 10?35 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000640', 'Large combustion plants  - SO2 - BAT25-V', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for New plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is < 10?50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000641', 'Large combustion plants  - SO2 - BAT25-VI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for Existing plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is < 10?70 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000642', 'Large combustion plants  - SO2 - BAT25-VII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for New plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is < 20?85 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000643', 'Large combustion plants  - SO2 - BAT25-VIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for Existing plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is < 20?175 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000644', 'Large combustion plants  - SO2 - BAT25-X', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for Existing plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is < 10?50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000645', 'Large combustion plants  - SO2 - BAT25-XI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table); Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is < 20?70 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000646', 'Large combustion plants  - SO2 - BAT25-XII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(h) (see table) for Existing plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is < 20?85 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000647', 'Large combustion plants  - SO2 - BAT29-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(f) (see table) for New plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 50?175 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000648', 'Large combustion plants  - SO2 - BAT29-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(f) (see table) for Existing plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 50?175 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000649', 'Large combustion plants  - SO2 - BAT29-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(f) (see table) for New plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 150?200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000650', 'Large combustion plants  - SO2 - BAT29-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(f) (see table) for Existing plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 150?200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000651', 'Large combustion plants  - SO2 - BAT29-V', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(f) (see table) for New plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 35?50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000652', 'Large combustion plants  - SO2 - BAT29-VI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(f) (see table) for Existing plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 50?110 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000653', 'Large combustion plants  - SO2 - BAT29-VII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(f) (see table) for New plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 50?120 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000654', 'Large combustion plants  - SO2 - BAT29-VIII', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(f) (see table) for Existing plant; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 150?165 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000655', 'Large combustion plants  - SO2 - BAT34-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(c) (see table) for New combustion plant (all sizes); Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 45?100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000656', 'Large combustion plants  - SO2 - BAT34-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(c) (see table) for Existing combustion plant (all sizes); Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 100?200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000657', 'Large combustion plants  - SO2 - BAT34-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(c) (see table) for New combustion plant (all sizes); Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 60?110 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000658', 'Large combustion plants  - SO2 - BAT34-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(c) (see table) for Existing combustion plant (all sizes); Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 105?235 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000659', 'Large combustion plants  - SO2 - BAT39-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Technique (a) (see table) for new and existing plants; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 35?60 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000660', 'Large combustion plants  - SO2 - BAT39-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Technique (a) (see table) for new and existing plants; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 50?66 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000661', 'Large combustion plants  - SO2 - BAT50-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(b) (see table) in boilers; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 25?150 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000662', 'Large combustion plants  - SO2 - BAT50-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(b) (see table) in boilers; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 50?200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000663', 'Large combustion plants  - SO2 - BAT50-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(b) (see table) in combined-cycle gas turbines (CCGTs); Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 10?45 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000664', 'Large combustion plants  - SO2 - BAT50-IV', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(b) (see table) in combined-cycle gas turbines (CCGTs); Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 20?70 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000665', 'Large combustion plants  - SO2 - BAT57-I', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table). for New and existing boilers; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 10?110 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000666', 'Large combustion plants  - SO2 - BAT57-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(g) (see table). for New and existing boilers; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 90?200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000667', 'Large combustion plants  - SO2 - BAT74', '1. Energy industries: 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; Acid gas removal (see table); Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 3?16 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000668', 'Large combustion plants  - TVOC - BAT15-XVI', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Techniques (a)-(c) (see table); Reducing TVOC emissions to air. The BAT-AEL emission level is 0,6?12 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000669', 'Large combustion plants  - SO3 - BAT15-VII', '1.? Energy industries; 5.? Waste management: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; 5.2, Disposal or recovery of waste in waste co-incineration plants for non-hazardous waste with a capacity exceeding 3 tonnes per hour or for hazardous waste with a capacity exceeding 10 tonnes per day, only when this activity takes place in combustion plants covered under 1.1 above. Reducing sulphite to water. The BAT-AEL emission level is 1?20 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000670', 'Large combustion plants  - SO4 - BAT15-V', '1.? Energy industries; 5.? Waste management: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; 5.2, Disposal or recovery of waste in waste co-incineration plants for non-hazardous waste with a capacity exceeding 3 tonnes per hour or for hazardous waste with a capacity exceeding 10 tonnes per day, only when this activity takes place in combustion plants covered under 1.1 above. Reducing sulphates to water. The BAT-AEL emission level is 1,3?2,0 g/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000671', 'Large combustion plants  - TOC - BAT15-I', '1.? Energy industries; 5.? Waste management: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; 5.2, Disposal or recovery of waste in waste co-incineration plants for non-hazardous waste with a capacity exceeding 3 tonnes per hour or for hazardous waste with a capacity exceeding 10 tonnes per day, only when this activity takes place in combustion plants covered under 1.1 above. Reducing total organic carbon (TOC) to water. The BAT-AEL emission level is 20?50 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000672', 'Large combustion plants  - TSS - BAT15-III', '1.? Energy industries; 5.? Waste management: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; 5.2, Disposal or recovery of waste in waste co-incineration plants for non-hazardous waste with a capacity exceeding 3 tonnes per hour or for hazardous waste with a capacity exceeding 10 tonnes per day, only when this activity takes place in combustion plants covered under 1.1 above. Reducing total suspended solids to water. The BAT-AEL emission level is 10?30 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000673', 'Large combustion plants  - TVOC - BAT71-II', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Use a combination of the techniques given in BAT 6, BAT 26 and techniques (a)-(c) (see table); Reducing TVOC emissions to air. The BAT-AEL emission level is <0,1-5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000674', 'Large combustion plants  - TVOC - BAT71-III', '1. Energy industries: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; Use a combination of the techniques given in BAT 6, BAT 26 and techniques (a)-(c) (see table); Reducing TVOC emissions to air. The BAT-AEL emission level is 0,5-10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000675', 'Large combustion plants  - Zn - BAT15-XV', '1.? Energy industries; 5.? Waste management: 1.1, Combustion of fuels in installations with a total rated thermal input of 50 MW or more, only when this activity takes place in combustion plants with a total rated thermal input of 50 MW or more; 1.4, Gasification of coal or other fuels in installations with a total rated thermal input of 20 MW or more, only when this activity is directly associated to a combustion plant; 5.2, Disposal or recovery of waste in waste co-incineration plants for non-hazardous waste with a capacity exceeding 3 tonnes per hour or for hazardous waste with a capacity exceeding 10 tonnes per day, only when this activity takes place in combustion plants covered under 1.1 above. Reducing zinc to water. The BAT-AEL emission level is 50?200 ?g/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000676', 'Production of Large Volume Organic Chemicals - Benzene - BAT57-I', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (b) oxygen-containing hydrocarbons such as alcohols, aldehydes, ketones, carboxylic acids, esters and mixtures of esters, acetates, ethers, peroxides and epoxy resins; Techniques (a)-(d) (see table); Reducing benzene emissions to air. The BAT-AEL emission level is < 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000677', 'Production of Large Volume Organic Chemicals - Cl2 - BAT66-IV', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (d) nitrogenous hydrocarbons such as amines, amides, nitrous compounds, nitro compounds or nitrate compounds, nitriles, cyanates, isocyanates; Treat combined waste gas streams using a thermal oxidiser followed by caustic scrubbing; Reducing chlorides emissions to air. The BAT-AEL emission level is < 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000678', 'Production of Large Volume Organic Chemicals - Cl2 - BAT67-IV', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (d) nitrogenous hydrocarbons such as amines, amides, nitrous compounds, nitro compounds or nitrate compounds, nitriles, cyanates, isocyanates; Treat combined waste gas streams using a thermal oxidiser followed by caustic scrubbing; Reducing chlorides emissions to air. The BAT-AEL emission level is < 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000679', 'Production of Large Volume Organic Chemicals - Cl2 - BAT76-III', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (f) halogenic hydrocarbons; treat the combined waste gas streams from EDC and/or VCM production by using a thermal oxidiser followed by two-stage wet scrubbing; Reducing chlorides emissions to air. The BAT-AEL emission level is < 1?4 mg/Nm3, at 11 vol-% O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000680', 'Production of Large Volume Organic Chemicals - Cl2 - BAT77-III', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (f) halogenic hydrocarbons; treat the combined waste gas streams from EDC and/or VCM production by using a thermal oxidiser followed by two-stage wet scrubbing; Reducing chlorides emissions to air. The BAT-AEL emission level is < 1?4 mg/Nm3, at 11 vol-% O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000681', 'Production of Large Volume Organic Chemicals - Cu - BAT80-I', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (f) halogenic hydrocarbons Reducing copper to water. The BAT-AEL emission level is 0,04?0,2 g/t EDC produced by oxychlorination .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000682', 'Production of Large Volume Organic Chemicals - EDC - BAT80-II', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (f) halogenic hydrocarbons Reducing EDC to water. The BAT-AEL emission level is 0,01?0,05 g/t EDC purified .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000683', 'Production of Large Volume Organic Chemicals - EDCVCM - BAT76-II', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (f) halogenic hydrocarbons; treat the combined waste gas streams from EDC and/or VCM production by using a thermal oxidiser followed by two-stage wet scrubbing; Reducing EDC and VCM emissions to air. The BAT-AEL emission level is < 1 mg/Nm3, at 11 vol-% O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000684', 'Production of Large Volume Organic Chemicals - EDCVCM - BAT77-II', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (f) halogenic hydrocarbons; treat the combined waste gas streams from EDC and/or VCM production by using a thermal oxidiser followed by two-stage wet scrubbing; Reducing EDC and VCM emissions to air. The BAT-AEL emission level is < 1 mg/Nm3, at 11 vol-% O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000685', 'Production of Large Volume Organic Chemicals - Formaldehyde - BAT45-II', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (b) oxygen-containing hydrocarbons such as alcohols, aldehydes, ketones, carboxylic acids, esters and mixtures of esters, acetates, ethers, peroxides and epoxy resins; Techniques (a)-(c) (see table); Reducing formaldehyde emissions to air. The BAT-AEL emission level is 2?5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000686', 'Production of Large Volume Organic Chemicals - HCl - BAT66-V', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (d) nitrogenous hydrocarbons such as amines, amides, nitrous compounds, nitro compounds or nitrate compounds, nitriles, cyanates, isocyanates; Treat combined waste gas streams using a thermal oxidiser followed by caustic scrubbing; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 2?10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000687', 'Production of Large Volume Organic Chemicals - HCl - BAT67-V', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (d) nitrogenous hydrocarbons such as amines, amides, nitrous compounds, nitro compounds or nitrate compounds, nitriles, cyanates, isocyanates; Treat combined waste gas streams using a thermal oxidiser followed by caustic scrubbing; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 2?10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000688', 'Production of Large Volume Organic Chemicals - HCl - BAT76-IV', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (f) halogenic hydrocarbons; treat the combined waste gas streams from EDC and/or VCM production by using a thermal oxidiser followed by two-stage wet scrubbing; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 2?10 mg/Nm3, at 11 vol-% O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000689', 'Production of Large Volume Organic Chemicals - HCl - BAT77-IV', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (f) halogenic hydrocarbons; treat the combined waste gas streams from EDC and/or VCM production by using a thermal oxidiser followed by two-stage wet scrubbing; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 2?10 mg/Nm3, at 11 vol-% O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000690', 'Production of Large Volume Organic Chemicals - NH3 - BAT4-III', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (a) simple hydrocarbons (linear or cyclic, saturated or unsaturated, aliphatic or?aromatic); Techniques (a)-(h) (see table) and optimise the design and/or operation of SCR or SNCR; Reducing ammonia (NH3) emissions to air. The BAT-AEL emission level is < 5?15 mg/Nm?, at 3 vol-% O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000691', 'Production of Large Volume Organic Chemicals - NOx - BAT4-I', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (a) simple hydrocarbons (linear or cyclic, saturated or unsaturated, aliphatic or?aromatic); Techniques (a)-(h) (see table) and optimise the design and/or operation of SCR or SNCR for New furnace; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 60?100 mg/Nm?, at 3 vol-% O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000692', 'Production of Large Volume Organic Chemicals - NOx - BAT4-II', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (a) simple hydrocarbons (linear or cyclic, saturated or unsaturated, aliphatic or?aromatic); Techniques (a)-(h) (see table) and optimise the design and/or operation of SCR or SNCR for Existing furnace; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 70?200 mg/Nm?, at 3 vol-% O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000693', 'Production of Large Volume Organic Chemicals - PCDD.F - BAT66-VI', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (d) nitrogenous hydrocarbons such as amines, amides, nitrous compounds, nitro compounds or nitrate compounds, nitriles, cyanates, isocyanates; Treat combined waste gas streams using a thermal oxidiser followed by caustic scrubbing; Reducing PCDD/F emissions to air. The BAT-AEL emission level is 0,025?0,08 ng I-TEQ/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000694', 'Production of Large Volume Organic Chemicals - PCDD.F - BAT67-VI', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (d) nitrogenous hydrocarbons such as amines, amides, nitrous compounds, nitro compounds or nitrate compounds, nitriles, cyanates, isocyanates; Treat combined waste gas streams using a thermal oxidiser followed by caustic scrubbing; Reducing PCDD/F emissions to air. The BAT-AEL emission level is 0,025?0,08 ng I-TEQ/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000695', 'Production of Large Volume Organic Chemicals - PCDD.F - BAT76-V', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (f) halogenic hydrocarbons; treat the combined waste gas streams from EDC and/or VCM production by using a thermal oxidiser followed by two-stage wet scrubbing; Reducing PCDD/F emissions to air. The BAT-AEL emission level is 0,025?0,08 ng I-TEQ/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000696', 'Production of Large Volume Organic Chemicals - PCDD.F - BAT77-V', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (f) halogenic hydrocarbons; treat the combined waste gas streams from EDC and/or VCM production by using a thermal oxidiser followed by two-stage wet scrubbing; Reducing PCDD/F emissions to air. The BAT-AEL emission level is 0,025?0,08 ng I-TEQ/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000697', 'Production of Large Volume Organic Chemicals - PCDD.F - BAT80-III', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (f) halogenic hydrocarbons Reducing PCDD/F to water. The BAT-AEL emission level is 0,1? 0,3 ?g I-TEQ/t EDC produced by oxychlorination .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000698', 'Production of Large Volume Organic Chemicals - TVOC - BAT45-I', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (b) oxygen-containing hydrocarbons such as alcohols, aldehydes, ketones, carboxylic acids, esters and mixtures of esters, acetates, ethers, peroxides and epoxy resins; Techniques (a)-(c) (see table); Reducing TVOC emissions to air. The BAT-AEL emission level is < 5?30 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000699', 'Production of Large Volume Organic Chemicals - TVOC - BAT51', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (b) oxygen-containing hydrocarbons such as alcohols, aldehydes, ketones, carboxylic acids, esters and mixtures of esters, acetates, ethers, peroxides and epoxy resins; Techniques (a)-(c) (see table); Reducing TVOC emissions to air. The BAT-AEL emission level is 1?10 g/t of EO produced .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000700', 'Production of Large Volume Organic Chemicals - TVOC - BAT57-II', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (b) oxygen-containing hydrocarbons such as alcohols, aldehydes, ketones, carboxylic acids, esters and mixtures of esters, acetates, ethers, peroxides and epoxy resins; Techniques (a)-(d) (see table); Reducing TVOC emissions to air. The BAT-AEL emission level is 5?30 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000701', 'Production of Large Volume Organic Chemicals - TVOC - BAT66-I', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (d) nitrogenous hydrocarbons such as amines, amides, nitrous compounds, nitro compounds or nitrate compounds, nitriles, cyanates, isocyanates; Treat combined waste gas streams using a thermal oxidiser followed by caustic scrubbing; Reducing TVOC emissions to air. The BAT-AEL emission level is 1?5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000702', 'Production of Large Volume Organic Chemicals - TVOC - BAT67-I', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (d) nitrogenous hydrocarbons such as amines, amides, nitrous compounds, nitro compounds or nitrate compounds, nitriles, cyanates, isocyanates; Treat combined waste gas streams using a thermal oxidiser followed by caustic scrubbing; Reducing TVOC emissions to air. The BAT-AEL emission level is 1?5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000703', 'Production of Large Volume Organic Chemicals - TVOC - BAT76-I', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (f) halogenic hydrocarbons; treat the combined waste gas streams from EDC and/or VCM production by using a thermal oxidiser followed by two-stage wet scrubbing; Reducing TVOC emissions to air. The BAT-AEL emission level is 0,5?5 mg/Nm3, at 11 vol-% O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000704', 'Production of Large Volume Organic Chemicals - TVOC - BAT77-I', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (f) halogenic hydrocarbons; treat the combined waste gas streams from EDC and/or VCM production by using a thermal oxidiser followed by two-stage wet scrubbing; Reducing TVOC emissions to air. The BAT-AEL emission level is 0,5?5 mg/Nm3, at 11 vol-% O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000705', 'Production of Large Volume Organic Chemicals - TVOC - BAT86', '4. Chemical industry: 4.2. Production of inorganic chemicals, such as: (e) non-metals, metal oxides or other inorganic compounds such as calcium carbide, silicon, silicon carbide; Techniques (a)-(d) (see table); Reducing TVOC emissions to air. The BAT-AEL emission level is 5?25 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000706', 'Production of Large Volume Organic Chemicals - Tetrachloromethane - BAT66-II', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (d) nitrogenous hydrocarbons such as amines, amides, nitrous compounds, nitro compounds or nitrate compounds, nitriles, cyanates, isocyanates; Treat combined waste gas streams using a thermal oxidiser followed by caustic scrubbing; Reducing tertachloromethane emissions to air. The BAT-AEL emission level is ? 0,5 g/t MDI produced .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000707', 'Production of Large Volume Organic Chemicals - Tetrachloromethane - BAT66-III', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (d) nitrogenous hydrocarbons such as amines, amides, nitrous compounds, nitro compounds or nitrate compounds, nitriles, cyanates, isocyanates; Treat combined waste gas streams using a thermal oxidiser followed by caustic scrubbing; Reducing tertachloromethane emissions to air. The BAT-AEL emission level is ? 0,7 g/t TDI produced .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000708', 'Production of Large Volume Organic Chemicals - Tetrachloromethane - BAT67-II', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (d) nitrogenous hydrocarbons such as amines, amides, nitrous compounds, nitro compounds or nitrate compounds, nitriles, cyanates, isocyanates; Treat combined waste gas streams using a thermal oxidiser followed by caustic scrubbing; Reducing tertachloromethane emissions to air. The BAT-AEL emission level is ? 0,5 g/t MDI produced .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000709', 'Production of Large Volume Organic Chemicals - Tetrachloromethane - BAT67-III', '4. Chemical industry: 4.1, Production of organic chemicals, such as: (d) nitrogenous hydrocarbons such as amines, amides, nitrous compounds, nitro compounds or nitrate compounds, nitriles, cyanates, isocyanates; Treat combined waste gas streams using a thermal oxidiser followed by caustic scrubbing; Reducing tertachloromethane emissions to air. The BAT-AEL emission level is ? 0,7 g/t TDI produced .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000710', 'Non-Ferrous Metals industries  - Ag - BAT17-I', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing mercury to water. The BAT-AEL emission level is ? 0,6 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000711', 'Non-Ferrous Metals industries  - As - BAT17-II', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing arsenic to water. The BAT-AEL emission level is ? 0,1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000712', 'Non-Ferrous Metals industries  - As - BAT17-III', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing arsenic to water. The BAT-AEL emission level is ? 0,3 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000713', 'Non-Ferrous Metals industries  - AsH3SbH3 - BAT114-III', '2, Production and processing of metals: 2.5: Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Techniques (a)-(c) (see table incl. footnote); Reducing arsenic and antimony emissions to air. The BAT-AEL emission level is ? 0,5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000714', 'Non-Ferrous Metals industries  - BaP - BAT178-II', '6.? Other activities: 6.8: Production of carbon (hard-burnt coal) or electrographite by means of incineration or graphitisation; Bag filter; Reducing benzo[a]pyrene emissions to air. The BAT-AEL emission level is ? 0,01 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000715', 'Non-Ferrous Metals industries  - BaP - BAT179-II', '6.? Other activities: 6.8: Production of carbon (hard-burnt coal) or electrographite by means of incineration or graphitisation; Techniques (a)-(d) (see table incl. footnote); Reducing benzo[a]pyrene emissions to air. The BAT-AEL emission level is 0,001-0,01 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000716', 'Non-Ferrous Metals industries  - BaP - BAT180-II', '6.? Other activities: 6.8: Production of carbon (hard-burnt coal) or electrographite by means of incineration or graphitisation; Techniques (a)-(c) (see table incl. footnote); Reducing benzo[a]pyrene emissions to air. The BAT-AEL emission level is 0,005-0,015 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000717', 'Non-Ferrous Metals industries  - BaP - BAT181-II', '6.? Other activities: 6.8: Production of carbon (hard-burnt coal) or electrographite by means of incineration or graphitisation; Techniques (a)-(c) (see table incl. footnote); Reducing benzo[a]pyrene emissions to air. The BAT-AEL emission level is 0,001-0,01 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000718', 'Non-Ferrous Metals industries  - BaP - BAT59-II', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Techniques (a)-(c) (see table incl. footnote) in a paste plant (hot pitch storage, paste mixing, cooling and forming); Reducing benzo[a]pyrene emissions to air. The BAT-AEL emission level is 0,001 - 0,01 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000719', 'Non-Ferrous Metals industries  - BaP - BAT60-II', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Techniques (a)-(d) (see table incl. footnote); Reducing benzo[a]pyrene emissions to air. The BAT-AEL emission level is 0,001-0,01 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000720', 'Non-Ferrous Metals industries  - BaP - BAT61-II', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Use a pre-filtration unit and a regenerative thermal oxidiser followed by a dry scrubber (e.g. lime bed); Reducing benzo[a]pyrene emissions to air. The BAT-AEL emission level is 0,001-0,01 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000721', 'Non-Ferrous Metals industries  - CO - BAT17-VII', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing silver to water. The BAT-AEL emission level is ? 0,1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000722', 'Non-Ferrous Metals industries  - CO - BAT17-VIII', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing silver to water. The BAT-AEL emission level is 0,1-0,5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000723', 'Non-Ferrous Metals industries  - Cd - BAT132-II', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Techniques (a)-(c) (see table incl. footnote); Reducing cadmium emissions to air. The BAT-AEL emission level is ? 0,1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000724', 'Non-Ferrous Metals industries  - Cd - BAT17-IV', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing cadmium to water. The BAT-AEL emission level is 0,02?0,1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000725', 'Non-Ferrous Metals industries  - Cd - BAT17-V', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing cadmium to water. The BAT-AEL emission level is ? 0,1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000726', 'Non-Ferrous Metals industries  - Cd - BAT17-VI', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing cadmium to water. The BAT-AEL emission level is ? 0,05 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000727', 'Non-Ferrous Metals industries  - Cl2 - BAT144-II', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Alkaline scrubber; Reducing chlorides emissions to air. The BAT-AEL emission level is 0,5-2 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000728', 'Non-Ferrous Metals industries  - Cl2 - BAT172-II', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Wet scrubber; Reducing chlorides emissions to air. The BAT-AEL emission level is ? 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000729', 'Non-Ferrous Metals industries  - Cl2 - BAT84-II', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Techniques (a)-(d) (see table); Reducing chlorides emissions to air. The BAT-AEL emission level is ? 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000730', 'Non-Ferrous Metals industries  - Cr - BAT17-IX', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing cobalt to water. The BAT-AEL emission level is ? 0,2 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000731', 'Non-Ferrous Metals industries  - Cr - BAT17-X', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing chromium to water. The BAT-AEL emission level is ? 0,05 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000732', 'Non-Ferrous Metals industries  - Cu - BAT17-XI', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing copper to water. The BAT-AEL emission level is 0,05-0,5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000733', 'Non-Ferrous Metals industries  - Cu - BAT17-XII', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing copper to water. The BAT-AEL emission level is ? 0,2 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000734', 'Non-Ferrous Metals industries  - Cu - BAT17-XIII', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing copper to water. The BAT-AEL emission level is ? 0,1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000735', 'Non-Ferrous Metals industries  - Cu - BAT17-XIV', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing copper to water. The BAT-AEL emission level is ? 0,3 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000736', 'Non-Ferrous Metals industries  - Cu - BAT17-XV', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing copper to water. The BAT-AEL emission level is ? 0,5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000737', 'Non-Ferrous Metals industries  - Dust - BAT113', '2, Production and processing of metals: 2.5: Processing of non-ferrous metals; Bag filter; Reducing dust emissions to air. The BAT-AEL emission level is ? 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000738', 'Non-Ferrous Metals industries  - Dust - BAT119', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Bag filter; Reducing dust emissions to air. The BAT-AEL emission level is 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000739', 'Non-Ferrous Metals industries  - Dust - BAT121', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals; Bag filter; Reducing dust emissions to air. The BAT-AEL emission level is ? 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000740', 'Non-Ferrous Metals industries  - Dust - BAT122', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Bag filter; Reducing dust emissions to air. The BAT-AEL emission level is 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000741', 'Non-Ferrous Metals industries  - Dust - BAT128', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Bag filter; Reducing dust emissions to air. The BAT-AEL emission level is ? 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000742', 'Non-Ferrous Metals industries  - Dust - BAT132-I', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Techniques (a)-(c) (see table incl. footnote); Reducing dust emissions to air. The BAT-AEL emission level is 2 - 3 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000743', 'Non-Ferrous Metals industries  - Dust - BAT140', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Techniques (a)-(b) (see table incl. footnote); Reducing dust emissions to air. The BAT-AEL emission level is 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000744', 'Non-Ferrous Metals industries  - Dust - BAT158-I', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Bag filter; Reducing dust emissions to air. The BAT-AEL emission level is 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000745', 'Non-Ferrous Metals industries  - Dust - BAT158-II', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Bag filter; Reducing dust emissions to air. The BAT-AEL emission level is 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000746', 'Non-Ferrous Metals industries  - Dust - BAT158-III', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Bag filter; Reducing dust emissions to air. The BAT-AEL emission level is 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000747', 'Non-Ferrous Metals industries  - Dust - BAT158-IV', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Bag filter; Reducing dust emissions to air. The BAT-AEL emission level is 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000748', 'Non-Ferrous Metals industries  - Dust - BAT171', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Bag filter or a combination of an ESP and a bag filter; Reducing dust emissions to air. The BAT-AEL emission level is 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000749', 'Non-Ferrous Metals industries  - Dust - BAT178-I', '6.? Other activities: 6.8: Production of carbon (hard-burnt coal) or electrographite by means of incineration or graphitisation; Bag filter; Reducing dust emissions to air. The BAT-AEL emission level is 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000750', 'Non-Ferrous Metals industries  - Dust - BAT179-I', '6.? Other activities: 6.8: Production of carbon (hard-burnt coal) or electrographite by means of incineration or graphitisation; Techniques (a)-(d) (see table incl. footnote); Reducing dust emissions to air. The BAT-AEL emission level is 2 - 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000751', 'Non-Ferrous Metals industries  - Dust - BAT180-I', '6.? Other activities: 6.8: Production of carbon (hard-burnt coal) or electrographite by means of incineration or graphitisation; Techniques (a)-(c) (see table incl. footnote); Reducing dust emissions to air. The BAT-AEL emission level is 2 - 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000752', 'Non-Ferrous Metals industries  - Dust - BAT181-I', '6.? Other activities: 6.8: Production of carbon (hard-burnt coal) or electrographite by means of incineration or graphitisation; Techniques (a)-(c) (see table incl. footnote); Reducing dust emissions to air. The BAT-AEL emission level is 2 - 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000753', 'Non-Ferrous Metals industries  - Dust - BAT37', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Bag filter for reception, storage, handling, transport, metering, mixing, blending, crushing, drying, cutting and screening of raw materials, and the pyrolytic treatment of copper turnings in primary and secondary copper production; Reducing dust emissions to air. The BAT-AEL emission level is 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000754', 'Non-Ferrous Metals industries  - Dust - BAT38', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Bag filter for concentrate drying in primary copper production; Reducing dust emissions to air. The BAT-AEL emission level is 3 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000755', 'Non-Ferrous Metals industries  - Dust - BAT39', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Bag filter and/or a wet scrubber for primary copper smelter and converter (emissions other than those that are routed to the sulphuric acid or liquid SO 2 plant or power plant); Reducing dust emissions to air. The BAT-AEL emission level is 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000756', 'Non-Ferrous Metals industries  - Dust - BAT40', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Bag filter for secondary copper smelter and converter and processing of secondary copper intermediates (emissions other than those that are routed to the sulphuric acid plant); Reducing dust emissions to air. The BAT-AEL emission level is 2 - 4 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000757', 'Non-Ferrous Metals industries  - Dust - BAT41', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Bag filter for secondary copper holding furnace; Reducing dust emissions to air. The BAT-AEL emission level is ? 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000758', 'Non-Ferrous Metals industries  - Dust - BAT42', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Bag filter or a scrubber in combination with an ESP for copper-rich slag furnace processing; Reducing dust emissions to air. The BAT-AEL emission level is 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000759', 'Non-Ferrous Metals industries  - Dust - BAT43', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Bag filter or a scrubber in combination with an ESP for anode furnace (in primary and secondary copper production); Reducing dust emissions to air. The BAT-AEL emission level is 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000760', 'Non-Ferrous Metals industries  - Dust - BAT44', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Bag filter or, in the case of off-gases with a water content close to the dew point, a wet scrubber or a demister for anode casting (in primary and secondary copper production); Reducing dust emissions to air. The BAT-AEL emission level is ? 5-15 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000761', 'Non-Ferrous Metals industries  - Dust - BAT45', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Bag filter for copper melting furnace; Reducing dust emissions to air. The BAT-AEL emission level is 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000762', 'Non-Ferrous Metals industries  - Dust - BAT59-I', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Techniques (a)-(c) (see table incl. footnote) in a a paste plant (hot pitch storage, paste mixing, cooling and forming, removing coke dust from operations such as coke storage and grindin); Reducing dust emissions to air. The BAT-AEL emission level is 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000763', 'Non-Ferrous Metals industries  - Dust - BAT60-I', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Techniques (a)-(d) (see table incl. footnote); Reducing dust emissions to air. The BAT-AEL emission level is 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000764', 'Non-Ferrous Metals industries  - Dust - BAT61-I', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Use a pre-filtration unit and a regenerative thermal oxidiser followed by a dry scrubber (e.g. lime bed); Reducing dust emissions to air. The BAT-AEL emission level is 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000765', 'Non-Ferrous Metals industries  - Dust - BAT64-I', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; See three tables; Reducing dust emissions to air. The BAT-AEL emission level is ? 1,2 kg/t Al.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000766', 'Non-Ferrous Metals industries  - Dust - BAT64-II', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; See three tables; Reducing dust emissions to air. The BAT-AEL emission level is ? 0,6 kg/t Al.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000767', 'Non-Ferrous Metals industries  - Dust - BAT66', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Bag filter; Reducing dust emissions to air. The BAT-AEL emission level is ? 5-10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000768', 'Non-Ferrous Metals industries  - Dust - BAT67-I', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Techniques (a)-(b) (see table incl. footnote); Reducing dust emissions to air. The BAT-AEL emission level is 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000769', 'Non-Ferrous Metals industries  - Dust - BAT68', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Techniques (a)-(b) (see table incl. footnote); Reducing dust emissions to air. The BAT-AEL emission level is 2 - 25 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000770', 'Non-Ferrous Metals industries  - Dust - BAT80', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Bag filter; Reducing dust emissions to air. The BAT-AEL emission level is ? 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000771', 'Non-Ferrous Metals industries  - Dust - BAT81', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Bag filter; Reducing dust emissions to air. The BAT-AEL emission level is 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000772', 'Non-Ferrous Metals industries  - Dust - BAT82', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Techniques (a)-(c) (see table); Reducing dust emissions to air. The BAT-AEL emission level is 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000773', 'Non-Ferrous Metals industries  - Dust - BAT88', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals; Bag filter; Reducing dust emissions to air. The BAT-AEL emission level is 2 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000774', 'Non-Ferrous Metals industries  - Dust - BAT94', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Bag filter; Reducing dust emissions to air. The BAT-AEL emission level is ? 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000775', 'Non-Ferrous Metals industries  - Dust - BAT95', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Bag filter or a wet scrubber; Reducing dust emissions to air. The BAT-AEL emission level is ? 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000776', 'Non-Ferrous Metals industries  - Dust - BAT96-I', '2, Production and processing of metals: 2.5: Processing of non-ferrous metals; Bag filter; Reducing dust emissions to air. The BAT-AEL emission level is 2 - 4 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000777', 'Non-Ferrous Metals industries  - Dust - BAT97-I', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Techniques (a)-(b) (see table); Reducing dust emissions to air. The BAT-AEL emission level is 2 - 4 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000778', 'Non-Ferrous Metals industries  - F - BAT60-IV', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Techniques (a)-(d) (see table incl. footnote); Reducing total fluorides emissions to air. The BAT-AEL emission level is ? 0,8 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000779', 'Non-Ferrous Metals industries  - F - BAT64-III', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; See three tables; Reducing total fluorides emissions to air. The BAT-AEL emission level is ? 0,6 kg/t Al.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000780', 'Non-Ferrous Metals industries  - F - BAT64-IV', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; See three tables; Reducing total fluorides emissions to air. The BAT-AEL emission level is ? 0,35 kg/t Al.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000781', 'Non-Ferrous Metals industries  - F - BAT67-III', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Techniques (a)-(b) (see table incl. footnote); Reducing total fluorides emissions to air. The BAT-AEL emission level is ? 1,5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000782', 'Non-Ferrous Metals industries  - H2S - BAT89-III', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals; Techniques (a)-(c) (see table incl. footnote); Reducing hydrogen sulphide emissions to air. The BAT-AEL emission level is ? 2 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000783', 'Non-Ferrous Metals industries  - H2SO4 - BAT114-II', '2, Production and processing of metals: 2.5: Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Techniques (a)-(c) (see table incl. footnote); Reducing sulphuric acid emissions to air. The BAT-AEL emission level is < 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000784', 'Non-Ferrous Metals industries  - HCl - BAT124-I', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Techniques (a)-(b) (see table incl. footnote); Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is ? 1,5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000785', 'Non-Ferrous Metals industries  - HCl - BAT144-I', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Alkaline scrubber; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is ? 5-10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000786', 'Non-Ferrous Metals industries  - HCl - BAT84-I', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Techniques (a)-(d) (see table); Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is ? 5-10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000787', 'Non-Ferrous Metals industries  - HF - BAT124-II', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Techniques (a)-(b) (see table incl. footnote); Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is ? 0,3 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000788', 'Non-Ferrous Metals industries  - HF - BAT60-III', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Techniques (a)-(d) (see table incl. footnote); Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is 0,3-0,5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000789', 'Non-Ferrous Metals industries  - HF - BAT61-III', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Use a pre-filtration unit and a regenerative thermal oxidiser followed by a dry scrubber (e.g. lime bed); Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is ? 3 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000790', 'Non-Ferrous Metals industries  - HF - BAT67-II', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Techniques (a)-(b) (see table incl. footnote); Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is ? 1,0 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000791', 'Non-Ferrous Metals industries  - HF - BAT84-III', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Techniques (a)-(d) (see table incl. footnote); Reducing hydrogen fluoride emissions to air. The BAT-AEL emission level is ? 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000792', 'Non-Ferrous Metals industries  - Hg - BAT11', '2, Production and processing of metals: 2.1, Metal ore (including sulphide ore) roasting or sintering; 2.5, Processing of non-ferrous metals; Techniques: (a)-(b) (see table); Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 0,01 - 0,05 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000793', 'Non-Ferrous Metals industries  - Hg - BAT17-XVI', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing mercury to water. The BAT-AEL emission level is 0,005?0,02 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000794', 'Non-Ferrous Metals industries  - Hg - BAT17-XVII', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing mercury to water. The BAT-AEL emission level is ? 0,05 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000795', 'Non-Ferrous Metals industries  - NH3 - BAT145', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Wet scrubber with sulphuric acid; Reducing ammonia (NH3) emissions to air. The BAT-AEL emission level is 1 - 3 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000796', 'Non-Ferrous Metals industries  - NH3 - BAT89-I', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals; Techniques (a)-(c) (see table incl. footnote); Reducing ammonia (NH3) emissions to air. The BAT-AEL emission level is ? 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000797', 'Non-Ferrous Metals industries  - NOx - BAT141', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Techniques (a)-(b) (see table incl. footnote); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 70 - 150 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000798', 'Non-Ferrous Metals industries  - Ni - BAT17-XIX', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing nickel to water. The BAT-AEL emission level is ? 0,1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000799', 'Non-Ferrous Metals industries  - Ni - BAT17-XVIII', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing nickel to water. The BAT-AEL emission level is ? 0,5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000800', 'Non-Ferrous Metals industries  - Ni - BAT17-XX', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing nickel to water. The BAT-AEL emission level is ? 2 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000801', 'Non-Ferrous Metals industries  - Ni - BAT172-I', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Wet scrubber; Reducing nickel emissions to air. The BAT-AEL emission level is ? 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000802', 'Non-Ferrous Metals industries  - Ni - BAT173', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Bag filter; Reducing nickel emissions to air. The BAT-AEL emission level is ? 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000803', 'Non-Ferrous Metals industries  - PCDD.F - BAT123-II', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Techniques (a)-(c) (see table incl. footnote); Reducing PCDD/F emissions to air. The BAT-AEL emission level is ? 0,1 ng I-TEQ/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000804', 'Non-Ferrous Metals industries  - PCDD.F - BAT146', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Techniques (a)-(h) (see table incl. footnote); Reducing PCDD/F emissions to air. The BAT-AEL emission level is ? 0,1 ng I-TEQ/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000805', 'Non-Ferrous Metals industries  - PCDD.F - BAT159', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Inject adsorbents and to use an ESP and/or a bag filter; Reducing PCDD/F emissions to air. The BAT-AEL emission level is ? 0,05 ng I-TEQ/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000806', 'Non-Ferrous Metals industries  - PCDD.F - BAT48', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals; Techniques (a)-(j) (see table incl. footnote); Reducing PCDD/F emissions to air. The BAT-AEL emission level is ? 0,1 ng I-TEQ/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000807', 'Non-Ferrous Metals industries  - PCDD.F - BAT83-II', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Techniques (a)-(e) (see table); Reducing PCDD/F emissions to air. The BAT-AEL emission level is ? 0,1 ng I-TEQ/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000808', 'Non-Ferrous Metals industries  - PCDD.F - BAT99', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Techniques (a)-(j) (see table incl. footnote); Reducing PCDD/F emissions to air. The BAT-AEL emission level is ? 0,1 ng I-TEQ/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000809', 'Non-Ferrous Metals industries  - PH3 - BAT89-II', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals; Techniques (a)-(c) (see table incl. footnote); Reducing phosphene emissions to air. The BAT-AEL emission level is ? 0,5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000810', 'Non-Ferrous Metals industries  - Pb - BAT17-XXI', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing lead to water. The BAT-AEL emission level is ? 0,5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000811', 'Non-Ferrous Metals industries  - Pb - BAT17-XXII', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing lead to water. The BAT-AEL emission level is ? 0,2 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000812', 'Non-Ferrous Metals industries  - Pb - BAT96-II', '2, Production and processing of metals: 2.5: Processing of non-ferrous metals; Bag filter; Reducing lead emissions to air. The BAT-AEL emission level is ? 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000813', 'Non-Ferrous Metals industries  - Pb - BAT97-II', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Techniques (a)-(b) (see table); Reducing lead emissions to air. The BAT-AEL emission level is ? 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000814', 'Non-Ferrous Metals industries  - SO2 - BAT100', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Techniques (a)-(d) (see table incl. footnotes); Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 50-350 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000815', 'Non-Ferrous Metals industries  - SO2 - BAT120', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Wet desulphurisation technique; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is ? 500 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000816', 'Non-Ferrous Metals industries  - SO2 - BAT142', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Techniques (a)-(b) (see table incl. footnote); Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 50 - 480 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000817', 'Non-Ferrous Metals industries  - SO2 - BAT143', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Wet scrubber; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 50 - 100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000818', 'Non-Ferrous Metals industries  - SO2 - BAT49-I', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Techniques (a)-(c) (see table incl. footnote) in primary copper production; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 50-500 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000819', 'Non-Ferrous Metals industries  - SO2 - BAT49-II', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Techniques (a)-(c) (see table incl. footnote) in secondary copper production; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 50-300 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000820', 'Non-Ferrous Metals industries  - SO2 - BAT69', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Techniques (a)-(b) (see table incl. footnote); Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is ? 2,5-15 kg/ t Al.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000821', 'Non-Ferrous Metals industries  - TVOC - BAT123-I', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Techniques (a)-(c) (see table incl. footnote); Reducing TVOC emissions to air. The BAT-AEL emission level is 2 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000822', 'Non-Ferrous Metals industries  - TVOC - BAT183', '6.? Other activities: 6.8: Production of carbon (hard-burnt coal) or electrographite by means of incineration or graphitisation; Techniques (a)-(b) (see table incl. footnote); Reducing TVOC emissions to air. The BAT-AEL emission level is ? 10-40 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000823', 'Non-Ferrous Metals industries  - TVOC - BAT46', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals; Techniques (a)-(e) (see table incl. footnote); Reducing TVOC emissions to air. The BAT-AEL emission level is 3 - 30 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000824', 'Non-Ferrous Metals industries  - TVOC - BAT83-I', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Techniques (a)-(e) (see table); Reducing TVOC emissions to air. The BAT-AEL emission level is ? 10-30 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000825', 'Non-Ferrous Metals industries  - TVOC - BAT98', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals: (b) melting, including the alloyage, of non-ferrous metals, including recovered products and operation of non-ferrous metal foundries, with a melting capacity exceeding 4 tonnes per day for lead and cadmium or 20 tonnes per day for all other metals; Techniques (a)-(c) (see table incl. footnotes); Reducing TVOC emissions to air. The BAT-AEL emission level is 10 - 40 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000826', 'Non-Ferrous Metals industries  - Zn - BAT114-I', '2, Production and processing of metals: 2.5: Processing of non-ferrous metals: (a) production of non-ferrous crude metals from ore, concentrates or secondary raw materials by metallurgical, chemical or electrolytic processes; Techniques (a)-(c) (see table incl. footnote); Reducing zinc emissions to air. The BAT-AEL emission level is ? 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000827', 'Non-Ferrous Metals industries  - Zn - BAT17-XXIII', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing zinc to water. The BAT-AEL emission level is ? 1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000828', 'Non-Ferrous Metals industries  - Zn - BAT17-XXIV', '2, Production and processing of metals: 2.5, Processing of non-ferrous metals Reducing zinc to water. The BAT-AEL emission level is ? 0,4 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000829', 'Production of pulp, paper and board - AOX - BAT19-VI', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing adsorbable organically bound halogens (AOX) to water. The BAT-AEL emission level is 0 - 0,2 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000830', 'Production of pulp, paper and board - AOX - BAT33-IX', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing Adsorbable Organically Bound Halogens (AOX) to water. The BAT-AEL emission level is 0,5 ? 1,5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000831', 'Production of pulp, paper and board - AOX - BAT45-V', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing adsorbable organically bound halogens (AOX) to water. The BAT-AEL emission level is < 0,05 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000832', 'Production of pulp, paper and board - AOX - BAT45-XIV', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing adsorbable organically bound halogens (AOX) to water. The BAT-AEL emission level is < 0,05 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000833', 'Production of pulp, paper and board - AOX - BAT50-VI', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing Adsorbable Organically Bound Halogens (AOX) to water. The BAT-AEL emission level is 0,05 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000834', 'Production of pulp, paper and board - AOX - BAT50-XI', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing Adsorbable Organically Bound Halogens (AOX) to water. The BAT-AEL emission level is 0,05 kg/t .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000835', 'Production of pulp, paper and board - COD - BAT19-I', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is 7 - 20 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000836', 'Production of pulp, paper and board - COD - BAT19-VII', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is 2,5 - 8 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000837', 'Production of pulp, paper and board - COD - BAT33-I', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is 10 ? 30 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000838', 'Production of pulp, paper and board - COD - BAT33-II', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is 20 ? 35 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000839', 'Production of pulp, paper and board - COD - BAT33-X', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is 3,2 ? 11 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000840', 'Production of pulp, paper and board - COD - BAT40-I', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is 0,9 ? 4,5 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000841', 'Production of pulp, paper and board - COD - BAT40-V', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is 12 ? 20 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000842', 'Production of pulp, paper and board - COD - BAT45-I', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is 0,4 - 1,4 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000843', 'Production of pulp, paper and board - COD - BAT45-VI', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is 0,9 - 3 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000844', 'Production of pulp, paper and board - COD - BAT45-VII', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is 0,9 - 4 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000845', 'Production of pulp, paper and board - COD - BAT50-I', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is 0,15 ? 1,5 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000846', 'Production of pulp, paper and board - COD - BAT50-VII', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is 0,3 ? 5 kg/t .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000847', 'Production of pulp, paper and board - Dust - BAT23-I', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Use an electrostatic precipitator (ESP) or a combination of ESP and wet scrubber: see description (Section 1.7.1.1) for New or major refurbishment; Reducing dust emissions to air. The BAT-AEL emission level is 10 ? 25 mg/Nm3 at 6 % O2 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000848', 'Production of pulp, paper and board - Dust - BAT23-II', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Use an electrostatic precipitator (ESP) or a combination of ESP and wet scrubber: see description (Section 1.7.1.1) for Existing; Reducing dust emissions to air. The BAT-AEL emission level is 0,02 ? 0,20 kg dust/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000849', 'Production of pulp, paper and board - Dust - BAT23-III', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Use an electrostatic precipitator (ESP) or a combination of ESP and wet scrubber: see description (Section 1.7.1.1) for New or major refurbishment; Reducing dust emissions to air. The BAT-AEL emission level is 10 ? 40 mg/Nm3 at 6 % O2 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000850', 'Production of pulp, paper and board - Dust - BAT23-IV', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Use an electrostatic precipitator (ESP) or a combination of ESP and wet scrubber: see description (Section 1.7.1.1) for Existing; Reducing dust emissions to air. The BAT-AEL emission level is 0,02 ? 0,3 kg dust/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000851', 'Production of pulp, paper and board - Dust - BAT27-I', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Use an electrostatic precipitator (ESP) or a combination of ESP and wet scrubber: see description (Section 1.7.1.1.) for New or major refurbishments; Reducing dust emissions to air. The BAT-AEL emission level is 10 ? 25 mg/Nm3 at 6 % O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000852', 'Production of pulp, paper and board - Dust - BAT27-II', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Use an electrostatic precipitator (ESP) or a combination of ESP and wet scrubber: see description (Section 1.7.1.1.) for New or major refurbishments; Reducing dust emissions to air. The BAT-AEL emission level is 0,005 ? 0,02 kg dust/ADt .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000853', 'Production of pulp, paper and board - Dust - BAT27-III', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Use an electrostatic precipitator (ESP) or a combination of ESP and wet scrubber: see description (Section 1.7.1.1.) for Existing; Reducing dust emissions to air. The BAT-AEL emission level is 10 ? 30 mg/Nm3 at 6 % O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000854', 'Production of pulp, paper and board - Dust - BAT27-IV', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Use an electrostatic precipitator (ESP) or a combination of ESP and wet scrubber: see description (Section 1.7.1.1.) for Existing; Reducing dust emissions to air. The BAT-AEL emission level is 0,005 ? 0,03 kg dust/ADt .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000855', 'Production of pulp, paper and board - Dust - BAT37-I', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(b) (see table) and limit ?acid operation? of the scrubbers to the minimum required to ensure their proper functioning; Reducing dust emissions to air. The BAT-AEL emission level is 5 ? 20 mg/Nm3 at 5 % O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000856', 'Production of pulp, paper and board - N - BAT33-V', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total nitrogen to water. The BAT-AEL emission level is 0,15 ? 0,3 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000857', 'Production of pulp, paper and board - N - BAT33-VI', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total nitrogen to water. The BAT-AEL emission level is 0,1 ? 0,25 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000858', 'Production of pulp, paper and board - N - BAT33-XII', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total nitrogen to water. The BAT-AEL emission level is 0,1 ? 0,2 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000859', 'Production of pulp, paper and board - N - BAT40-III', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total nitrogen to water. The BAT-AEL emission level is 0,03 ? 0,1 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000860', 'Production of pulp, paper and board - N - BAT40-VII', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total nitrogen to water. The BAT-AEL emission level is 0,15 ? 0,18 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000861', 'Production of pulp, paper and board - N - BAT50-III', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total nitrogen to water. The BAT-AEL emission level is 0,01 ? 0,1 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000862', 'Production of pulp, paper and board - N - BAT50-IV', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total nitrogen to water. The BAT-AEL emission level is 0,01 ? 0,15 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000863', 'Production of pulp, paper and board - N - BAT50-IX', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total nitrogen to water. The BAT-AEL emission level is 0,015 ? 0,4 kg/t .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000864', 'Production of pulp, paper and board - NH3 - BAT36-III', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(c) (see table); Reducing ammonia (NH3) emissions to air. The BAT-AEL emission level is < 5 mg/Nm3 at 5 % O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000865', 'Production of pulp, paper and board - NO2 - BAT22-I', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(c) (see table); Reducing nitrous oxides (NOx) emissions to air. The BAT-AEL emission level is 120 ? 200 mg/Nm3 at 6 % O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000866', 'Production of pulp, paper and board - NO2 - BAT22-II', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(c) (see table); Reducing nitrous oxides (NOx) emissions to air. The BAT-AEL emission level is 0,8 ? 1,4 kg NOx/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000867', 'Production of pulp, paper and board - NO2 - BAT22-III', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(c) (see table); Reducing nitrous oxides (NOx) emissions to air. The BAT-AEL emission level is 1,0 ? 1,6 kg NOx/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000868', 'Production of pulp, paper and board - NO2 - BAT22-IV', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(c) (see table); Reducing nitrous oxides (NOx) emissions to air. The BAT-AEL emission level is 120 ? 200 mg/Nm3 at 6 % O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000869', 'Production of pulp, paper and board - NO2 - BAT22-V', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(c) (see table); Reducing nitrous oxides (NOx) emissions to air. The BAT-AEL emission level is 0,8 ? 1,4 kg NOx/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000870', 'Production of pulp, paper and board - NO2 - BAT22-VI', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(c) (see table); Reducing nitrous oxides (NOx) emissions to air. The BAT-AEL emission level is 1,0 ? 1,7 kg NOx/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000871', 'Production of pulp, paper and board - NO2 - BAT26-I', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(d) (see table); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 100 ? 200 mg/Nm3 at 6 % O2 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000872', 'Production of pulp, paper and board - NO2 - BAT26-II', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(d) (see table); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 0,1 ? 0,2 kg NOx/ADt .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000873', 'Production of pulp, paper and board - NO2 - BAT26-III', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(d) (see table); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 100 ? 350 mg/Nm3 at 6 % O2 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000874', 'Production of pulp, paper and board - NO2 - BAT26-IV', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(d) (see table); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 0,1 ? 0,3 kg NOx/ADt .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000875', 'Production of pulp, paper and board - NO2 - BAT29-I', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(b) (see table); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 50 ? 400 mg/Nm3 at 9 % O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000876', 'Production of pulp, paper and board - NO2 - BAT29-II', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(b) (see table); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 0,01 ? 0,1 kg NOx/ADt .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000877', 'Production of pulp, paper and board - NO2 - BAT36-I', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(c) (see table); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 100 ? 350 mg/Nm3 at 5 % O2 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000878', 'Production of pulp, paper and board - NO2 - BAT36-II', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(c) (see table); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 100 ? 270 mg/Nm3 at 5 % O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000879', 'Production of pulp, paper and board - S - BAT21-V', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(c) (see table); Reducing total reduced sulphur (TRS) emissions to air. The BAT-AEL emission level is 1 ? 10 mg/Nm3 at 6 % O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000880', 'Production of pulp, paper and board - S - BAT21-VI', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(c) (see table); Reducing total reduced sulphur (TRS) emissions to air. The BAT-AEL emission level is 1 ? 5 mg/Nm3 at 6 % O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000881', 'Production of pulp, paper and board - S - BAT21-VII', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(c) (see table); Reducing gaseous S emissions to air. The BAT-AEL emission level is 0,03 ? 0,17 kg S/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000882', 'Production of pulp, paper and board - S - BAT21-VIII', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(c) (see table); Reducing gaseous S emissions to air. The BAT-AEL emission level is 0,03 ? 0,13 kg S/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000883', 'Production of pulp, paper and board - S - BAT24-III', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(d) (see table); Reducing gaseous S emissions to air. The BAT-AEL emission level is 0,005 ? 0,07 kg S/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000884', 'Production of pulp, paper and board - S - BAT24-IV', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(d) (see table); Reducing gaseous S emissions to air. The BAT-AEL emission level is 0,055 ? 0,12 kg S/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000885', 'Production of pulp, paper and board - S - BAT28-II', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Use an alkaline SO2 scrubber; Reducing TRS emissions to air. The BAT-AEL emission level is 1 ? 5 mg/Nm3 at 9 % O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000886', 'Production of pulp, paper and board - S - BAT28-III', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Use an alkaline SO2 scrubber; Reducing gaseous S emissions to air. The BAT-AEL emission level is 0,002 ? 0,05 kg S/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000887', 'Production of pulp, paper and board - SO2 - BAT21-I', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(c) (see table); Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 10 ? 70 mg/Nm3 at 6 % O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000888', 'Production of pulp, paper and board - SO2 - BAT21-II', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(c) (see table); Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 5 ? 50 mg/Nm3 at 6 % O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000889', 'Production of pulp, paper and board - SO2 - BAT21-III', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(c) (see table); Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 10 ? 50 mg/Nm3 at 6 % O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000890', 'Production of pulp, paper and board - SO2 - BAT21-IV', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(c) (see table); Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 5 ? 25 mg/Nm3 at 6 % O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000891', 'Production of pulp, paper and board - SO2 - BAT24-I', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(d) (see table); Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 5 ? 70 mg SO2/Nm3 at 6 % O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000892', 'Production of pulp, paper and board - SO2 - BAT24-II', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(d) (see table); Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 55 ? 120 mg SO2/Nm3 at 6 % O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000893', 'Production of pulp, paper and board - SO2 - BAT28-I', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Use an alkaline SO2 scrubber; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 20 ? 120 mg/Nm3 at 9 % O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000894', 'Production of pulp, paper and board - SO2 - BAT37-II', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(b) (see table) and limit ?acid operation? of the scrubbers to the minimum required to ensure their proper functioning; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 100 ? 300 mg/Nm3 at 5 % O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000895', 'Production of pulp, paper and board - SO2 - BAT37-III', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(b) (see table) and limit ?acid operation? of the scrubbers to the minimum required to ensure their proper functioning; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 50 ? 250 mg/Nm3 at 5 % O2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000896', 'Production of pulp, paper and board - TN - BAT19-III', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total nitrogen to water. The BAT-AEL emission level is 0,05 - 0,25 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000897', 'Production of pulp, paper and board - TN - BAT19-IX', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total nitrogen to water. The BAT-AEL emission level is 0,1 - 0,2 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000898', 'Production of pulp, paper and board - TN - BAT45-III', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total nitrogen to water. The BAT-AEL emission level is 0,008 - 0,09 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000899', 'Production of pulp, paper and board - TN - BAT45-X', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total nitrogen to water. The BAT-AEL emission level is 0,01 - 0,1 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000900', 'Production of pulp, paper and board - TN - BAT45-XI', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total nitrogen to water. The BAT-AEL emission level is 0,01 - 0,15 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000901', 'Production of pulp, paper and board - TP - BAT19-IV', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total phosphorus to water. The BAT-AEL emission level is 0,01 - 0,03 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000902', 'Production of pulp, paper and board - TP - BAT19-V', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total phosphorus to water. The BAT-AEL emission level is 0,02 - 0,11 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000903', 'Production of pulp, paper and board - TP - BAT19-X', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total phosphorus to water. The BAT-AEL emission level is 0,01 - 0,02 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000904', 'Production of pulp, paper and board - TP - BAT33-VII', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total phosphorous to water. The BAT-AEL emission level is 0,01 ? 0,05 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000905', 'Production of pulp, paper and board - TP - BAT33-VIII', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total phosphorous to water. The BAT-AEL emission level is 0,01 ? 0,07 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000906', 'Production of pulp, paper and board - TP - BAT33-XIII', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total phosphorus to water. The BAT-AEL emission level is 0,01 ? 0,02 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000907', 'Production of pulp, paper and board - TP - BAT40-IV', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total phosphorus to water. The BAT-AEL emission level is 0,001 ? 0,01 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000908', 'Production of pulp, paper and board - TP - BAT40-VIII', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total phosphorus to water. The BAT-AEL emission level is 0,001 ? 0,01 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000909', 'Production of pulp, paper and board - TP - BAT45-IV', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total phosphorus to water. The BAT-AEL emission level is 0,001 - 0,005 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000910', 'Production of pulp, paper and board - TP - BAT45-XII', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total phosphorus to water. The BAT-AEL emission level is 0,002 - 0,01 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000911', 'Production of pulp, paper and board - TP - BAT45-XIII', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total phosphorus to water. The BAT-AEL emission level is 0,002 - 0,015 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000912', 'Production of pulp, paper and board - TP - BAT50-V', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total phosphorus to water. The BAT-AEL emission level is 0,003 ? 0,012 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000913', 'Production of pulp, paper and board - TP - BAT50-X', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total phosphorus to water. The BAT-AEL emission level is 0,002 ? 0,04 kg/t .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000914', 'Production of pulp, paper and board - TRS - BAT20', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(c) (see table incl. footnotes); Reducing total reduced sulphur (TRS) emissions to air. The BAT-AEL emission level is 0,05 - 0,2 kg/Adt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000915', 'Production of pulp, paper and board - TRS - BAT25-I', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(c) (see table incl. footnotes); Reducing total reduced sulphur (TRS) emissions to air. The BAT-AEL emission level is < 1 - 10 mg S/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000916', 'Production of pulp, paper and board - TRS - BAT25-II', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Techniques (a)-(c) (see table incl. footnotes); Reducing total reduced sulphur (TRS) emissions to air. The BAT-AEL emission level is < 1 - 40 mg S/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000917', 'Production of pulp, paper and board - TSS - BAT19-II', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total suspended solids (TSS) to water. The BAT-AEL emission level is 0,3 - 1,5 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000918', 'Production of pulp, paper and board - TSS - BAT19-VIII', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total suspended solids (TSS) to water. The BAT-AEL emission level is 0,3 - 1 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000919', 'Production of pulp, paper and board - TSS - BAT33-III', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total suspended solids (TSS) to water. The BAT-AEL emission level is 0,4 ? 1,5 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000920', 'Production of pulp, paper and board - TSS - BAT33-IV', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total suspended solids (TSS) to water. The BAT-AEL emission level is 0,5 ? 2,0 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000921', 'Production of pulp, paper and board - TSS - BAT33-XI', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total suspended solids (TSS) to water. The BAT-AEL emission level is 0,5 ? 1,3 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000922', 'Production of pulp, paper and board - TSS - BAT40-II', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total suspended solids (TSS) to water. The BAT-AEL emission level is 0,06 ? 0,45 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000923', 'Production of pulp, paper and board - TSS - BAT40-VI', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total suspended solids (TSS) to water. The BAT-AEL emission level is 0,5 ? 0,9 kg/ADt.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000924', 'Production of pulp, paper and board - TSS - BAT45-II', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total suspended solids (TSS) to water. The BAT-AEL emission level is 0,02 - 0,2 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000925', 'Production of pulp, paper and board - TSS - BAT45-IX', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total suspended solids (TSS) to water. The BAT-AEL emission level is 0,1 - 0,4 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000926', 'Production of pulp, paper and board - TSS - BAT45-VIII', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total suspended solids (TSS) to water. The BAT-AEL emission level is 0,08 - 0,3 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000927', 'Production of pulp, paper and board - TSS - BAT50-II', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total suspended solids (TSS) to water. The BAT-AEL emission level is 0,02 ? 0,35 kg/t.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000928', 'Production of pulp, paper and board - TSS - BAT50-VIII', '6. Other activities: 6.1 Production in industrial installations of:(a) pulp from timber or other fibrous materials;(b) paper or card board; Reducing total suspended solids (TSS) to water. The BAT-AEL emission level is 0,10 ? 1 kg/t .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000929', 'Refining of mineral oil and gas - Benzene - BAT12-IX', 'Energy industries : 1.2 Refining of mineral oil and gas Reducing benzene to water. The BAT-AEL emission level is 0,001 - 0,05 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000930', 'Refining of mineral oil and gas - Benzene - BAT52-II', 'Energy industries : 1.2 Refining of mineral oil and gas; Techniques (i) - (v) (see table); Reducing benzene emissions to air. The BAT-AEL emission level is  < 1 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000931', 'Refining of mineral oil and gas - CO - BAT27', 'Energy industries : 1.2 Refining of mineral oil and gas; Partial combustion mode; Reducing carbon monoxide (CO) emissions to air. The BAT-AEL emission level is ? 100  mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000932', 'Refining of mineral oil and gas - CO - BAT37', 'Energy industries : 1.2 Refining of mineral oil and gas; Combustion operation control; Reducing carbon monoxide (CO) emissions to air. The BAT-AEL emission level is  ? 100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000933', 'Refining of mineral oil and gas - COD - BAT12-III', 'Energy industries : 1.2 Refining of mineral oil and gas Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is 30 - 125 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000934', 'Refining of mineral oil and gas - Cd - BAT12-VI', 'Energy industries : 1.2 Refining of mineral oil and gas Reducing cadmium to water. The BAT-AEL emission level is 0,002 - 0,008 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000935', 'Refining of mineral oil and gas - Dust - BAT25-I', 'Energy industries : 1.2 Refining of mineral oil and gas; Techniques I - II (see table); for New unit; Reducing dust emissions to air. The BAT-AEL emission level is 10 - 25 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000936', 'Refining of mineral oil and gas - Dust - BAT25-II', 'Energy industries : 1.2 Refining of mineral oil and gas; Techniques I - II (see table); for Existing unit; Reducing dust emissions to air. The BAT-AEL emission level is 10 - 50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000937', 'Refining of mineral oil and gas - Dust - BAT32', 'Energy industries : 1.2 Refining of mineral oil and gas; Techniques (i) - (ii) (see table); Reducing dust emissions to air. The BAT-AEL emission level is 10 - 50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000938', 'Refining of mineral oil and gas - Dust - BAT35-I', 'Energy industries : 1.2 Refining of mineral oil and gas; Multi-fuel firing for Existing unit; Reducing dust emissions to air. The BAT-AEL emission level is 5 - 50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000939', 'Refining of mineral oil and gas - Dust - BAT35-II', 'Energy industries : 1.2 Refining of mineral oil and gas; Multi-fuel firing for New unit < 50 MW; Reducing dust emissions to air. The BAT-AEL emission level is 5 - 25 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000940', 'Refining of mineral oil and gas - HOI - BAT12-I', 'Energy industries : 1.2 Refining of mineral oil and gas Reducing hydrocarbon oil index (HOI) to water. The BAT-AEL emission level is 0,1 - 2,5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000941', 'Refining of mineral oil and gas - Hg - BAT12-VIII', 'Energy industries : 1.2 Refining of mineral oil and gas Reducing mercury to water. The BAT-AEL emission level is 0,0001 - 0,001 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000942', 'Refining of mineral oil and gas - N - BAT12-IV', 'Energy industries : 1.2 Refining of mineral oil and gas Reducing total nitrogen to water. The BAT-AEL emission level is 1 - 25 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000943', 'Refining of mineral oil and gas - NH3 - BAT8', '1, Energy industries : 1.2 Refining of mineral oil and gas; SCR/SNCR; Reducing ammonia (NH3) emissions to air. The BAT-AEL emission level is < 5 - 15 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000944', 'Refining of mineral oil and gas - NMVOC - BAT52-I', 'Energy industries : 1.2 Refining of mineral oil and gas; Techniques (i) - (v) (see table); Reducing NMVOC emissions to air. The BAT-AEL emission level is 0,15 - 10 g/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000945', 'Refining of mineral oil and gas - NO2 - BAT24-I', 'Energy industries : 1.2 Refining of mineral oil and gas; All combustion modes for New unit; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 30 - 100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000946', 'Refining of mineral oil and gas - NO2 - BAT24-II', 'Energy industries : 1.2 Refining of mineral oil and gas; Full combustion mode for Existing unit; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is < 100 - 300 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000947', 'Refining of mineral oil and gas - NO2 - BAT24-III', 'Energy industries : 1.2 Refining of mineral oil and gas; Partial combustion mode for Existing unit; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 100 - 400 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000948', 'Refining of mineral oil and gas - NO2 - BAT34-I', 'Energy industries : 1.2 Refining of mineral oil and gas; Combustion unit for Existing turbine; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 40 - 120 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000949', 'Refining of mineral oil and gas - NO2 - BAT34-II', 'Energy industries : 1.2 Refining of mineral oil and gas; Gas turbine (including combined cycle gas turbine ? CCGT) and integrated gasification combined cycle turbine (IGCC)) for New turbine; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 20 - 50 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000950', 'Refining of mineral oil and gas - NO2 - BAT34-III', 'Energy industries : 1.2 Refining of mineral oil and gas; Gas firing with exception of gas turbines for Existing unit; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 30 - 150 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000951', 'Refining of mineral oil and gas - NO2 - BAT34-IV', 'Energy industries : 1.2 Refining of mineral oil and gas; Gas firing with exception of gas turbines for New unit; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 30 - 100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000952', 'Refining of mineral oil and gas - NO2 - BAT34-V', 'Energy industries : 1.2 Refining of mineral oil and gas; Multi-fuel fired combustion unit for Existing unit - should cover both new and existing ones; Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 30 - 300 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000953', 'Refining of mineral oil and gas - Ni - BAT12-VII', 'Energy industries : 1.2 Refining of mineral oil and gas Reducing nickel to water. The BAT-AEL emission level is 0,005 - 0,1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000954', 'Refining of mineral oil and gas - Pb - BAT12-V', 'Energy industries : 1.2 Refining of mineral oil and gas Reducing lead to water. The BAT-AEL emission level is 0,005 - 0,03 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000955', 'Refining of mineral oil and gas - SO2 - BAT26-I', 'Energy industries : 1.2 Refining of mineral oil and gas; Techniques I - II (see table); for New units; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is ? 300  - mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000956', 'Refining of mineral oil and gas - SO2 - BAT26-II', 'Energy industries : 1.2 Refining of mineral oil and gas; Full combustion mode for Existing units; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is < 100 - 800 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000957', 'Refining of mineral oil and gas - SO2 - BAT26-III', 'Energy industries : 1.2 Refining of mineral oil and gas; Partial combustion mode for Existing units; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is < 100 - 1200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000958', 'Refining of mineral oil and gas - SO2 - BAT36-I', 'Energy industries : 1.2 Refining of mineral oil and gas; RFG; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 5 - 35 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000959', 'Refining of mineral oil and gas - SO2 - BAT36-II', 'Energy industries : 1.2 Refining of mineral oil and gas; Multi-fuel fired combustion units, with the exception of gas turbines and stationary gas engines for Existing units; Reducing sulphur dioxide (SO2) emissions to air. The BAT-AEL emission level is 35 - 600 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000960', 'Refining of mineral oil and gas - TSS - BAT12-II', 'Energy industries : 1.2 Refining of mineral oil and gas Reducing total suspended solids (TSS) to water. The BAT-AEL emission level is 5 - 25 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000961', 'Tanning of Hides and Skins - BOD5 - BAT10-III', '6, Other activities: 6,3 Tanning of hides and skins where the treatment capacity exceeds 12?tonnes of finished products per day Reducing biological oxygen demand for 5 days (BOD5) to water. The BAT-AEL emission level is 15 - 25 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000962', 'Tanning of Hides and Skins - BOD5 - BAT10-IV', '6, Other activities: 6,11 Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under 6.3 Reducing biological oxygen demand for 5 days (BOD5) to water. The BAT-AEL emission level is 15 - 25 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000963', 'Tanning of Hides and Skins - COD - BAT10-I', '6, Other activities: 6,3 Tanning of hides and skins where the treatment capacity exceeds 12?tonnes of finished products per day Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is 200 - 500 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000964', 'Tanning of Hides and Skins - COD - BAT10-II', '6, Other activities: 6,11 Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under 6.3 Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is 200 - 500 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000965', 'Tanning of Hides and Skins - Cr - BAT10-IX', '6, Other activities: 6,3 Tanning of hides and skins where the treatment capacity exceeds 12?tonnes of finished products per day Reducing total chromium to water. The BAT-AEL emission level is < 0,3 - 1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000966', 'Tanning of Hides and Skins - Cr - BAT10-X', '6, Other activities: 6,11 Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under 6.3 Reducing total chromium to water. The BAT-AEL emission level is < 0,3 - 1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000967', 'Tanning of Hides and Skins - Cr - BAT11-I', '6, Other activities: 6,3 Tanning of hides and skins where the treatment capacity exceeds 12?tonnes of finished products per day Reducing total chromium to water. The BAT-AEL emission level is < 0,3 - 1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000968', 'Tanning of Hides and Skins - Cr - BAT11-II', '6, Other activities: 6,11 Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under 6.3 Reducing total chromium to water. The BAT-AEL emission level is < 0,3 - 1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000969', 'Tanning of Hides and Skins - Cr - BAT11-III', '6, Other activities: 6,3 Tanning of hides and skins where the treatment capacity exceeds 12?tonnes of finished products per day Reducing total chromium to water. The BAT-AEL emission level is < 0,3 - 1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000970', 'Tanning of Hides and Skins - Cr - BAT12-I', '6, Other activities: 6,3 Tanning of hides and skins where the treatment capacity exceeds 12?tonnes of finished products per day Reducing total chromium to water. The BAT-AEL emission level is < 0,3 - 1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000971', 'Tanning of Hides and Skins - N - BAT10-VII', '6, Other activities: 6,3 Tanning of hides and skins where the treatment capacity exceeds 12?tonnes of finished products per day Reducing ammoniacal nitrogen (NH4-N) to water. The BAT-AEL emission level is  < 10 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000972', 'Tanning of Hides and Skins - N - BAT10-VIII', '6, Other activities: 6,11 Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under 6.3 Reducing ammoniacal nitrogen (NH4-N) to water. The BAT-AEL emission level is  < 10 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000973', 'Tanning of Hides and Skins - PM - BAT20', '6, Other activities: 6,3 Tanning of hides and skins where the treatment capacity exceeds 12?tonnes of finished products per day; Extraction ventilation system with bag filters or wet scrubbers; Reducing particulate matter emissions to air. The BAT-AEL emission level is 3 - 6 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000974', 'Tanning of Hides and Skins - S - BAT10-XI', '6, Other activities: 6,3 Tanning of hides and skins where the treatment capacity exceeds 12?tonnes of finished products per day Reducing sulphide to water. The BAT-AEL emission level is  < 1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000975', 'Tanning of Hides and Skins - S - BAT10-XII', '6, Other activities: 6,11 Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under 6.3 Reducing sulphide to water. The BAT-AEL emission level is  < 1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000976', 'Tanning of Hides and Skins - S - BAT12-II', '6, Other activities: 6,3 Tanning of hides and skins where the treatment capacity exceeds 12?tonnes of finished products per day Reducing sulphide to water. The BAT-AEL emission level is  < 1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000977', 'Tanning of Hides and Skins - SS - BAT10-V', '6, Other activities: 6,3 Tanning of hides and skins where the treatment capacity exceeds 12?tonnes of finished products per day Reducing suspended solids to water. The BAT-AEL emission level is  < 35 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000978', 'Tanning of Hides and Skins - SS - BAT10-VI', '6, Other activities: 6,11 Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under 6.3 Reducing suspended solids to water. The BAT-AEL emission level is  < 35 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000979', 'Tanning of Hides and Skins - TC - BAT19', '6, Other activities: 6,3 Tanning of hides and skins where the treatment capacity exceeds 12?tonnes of finished products per day; Techniques (a)-(b) (see table); Reducing volatile organic compounds (VOC) emissions to air. The BAT-AEL emission level is 9 - 23 g/m2.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000980', 'Production of Wood-based Panels - C - BAT17-IV', '6, Other activities: 6,1 Production in industrial installations of: (c) one or more of the following wood-based panels: oriented strand board, particleboard or fibreboard with a production capacity exceeding 600 m3 per day; For PB and all dryer types; Reducing total Volatile Organic Compounds (TVOC) emissions to air. The BAT-AEL emission level is < 20 - 200 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000981', 'Production of Wood-based Panels - C - BAT17-V', '6, Other activities: 6,1 Production in industrial installations of: (c) one or more of the following wood-based panels: oriented strand board, particleboard or fibreboard with a production capacity exceeding 600 m3 per day; For OSB and all dryer types; Reducing total Volatile Organic Compounds (TVOC) emissions to air. The BAT-AEL emission level is 10 - 400 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000982', 'Production of Wood-based Panels - C - BAT17-VI', '6, Other activities: 6,1 Production in industrial installations of: (c) one or more of the following wood-based panels: oriented strand board, particleboard or fibreboard with a production capacity exceeding 600 m3 per day; For fibre and all dryer types; Reducing total Volatile Organic Compounds (TVOC) emissions to air. The BAT-AEL emission level is < 20 - 120 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000983', 'Production of Wood-based Panels - C - BAT19-II', '6, Other activities: 6,1 Production in industrial installations of: (c) one or more of the following wood-based panels: oriented strand board, particleboard or fibreboard with a production capacity exceeding 600 m3 per day; Techniques (a)-(f) (see table); Reducing total Volatile Organic Compounds (TVOC) emissions to air. The BAT-AEL emission level is 10 - 100 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000984', 'Production of Wood-based Panels - C - BAT21-I', '6, Other activities: 6,1 Production in industrial installations of: (c) one or more of the following wood-based panels: oriented strand board, particleboard or fibreboard with a production capacity exceeding 600 m3 per day; Techniques (a)-(e) (see table); Reducing total Volatile Organic Compounds (TVOC) emissions to air. The BAT-AEL emission level is 5 - 30 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000985', 'Production of Wood-based Panels - CH2O - BAT17-IX', '6, Other activities: 6,1 Production in industrial installations of: (c) one or more of the following wood-based panels: oriented strand board, particleboard or fibreboard with a production capacity exceeding 600 m3 per day; For fibre and all dryer types; Reducing formaldehyde emissions to air. The BAT-AEL emission level is < 5 - 15 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000986', 'Production of Wood-based Panels - CH2O - BAT17-VII', '6, Other activities: 6,1 Production in industrial installations of: (c) one or more of the following wood-based panels: oriented strand board, particleboard or fibreboard with a production capacity exceeding 600 m3 per day; For PB and all dryer types; Reducing formaldehyde emissions to air. The BAT-AEL emission level is < 5 - 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000987', 'Production of Wood-based Panels - CH2O - BAT17-VIII', '6, Other activities: 6,1 Production in industrial installations of: (c) one or more of the following wood-based panels: oriented strand board, particleboard or fibreboard with a production capacity exceeding 600 m3 per day; For OSB and all dryer types; Reducing formaldehyde emissions to air. The BAT-AEL emission level is < 5 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000988', 'Production of Wood-based Panels - CH2O - BAT19-III', '6, Other activities: 6,1 Production in industrial installations of: (c) one or more of the following wood-based panels: oriented strand board, particleboard or fibreboard with a production capacity exceeding 600 m3 per day; Techniques (a)-(f) (see table); Reducing formaldehyde emissions to air. The BAT-AEL emission level is 2 - 15 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000989', 'Production of Wood-based Panels - CH2O - BAT21-II', '6, Other activities: 6,1 Production in industrial installations of: (c) one or more of the following wood-based panels: oriented strand board, particleboard or fibreboard with a production capacity exceeding 600 m3 per day; Techniques (a)-(e) (see table); Reducing formaldehyde emissions to air. The BAT-AEL emission level is < 5 - 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000990', 'Production of Wood-based Panels - COD - BAT27-II', '6, Other activities: 6,1 Production in industrial installations of: (c) one or more of the following wood-based panels: oriented strand board, particleboard or fibreboard with a production capacity exceeding 600 m3 per day. Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is 20 - 200 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000991', 'Production of Wood-based Panels - NO2 - BAT18', '6, Other activities: 6,1 Production in industrial installations of: (c) one or more of the following wood-based panels: oriented strand board, particleboard or fibreboard with a production capacity exceeding 600 m3 per day; Techniques (a)-(b) (see table); Reducing nitrogen oxides (NOx) emissions to air. The BAT-AEL emission level is 30 - 250 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000992', 'Production of Wood-based Panels - TPM - BAT17-I', '6, Other activities: 6,1 Production in industrial installations of: (c) one or more of the following wood-based panels: oriented strand board, particleboard or fibreboard with a production capacity exceeding 600 m3 per day; For PB or OSB and directly heated dryer; Reducing dust emissions to air. The BAT-AEL emission level is 3 - 30 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000993', 'Production of Wood-based Panels - TPM - BAT17-II', '6, Other activities: 6,1 Production in industrial installations of: (c) one or more of the following wood-based panels: oriented strand board, particleboard or fibreboard with a production capacity exceeding 600 m3 per day; For PB or OSB and indirectly heated dryer; Reducing dust emissions to air. The BAT-AEL emission level is 3 - 10 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000994', 'Production of Wood-based Panels - TPM - BAT17-III', '6, Other activities: 6,1 Production in industrial installations of: (c) one or more of the following wood-based panels: oriented strand board, particleboard or fibreboard with a production capacity exceeding 600 m3 per day; For fibre and all dryer types; Reducing dust emissions to air. The BAT-AEL emission level is 3 - 20 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000995', 'Production of Wood-based Panels - TPM - BAT19-I', '6, Other activities: 6,1 Production in industrial installations of: (c) one or more of the following wood-based panels: oriented strand board, particleboard or fibreboard with a production capacity exceeding 600 m3 per day; Techniques (a)-(f) (see table); Reducing dust emissions to air. The BAT-AEL emission level is 3 - 15 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000996', 'Production of Wood-based Panels - TPM - BAT20', '6, Other activities: 6,1 Production in industrial installations of: (c) one or more of the following wood-based panels: oriented strand board, particleboard or fibreboard with a production capacity exceeding 600 m3 per day; Bag filter or cyclofilter; Reducing dust emissions to air. The BAT-AEL emission level is < 3 - 5 mg/Nm3.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000997', 'Production of Wood-based Panels - TSS - BAT25', '6, Other activities: 6,1 Production in industrial installations of: (c) one or more of the following wood-based panels: oriented strand board, particleboard or fibreboard with a production capacity exceeding 600 m3 per day. Reducing total suspended solids (TSS) to water. The BAT-AEL emission level is 10 - 40 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000998', 'Production of Wood-based Panels - TSS - BAT27-I', '6, Other activities: 6,1 Production in industrial installations of: (c) one or more of the following wood-based panels: oriented strand board, particleboard or fibreboard with a production capacity exceeding 600 m3 per day. Reducing total suspended solids (TSS) to water. The BAT-AEL emission level is 5 - 35 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0000999', 'Waste Treatment - AOX - BAT20-XIV', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing adsorbable organically bound halogens to water. The BAT-AEL emission level is 0,2-1 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001000', 'Waste Treatment - AOX - BAT20-XXXIV', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing adsorbable organically bound halogens to water. The BAT-AEL emission level is 0,2-1 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001001', 'Waste Treatment - As - BAT20-XLIII', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing arsenic to water. The BAT-AEL emission level is 0,01-0,1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001002', 'Waste Treatment - As - BAT20-XV', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing arsenic to water. The BAT-AEL emission level is 0,01-0,05 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001003', 'Waste Treatment - As - BAT20-XXIII', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing arsenic to water. The BAT-AEL emission level is 0,01-0,1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001004', 'Waste Treatment - As - BAT20-XXXV', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing arsenic to water. The BAT-AEL emission level is 0,01-0,05 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001005', 'Waste Treatment - CFCs - BAT29-II', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above; Apply BAT 14d, BAT 14h and use technique (a) and one or both of the techniques (b) and (c); Reducing CFCs emissions to air. The BAT-AEL emission level is 0,5-10 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001006', 'Waste Treatment - CN - BAT20-XIII', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing free cyanide to water. The BAT-AEL emission level is 0,02-0,1 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001007', 'Waste Treatment - CN - BAT20-XXXIII', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing free cyanide to water. The BAT-AEL emission level is 0,02-0,1 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001008', 'Waste Treatment - COD - BAT20-III', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is 30-180 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001009', 'Waste Treatment - COD - BAT20-IV', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing chemical oxygen demand (COD) to water. The BAT-AEL emission level is 30-300 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001010', 'Waste Treatment - Cd - BAT20-XLIV', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing cadmium to water. The BAT-AEL emission level is 0,01-0,1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001011', 'Waste Treatment - Cd - BAT20-XVI', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing cadmium to water. The BAT-AEL emission level is 0,01-0,05 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001012', 'Waste Treatment - Cd - BAT20-XXIV', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing cadmium to water. The BAT-AEL emission level is 0,01-0,1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001013', 'Waste Treatment - Cd - BAT20-XXXVI', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing cadmium to water. The BAT-AEL emission level is 0,01-0,05 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001014', 'Waste Treatment - Cr - BAT20-XLV', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing chromium to water. The BAT-AEL emission level is 0,01-0,3 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001015', 'Waste Treatment - Cr - BAT20-XLVI', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing hexavalent chromium to water. The BAT-AEL emission level is 0,01-0,1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001016', 'Waste Treatment - Cr - BAT20-XVII', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing chromium to water. The BAT-AEL emission level is 0,01-0,15 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001017', 'Waste Treatment - Cr - BAT20-XXV', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing chromium to water. The BAT-AEL emission level is 0,01-0,3 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001018', 'Waste Treatment - Cr - BAT20-XXVI', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing hexavalent chromium to water. The BAT-AEL emission level is 0,01-0,1 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001019', 'Waste Treatment - Cr - BAT20-XXXVII', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing chromium to water. The BAT-AEL emission level is 0,01-0,15 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001020', 'Waste Treatment - Cu - BAT20-XLVII', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing copper to water. The BAT-AEL emission level is 0,05-0,5 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001021', 'Waste Treatment - Cu - BAT20-XVIII', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing copper to water. The BAT-AEL emission level is 0,05-0,5 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001022', 'Waste Treatment - Cu - BAT20-XXVII', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing copper to water. The BAT-AEL emission level is 0,05-0,5 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001023', 'Waste Treatment - Cu - BAT20-XXXVIII', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing copper to water. The BAT-AEL emission level is 0,05-0,5 mg/l.', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001024', 'Waste Treatment - Dust - BAT25', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above; Techniques (a)-(r) (see table incl. footnotes) for treatment of water-based liquid waste; Reducing dust emissions to air. The BAT-AEL emission level is 2-5 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001025', 'Waste Treatment - Dust - BAT34-III', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above; Techniques (a)-(e) (see table); Reducing dust emissions to air. The BAT-AEL emission level is 2-5 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001026', 'Waste Treatment - Dust - BAT41', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above; Reducing dust emissions to air. The BAT-AEL emission level is 2-5 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001027', 'Waste Treatment - HCl - BAT53-I', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above; Reducing hydrogen chloride emissions to air. The BAT-AEL emission level is 1-5 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001028', 'Waste Treatment - HOI - BAT20-VI', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing hydrocarbon oil index to water. The BAT-AEL emission level is 0,5-10 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001029', 'Waste Treatment - HOI - BAT20-XXXII', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing hydrocarbon oil index to water. The BAT-AEL emission level is 0,5-10 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001030', 'Waste Treatment - Hg - BAT20-L', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing mercury to water. The BAT-AEL emission level is 1-10 ?g/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001031', 'Waste Treatment - Hg - BAT20-XLI', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing mercury to water. The BAT-AEL emission level is 0,5-5 ?g/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001032', 'Waste Treatment - Hg - BAT20-XXI', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing mercury to water. The BAT-AEL emission level is 0,5-5 ?g/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001033', 'Waste Treatment - Hg - BAT20-XXX', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing mercury to water. The BAT-AEL emission level is 1-10 ?g/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001034', 'Waste Treatment - Hg - BAT32', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above; Techniques (a)-(d) (see table); Reducing mercury emissions to air. The BAT-AEL emission level is 2-7 ?g/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001035', 'Waste Treatment - NH3 - BAT34-I', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above; Collect mercury emissions at source, send them to abatement and carry out adequate monitoring (see description); Reducing ammonia (NH3) emissions to air. The BAT-AEL emission level is 0,3-20 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001036', 'Waste Treatment - Ni - BAT20-XL', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing nickel to water. The BAT-AEL emission level is 0,05-0,5 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001037', 'Waste Treatment - Ni - BAT20-XLIX', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing nickel to water. The BAT-AEL emission level is 0,05-1 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001038', 'Waste Treatment - Ni - BAT20-XX', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing nickel to water. The BAT-AEL emission level is 0,05-0,5 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001039', 'Waste Treatment - Ni - BAT20-XXIX', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing nickel to water. The BAT-AEL emission level is 0,05-1 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001040', 'Waste Treatment - Odour - BAT34-II', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above; Techniques (a)-(e) (see table); Reducing odour concentration emissions to air. The BAT-AEL emission level is 200-1 000 ouE/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001041', 'Waste Treatment - Pb - BAT20-XIX', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing lead to water. The BAT-AEL emission level is 0,05-0,1 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001042', 'Waste Treatment - Pb - BAT20-XLVIII', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing lead to water. The BAT-AEL emission level is 0,05-0,3 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001043', 'Waste Treatment - Pb - BAT20-XXVIII', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing lead to water. The BAT-AEL emission level is 0,05-0,3 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001044', 'Waste Treatment - Pb - BAT20-XXXIX', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing lead to water. The BAT-AEL emission level is 0,05-0,1 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001045', 'Waste Treatment - Phenols - BAT20-XI', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing phenol index to water. The BAT-AEL emission level is 0,05-0,2 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001046', 'Waste Treatment - Phenols - BAT20-XII', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing phenol index to water. The BAT-AEL emission level is 0,05-0,3 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001047', 'Waste Treatment - TN - BAT20-VII', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing total nitrogen to water. The BAT-AEL emission level is 1-25 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001048', 'Waste Treatment - TN - BAT20-VIII', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing total nitrogen to water. The BAT-AEL emission level is 10-60 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001049', 'Waste Treatment - TOC - BAT20-I', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing total organic carbon to water. The BAT-AEL emission level is 10-60 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001050', 'Waste Treatment - TOC - BAT20-II', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing total organic carbon to water. The BAT-AEL emission level is 10-100 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001051', 'Waste Treatment - TP - BAT20-IX', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing total phosphorus to water. The BAT-AEL emission level is 0,3-2 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001052', 'Waste Treatment - TP - BAT20-X', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing total phosphorus to water. The BAT-AEL emission level is 1-3 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001053', 'Waste Treatment - TSS - BAT20-V', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing total suspended solids to water. The BAT-AEL emission level is 5-60 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001054', 'Waste Treatment - TVOC - BAT29-I', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above; Techniques (a)-(d) (see table incl. footnote); Reducing TVOC emissions to air. The BAT-AEL emission level is 3-15 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001055', 'Waste Treatment - TVOC - BAT31', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above; Apply BAT 14d, BAT 14h and use technique (a) and one or both of the techniques (b) and (c); Reducing TVOC emissions to air. The BAT-AEL emission level is 10-30 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001056', 'Waste Treatment - TVOC - BAT34-IV', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above; Techniques (a)-(e) (see table); Reducing TVOC emissions to air. The BAT-AEL emission level is 5-40 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001057', 'Waste Treatment - TVOC - BAT45', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above; Reducing TVOC emissions to air. The BAT-AEL emission level is 5-30 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001058', 'Waste Treatment - TVOC - BAT47', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above; Reducing TVOC emissions to air. The BAT-AEL emission level is 5-30 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001059', 'Waste Treatment - TVOC - BAT53-II', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above; Reducing TVOC emissions to air. The BAT-AEL emission level is 3-20 mg/Nm3 .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001060', 'Waste Treatment - Zn - BAT20-LI', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing zinc to water. The BAT-AEL emission level is 0,1-2 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001061', 'Waste Treatment - Zn - BAT20-XLII', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing zinc to water. The BAT-AEL emission level is 0,1-1 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001062', 'Waste Treatment - Zn - BAT20-XXII', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing zinc to water. The BAT-AEL emission level is 0,1-1 mg/l .', '1', 'geokon')
   insert into dma_afgoerelseBATAEL (Id, Navn, Beskrivelse, Aktiv, created_by) values ('BATAEL0001063', 'Waste Treatment - Zn - BAT20-XXXI', '5.? Waste management; 6. Other activities: 5.1. Disposal or recovery of hazardous waste with a capacity exceeding 10 tonnes per day involving one or more of the following activities: (a)-(j) (see scope); 5.3. (a) Disposal of non-hazardous waste with a capacity exceeding 50 tonnes per day involving one or more of the following activities, and excluding activities covered by Council Directive 91/271/EEC (1): (i)-(v) (see scope). (b) Recovery, or a mix of recovery and disposal, of non-hazardous waste with a capacity exceeding 75 tonnes per day involving one or more of the following activities, and excluding activities covered by Directive 91/271/EEC: (i)-(iv) (see scope). 5.5. Temporary storage of hazardous waste not covered under point 5.4 of Annex I to Directive 2010/75/EU pending any of the activities listed in points 5.1, 5.2, 5.4 and 5.6 of Annex I to Directive 2010/75/EU with a total capacity exceeding 50 tonnes, excluding temporary storage, pending collection, on the site where the waste is generated. 6.11. Independently operated treatment of waste water not covered by Directive 91/271/EEC and discharged by an installation undertaking activities covered under points 5.1, 5.3 or 5.5 as listed above. Reducing zinc to water. The BAT-AEL emission level is 0,1-2 mg/l .', '1', 'geokon')
end;

--******************************************************************************
-- Ny kolonne: ind_decision.condition_report                          18-03-2021
--******************************************************************************

if (select col_length('ind_decision','condition_report')) is null
   alter table ind_decision add condition_report varchar(50) null;

drop_foreign_key on ind_decision dma_afgoerelseBasistilstandsrapport;
alter table ind_decision
  add constraint fk_ind_decision_dma_afgoerelseBasistilstandsrapport foreign key (condition_report)
  references dma_afgoerelseBasistilstandsrapport (Id);

--******************************************************************************
-- Nye tabeller til reg. af FravigelseIfmLempeligereKravEndBAT        18-03-2021
--******************************************************************************

create table dbo.ind_decision_bat_lenient (
    decis_seq_no                  numeric(9,0)    not null,
    start_date                    datetime        not null,
    end_date                      datetime        null,
    created                       datetime        null default current_timestamp,
    created_by                    varchar(6)      null default current_user,
    changed                       datetime        null,
    changed_by                    varchar(6)      null,
    constraint pk_ind_decision_bat_lenient primary key (decis_seq_no)
);
grant select on ind_decision_bat_lenient to public;
grant select,insert,update,delete on ind_decision_bat_lenient to INSP_USER;

drop_foreign_key on ind_decision_bat_lenient ind_decision;
alter table ind_decision_bat_lenient
  add constraint fk_ind_decision_bat_lenient_ind_decision foreign key (decis_seq_no)
  references ind_decision (decis_seq_no)
  on delete cascade;

create table dbo.ind_decision_bat_lenient_batael (
    decis_seq_no                  numeric(9,0)    not null,
    batael                        varchar(50)     not null,
    created                       datetime        null default current_timestamp,
    created_by                    varchar(6)      null default current_user,
    changed                       datetime        null,
    changed_by                    varchar(6)      null,
    constraint pk_ind_decision_bat_lenient_batael primary key (decis_seq_no, batael)
);
grant select on ind_decision_bat_lenient_batael to public;
grant select,insert,update,delete on ind_decision_bat_lenient_batael to INSP_USER;

drop_foreign_key on ind_decision_bat_lenient_batael ind_decision_bat_lenient;
alter table ind_decision_bat_lenient_batael
  add constraint fk_ind_decision_bat_lenient_batael_ind_decision_bat_lenient foreign key (decis_seq_no)
  references ind_decision_bat_lenient (decis_seq_no)
  on delete cascade;

drop_foreign_key on ind_decision_bat_lenient_batael dma_afgoerelseBATAEL;
alter table ind_decision_bat_lenient_batael
  add constraint fk_ind_decision_bat_lenient_batael_dma_afgoerelseBATAEL foreign key (batael)
  references dma_afgoerelseBATAEL (Id);

--******************************************************************************
-- Nye tabeller til reg. af FravigelseIfmStrengereKravEndBAT          18-03-2021
--******************************************************************************

create table dbo.ind_decision_bat_strict (
    decis_seq_no                  numeric(9,0)    not null,
    start_date                    datetime        not null,
    created                       datetime        null default current_timestamp,
    created_by                    varchar(6)      null default current_user,
    changed                       datetime        null,
    changed_by                    varchar(6)      null,
    constraint pk_ind_decision_bat_strict primary key (decis_seq_no)
);
grant select on ind_decision_bat_strict to public;
grant select,insert,update,delete on ind_decision_bat_strict to INSP_USER;

drop_foreign_key on ind_decision_bat_strict ind_decision;
alter table ind_decision_bat_strict
  add constraint fk_ind_decision_bat_strict_ind_decision foreign key (decis_seq_no)
  references ind_decision (decis_seq_no)
  on delete cascade;

create table dbo.ind_decision_bat_strict_batael (
    decis_seq_no                  numeric(9,0)    not null,
    batael                        varchar(50)     not null,
    artikel14_4                   varchar(1)      not null default '0',
    artikel18                     varchar(1)      not null default '0',
    created                       datetime        null default current_timestamp,
    created_by                    varchar(6)      null default current_user,
    changed                       datetime        null,
    changed_by                    varchar(6)      null,
    constraint pk_ind_decision_bat_strict_batael primary key (decis_seq_no, batael)
);
grant select on ind_decision_bat_strict_batael to public;
grant select,insert,update,delete on ind_decision_bat_strict_batael to INSP_USER;

drop_foreign_key on ind_decision_bat_strict_batael ind_decision_bat_strict;
alter table ind_decision_bat_strict_batael
  add constraint fk_ind_decision_bat_strict_batael_ind_decision_bat_strict foreign key (decis_seq_no)
  references ind_decision_bat_strict (decis_seq_no)
  on delete cascade;

drop_foreign_key on ind_decision_bat_strict_batael dma_afgoerelseBATAEL;
alter table ind_decision_bat_strict_batael
  add constraint fk_ind_decision_bat_strict_batael_dma_afgoerelseBATAEL foreign key (batael)
  references dma_afgoerelseBATAEL (Id);

--******************************************************************************
-- Ny tabel til reg. af MidlertidigFravigelse                         18-03-2021
--******************************************************************************

create table dbo.ind_decision_bat_temp (
    decis_seq_no                  numeric(9,0)    not null,
    start_date                    datetime        not null,
    end_date                      datetime        null,
    created                       datetime        null default current_timestamp,
    created_by                    varchar(6)      null default current_user,
    changed                       datetime        null,
    changed_by                    varchar(6)      null,
    constraint pk_ind_decision_bat_temp primary key (decis_seq_no)
);
grant select on ind_decision_bat_temp to public;
grant select,insert,update,delete on ind_decision_bat_temp to INSP_USER;

drop_foreign_key on ind_decision_bat_temp ind_decision;
alter table ind_decision_bat_temp
  add constraint fk_ind_decision_bat_temp_ind_decision foreign key (decis_seq_no)
  references ind_decision (decis_seq_no)
  on delete cascade;

--******************************************************************************